import React from 'react';
import { ISurface } from '../Surface/Surface';
import { IColor, IElement, IElementReference, IElevation, IPropsAny, ITonal } from '../types';
declare type TPadding = 'start' | 'end' | 'both' | 'none';
export interface IAccordion extends ISurface {
    tonal?: ITonal;
    color?: IColor;
    elevation?: IElevation;
    primary?: IElement;
    secondary?: IElement;
    start?: any;
    end?: any;
    openDefault?: boolean;
    open?: boolean;
    onChange?: (open: boolean) => any;
    noBackground?: boolean;
    noExpandButton?: boolean;
    expandedMarginVertical?: TPadding;
    expandedHeaderPaddingVertical?: TPadding;
    headerPaddingVertical?: TPadding;
    headerPaddingHorizontal?: TPadding;
    mainPaddingVertical?: TPadding;
    mainPaddingHorizontal?: TPadding;
    noTransition?: boolean;
    disabled?: boolean;
    ExpandProps?: IPropsAny;
    TransitionComponentProps?: IPropsAny;
    WrapperHeaderProps?: IPropsAny;
    HeaderProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    StartProps?: IPropsAny;
    EndProps?: IPropsAny;
    ExpandIcon?: IElementReference;
    TransitionComponent?: IElementReference;
}
declare const Accordion: React.FC<IAccordion>;
export default Accordion;
