import React from 'react';
import { IChildren, IHTMLElement, IStyle } from '../types';
export declare type TAppendPadding = Array<number>;
export interface IAppendValue {
    x?: number;
    y?: number;
    switch?: boolean;
    init?: boolean;
}
export interface IAppend {
    open?: boolean;
    portal?: boolean;
    accelerated?: boolean;
    anchor?: DOMRect;
    anchorElement?: IHTMLElement;
    offset?: TAppendPadding;
    padding?: TAppendPadding;
    paddingUnfollow?: TAppendPadding;
    inset?: boolean;
    position?: 'top' | 'left' | 'bottom' | 'right';
    alignment?: 'start' | 'center' | 'end';
    switch?: boolean;
    overflow?: boolean;
    unfollow?: boolean;
    style?: IStyle;
    update?: any;
    element?: any;
    parent?: IHTMLElement;
    additional?: (rects: {
        root: DOMRect;
        element: DOMRect;
    }, rectsOffset: {
        root: DOMRect;
        element: DOMRect;
    }) => any;
    children?: IChildren;
    [property: string]: any;
}
declare const Append: React.FC<IAppend>;
export default Append;
