import React from 'react';
import { ILine } from '../Line/Line';
import { IColor, IElementReference, IPropsAny, ISize, ITonal } from '../types';
export interface IAudioPlayer extends ILine {
    name?: string;
    src?: string;
    mime?: string;
    meta?: any;
    versions?: any;
    duration?: number;
    tonal?: ITonal;
    color?: IColor;
    size?: ISize;
    start?: any;
    end?: any;
    startControls?: any;
    endControls?: any;
    startButtons?: any;
    endButtons?: any;
    startEnd?: any;
    endEnd?: any;
    forward?: boolean;
    backward?: boolean;
    settings?: boolean;
    quality?: boolean;
    playbackSpeed?: boolean;
    startMediaSessionOnPlay?: boolean;
    disabled?: boolean;
    IconPlay?: IElementReference;
    IconPause?: IElementReference;
    IconForward?: IElementReference;
    IconBackward?: IElementReference;
    IconVolume?: IElementReference;
    IconVolumeMuted?: IElementReference;
    IconBack?: IElementReference;
    IconSettings?: IElementReference;
    IconQuality?: IElementReference;
    IconPlaybackSpeed?: IElementReference;
    PlayButtonProps?: IPropsAny;
    ForwardButtonProps?: IPropsAny;
    BackwardButtonProps?: IPropsAny;
    VolumeButtonProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    TypeProps?: IPropsAny;
    TimelineProps?: IPropsAny;
    VolumeProps?: IPropsAny;
    SliderProps?: IPropsAny;
    SettingsButtonProps?: IPropsAny;
    SettingsMenuProps?: IPropsAny;
    QualityButtonProps?: IPropsAny;
}
declare const AudioPlayer: React.FC<IAudioPlayer>;
export default AudioPlayer;
