import React from 'react';
import { ILine } from '../Line/Line';
import { IElementReference, IPropsAny, ISize } from '../types';
export interface IAudioRecorder extends ILine {
    size?: ISize;
    pause?: boolean;
    renderMain?: (props: {
        onStart: () => any;
        supported: boolean;
    }) => any;
    renderTime?: (value: string) => any;
    loading?: any;
    disabled?: any;
    Icon?: IElementReference;
    IconConfirm?: IElementReference;
    IconStart?: IElementReference;
    IconPause?: IElementReference;
    IconStop?: IElementReference;
    onConfirm?: (value: Blob) => any;
    onData?: (value: Blob) => any;
    onStart?: (event: React.MouseEvent<any>) => any;
    onPause?: (event: React.MouseEvent<any>) => any;
    onResume?: (event: React.MouseEvent<any>) => any;
    onStop?: (event: React.MouseEvent<any>) => any;
    onError?: (error: Error) => any;
    TooltipProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    IconProps?: IPropsAny;
}
declare const AudioRecorder: React.FC<IAudioRecorder>;
export default AudioRecorder;
