import React from 'react';
import { ITextField } from '../TextField/TextField';
import { IElement, IElementReference, IPropsAny } from '../types';
export declare type TAutoCompleteValue = string | Array<string>;
export declare type TAutoCompleteOption = {
    label?: string;
    version?: 'text' | 'subheader';
    noOptions?: boolean;
};
export interface IAutoComplete extends ITextField {
    value?: any;
    valueDefault?: any;
    onChange?: (value: any) => any;
    valueInput?: string;
    valueInputDefault?: string;
    onChangeInput?: (value: string) => any;
    multiple?: boolean;
    autoWidth?: boolean;
    readOnly?: boolean;
    getLabel?: (item: any) => any;
    equal?: (value1: any, value2: any) => boolean;
    equalInput?: (input: string, value: any) => boolean;
    renderValues?: (value: TAutoCompleteValue, onUnselect: (value: string) => any) => IElement;
    renderChip?: (item: any, value: any, props: IPropsAny) => IElement;
    renderOption?: (item: TAutoCompleteOption, index: number, props: IPropsAny) => IElement;
    chip?: boolean;
    filter?: (value: string, options: Array<TAutoCompleteOption>) => Array<TAutoCompleteOption>;
    options?: Array<TAutoCompleteOption>;
    clear?: boolean;
    loading?: boolean;
    autoSelectOnBlur?: boolean;
    blurOnSelect?: boolean;
    noOptions?: boolean;
    noOptionsObject?: any;
    startOptionsObject?: any;
    endOptionsObject?: any;
    noOptionsElement?: any;
    startOptionsElement?: any;
    endOptionsElement?: any;
    openOnFocus?: boolean;
    closeOnSelect?: boolean;
    clearInputOnSelect?: boolean;
    clearOnEscape?: boolean;
    groupBy?: (value: TAutoCompleteOption) => string;
    limit?: number;
    filterOutSelectedOptions?: boolean;
    selectOnFocus?: boolean;
    clearOnBlur?: boolean;
    disabled?: boolean;
    IconClear?: IElementReference;
    WrapperProps?: IPropsAny;
    ChipProps?: IPropsAny;
    ListProps?: IPropsAny;
    MenuProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    InputProps?: IPropsAny;
}
declare const AutoComplete: React.FC<IAutoComplete>;
export default AutoComplete;
