"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const style_react_1 = require("@amaui/style-react");
const Line_1 = __importDefault(require("../Line"));
const Avatar_1 = __importDefault(require("../Avatar"));
const utils_1 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    disabled: {
        pointerEvents: 'none',
        opacity: theme.palette.visual_contrast.default.opacity.disabled,
        filter: 'grayscale(1)'
    },
    item: {
        outline: `2px solid ${theme.palette.background.default.primary}`,
        '&:not(:last-child)': {
            marginInlineStart: `-0.24em`
        }
    }
}), { name: 'amaui-AvatarGroup' });
const AvatarGroup = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiAvatarGroup) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Avatar = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Avatar) || Avatar_1.default; }, [theme]);
    const { tonal = true, color = 'primary', size = 'regular', total, max, disabled, AdditionalAvatar, AdditionalAvatarProps = {}, Component = 'div', className, style, children: children_ } = props, other = __rest(props, ["tonal", "color", "size", "total", "max", "disabled", "AdditionalAvatar", "AdditionalAvatarProps", "Component", "className", "style", "children"]);
    const { classes } = useStyle();
    const styles = {
        root: {},
        item: {}
    };
    const children = react_1.default.Children.toArray(children_).slice(0, max || children_.length).reverse();
    if (size !== undefined) {
        if (size === 'small')
            styles.item.outlineWidth = 2;
        else if (size === 'regular')
            styles.item.outlineWidth = 3;
        else if (size === 'large')
            styles.item.outlineWidth = 4;
        else
            styles.item.outlineWidth = Math.ceil(size / 20);
    }
    other.style = styles.item;
    if ((total !== undefined && total - children_.length >= 1) || max < children_.length) {
        let value;
        if ((total !== undefined && total - children_.length >= 1))
            value = `+${total - children_.length}`;
        else
            value = `+${Math.abs(children_.length - max)}`;
        if (!AdditionalAvatarProps.TypeProps)
            AdditionalAvatarProps.TypeProps = {};
        AdditionalAvatarProps.TypeProps.size = '0.44em';
        children.unshift(AdditionalAvatar ||
            (0, jsx_runtime_1.jsx)(Avatar, Object.assign({ tonal: tonal, color: 'neutral' }, other, AdditionalAvatarProps, { noIconRootFontSize: true }, { children: value })));
    }
    if ((AdditionalAvatarProps === null || AdditionalAvatarProps === void 0 ? void 0 : AdditionalAvatarProps.size) !== undefined)
        styles.root.fontSize = AdditionalAvatarProps.size;
    return ((0, jsx_runtime_1.jsx)(Line, Object.assign({ ref: ref, gap: 0, direction: 'row-reverse', Component: Component, className: (0, style_react_1.classNames)([
            (0, utils_1.staticClassName)('AvatarGroup', theme) && [
                'amaui-AvatarGroup-root'
            ],
            className,
            classes.root,
            disabled && classes.disabled
        ]), style: Object.assign(Object.assign({}, style), styles.root) }, { children: children.map((item, index) => {
            var _a;
            return react_1.default.cloneElement(item, Object.assign(Object.assign({ key: index, className: (0, style_react_1.classNames)([
                    (_a = item === null || item === void 0 ? void 0 : item.props) === null || _a === void 0 ? void 0 : _a.className,
                    classes.item
                ]), tonal: item.props.tonal || tonal, color: item.props.color || color, size: item.props.size || size }, other), item.props));
        }) })));
});
AvatarGroup.displayName = 'amaui-AvatarGroup';
exports.default = AvatarGroup;
