"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const style_react_1 = require("@amaui/style-react");
const Line_1 = __importDefault(require("../Line"));
const Surface_1 = __importDefault(require("../Surface"));
const Transition_1 = __importDefault(require("../Transition"));
const utils_1 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        zIndex: theme.z_index.app_bar,
        width: '100%',
        height: '80px',
        paddingBlock: theme.methods.space.value(1.5, 'px'),
        paddingInline: `${theme.methods.space.value(0.5, 'px')} ${theme.methods.space.value(2, 'px')}`
    },
    size_small: { height: '72px' },
    size_regular: { height: '80px' },
    size_large: { height: '88px' },
    fixed: {
        position: 'fixed',
        insetInline: '0px',
        bottom: '0px'
    },
    item: {
        opacity: '0',
        transform: 'translateY(100%)',
        transition: theme === null || theme === void 0 ? void 0 : theme.methods.transitions.make(['opacity', 'transform'], { duration: 'rg', timing_function: 'standard' }),
        '&.enter': {
            opacity: '0',
            transform: 'translateY(100%)'
        },
        '&.entering': {
            opacity: '1',
            transform: 'translateY(0%)'
        },
        '&.entered': {
            opacity: '1',
            transform: 'translateY(0%)'
        },
        '&.exit': {
            opacity: '1',
            transform: 'translateY(0%)'
        },
        '&.exiting': {
            opacity: '0',
            transform: 'translateY(0%)'
        },
        '&.exited': {
            opacity: '0',
            transform: 'translateY(0%)'
        }
    },
    mainItem: {
        opacity: '0',
        transform: 'scale(0.75)',
        transition: theme === null || theme === void 0 ? void 0 : theme.methods.transitions.make(['opacity', 'transform'], { duration: 'rg', timing_function: 'standard' }),
        '&.enter': {
            opacity: '0',
            transform: 'scale(0.75)'
        },
        '&.entering': {
            opacity: '1',
            transform: 'scale(1)'
        },
        '&.entered': {
            opacity: '1',
            transform: 'scale(1)'
        },
        '&.exit': {
            opacity: '1',
            transform: 'scale(1)'
        },
        '&.exiting': {
            opacity: '0',
            transform: 'scale(1)'
        },
        '&.exited': {
            opacity: '0',
            transform: 'scale(1)'
        }
    }
}), { name: 'amaui-BottomAppBar' });
const BottomAppBar = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiBottomAppBar) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const Transition = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Transition) || Transition_1.default; }, [theme]);
    const { tonal = true, color = 'primary', size = 'regular', main: main_, fixed, noTransition, className, children: children_ } = props, other = __rest(props, ["tonal", "color", "size", "main", "fixed", "noTransition", "className", "children"]);
    const { classes } = useStyle();
    const makeChildren = (values) => {
        return react_1.default.Children
            .toArray(values)
            .map((item, index) => ((0, jsx_runtime_1.jsx)(Transition, Object.assign({ onRemoved: () => {
                if (index === 0)
                    reAddChildren();
            }, removeOnExited: true }, { children: (status) => (react_1.default.cloneElement(item, {
                className: (0, style_react_1.classNames)([
                    classes.item,
                    status
                ]),
                elevation: item.props.elevation !== undefined ? item.props.elevation : false,
                version: item.props.version !== undefined ? item.props.version : 'filled',
                color: item.props.color !== undefined ? item.props.color : color,
                tonal: item.props.tonal !== undefined ? item.props.tonal : tonal,
                style: Object.assign(Object.assign({}, item.props.style), (status.includes('enter') && {
                    transitionDelay: `${index * 70}ms`
                }))
            })) }), index)));
    };
    const makeMain = (values) => {
        return react_1.default.Children
            .toArray(values)
            .map((item, index) => ((0, jsx_runtime_1.jsx)(Transition, Object.assign({ onRemoved: () => {
                if (index === 0)
                    reAddMain();
            }, removeOnExited: true }, { children: (status) => {
                var _a;
                return (react_1.default.cloneElement(item, {
                    className: (0, style_react_1.classNames)([
                        classes.mainItem,
                        status
                    ]),
                    color: item.props.color !== undefined ? item.props.color : color,
                    tonal: item.props.tonal !== undefined ? item.props.tonal : tonal && ['amaui-Fab'].includes((_a = item.type) === null || _a === void 0 ? void 0 : _a.displayName) ? 'secondary' : tonal
                }));
            } }), index)));
    };
    const [init, setInit] = react_1.default.useState(false);
    const [children, setChildren] = react_1.default.useState(() => makeChildren(children_));
    const [main, setMain] = react_1.default.useState(() => makeMain(main_));
    const [inProp, setInProp] = react_1.default.useState(true);
    const refs = {
        preChildren: react_1.default.useRef(),
        preMain: react_1.default.useRef()
    };
    react_1.default.useEffect(() => {
        setInit(true);
    }, []);
    const reAddChildren = () => {
        setChildren(makeChildren(refs.preChildren.current));
        setInProp(true);
        refs.preChildren.current = undefined;
    };
    const reAddMain = () => {
        setMain(makeMain(refs.preMain.current));
        setInProp(true);
        refs.preMain.current = undefined;
    };
    react_1.default.useEffect(() => {
        if (init) {
            if (!noTransition) {
                refs.preChildren.current = children_;
                setInProp(false);
            }
            else
                setChildren(makeChildren(children_));
        }
    }, [react_1.default.Children.toArray(children_).map((item) => item.key).join('')]);
    react_1.default.useEffect(() => {
        if (init) {
            if (!noTransition) {
                refs.preMain.current = main_;
                setInProp(false);
            }
            else
                setMain(makeMain(main_));
        }
    }, [react_1.default.Children.toArray(main_).map((item) => item.key).join('')]);
    return ((0, jsx_runtime_1.jsxs)(Surface, Object.assign({ ref: ref, color: color, tonal: tonal, gap: 4, direction: 'row', align: 'center', justify: 'space-between', Component: Line, className: (0, style_react_1.classNames)([
            (0, utils_1.staticClassName)('BottomAppBar', theme) && [
                'amaui-BottomAppBar-root'
            ],
            className,
            classes.root,
            classes[`size_${size}`],
            fixed && classes.fixed
        ]) }, other, { children: [!!children.length && ((0, jsx_runtime_1.jsx)(Line, Object.assign({ direction: 'row', align: 'center', justify: 'flex-start', gap: 0 }, { children: children.map((item) => (react_1.default.cloneElement(item, {
                    in: inProp
                }))) }))), !!main.length && ((0, jsx_runtime_1.jsx)(Line, Object.assign({ direction: 'row', align: 'center', justify: 'flex-end' }, { children: main.map((item) => (react_1.default.cloneElement(item, {
                    in: inProp
                }))) })))] })));
});
BottomAppBar.displayName = 'amaui-BottomAppBar';
exports.default = BottomAppBar;
