import React from 'react';
import { ISurface } from '../Surface/Surface';
import { IElement, IElementReference, IPropsAny, ISizeAny } from '../types';
export interface IButton extends Omit<ISurface, 'elevation'> {
    size?: ISizeAny;
    fullWidth?: boolean;
    fontSize?: string | number;
    selected?: boolean;
    iconSelected?: IElement;
    start?: IElement;
    startSelected?: IElement;
    end?: IElement;
    endSelected?: IElement;
    elevation?: boolean;
    backgroundOpacity?: number;
    align?: 'start' | 'center' | 'end';
    loading?: boolean;
    loadingLabel?: IElement;
    loadingIcon?: IElement;
    loadingIconPosition?: 'start' | 'center' | 'end';
    fab?: boolean;
    chip?: boolean;
    icon?: boolean;
    focus?: boolean;
    value?: any;
    noIconRootFontSize?: boolean;
    firstLevelChildren?: IElement;
    noFontSize?: boolean;
    disabled?: boolean;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    IconWrapperComponent?: IElementReference;
    InteractionProps?: IPropsAny;
    IconWrapperProps?: IPropsAny;
}
declare const Button: React.FC<IButton>;
export default Button;
