import React from 'react';
import { AmauiDate } from '@amaui/date';
import { ILine } from '../Line/Line';
import { IColor, IPropsAny, ISize, ITonal } from '../types';
export declare type TCalendarMonthValue = AmauiDate | [AmauiDate, AmauiDate];
export declare type TCalendarMonthCalendar = AmauiDate;
export interface ICalendarMonthValuesValue {
    day: string;
    month: string;
    year: string;
    inputModal: string;
    input: string;
    selected: AmauiDate;
    date: AmauiDate;
    previous: AmauiDate;
    move: 'previous' | 'next';
}
export declare type TCalendarMonthValues = [ICalendarMonthValuesValue, ICalendarMonthValuesValue];
export interface ICalenarDays extends ILine {
    tonal?: ITonal;
    color?: IColor;
    size?: ISize;
    value?: TCalendarMonthValue;
    valueDefault?: TCalendarMonthValue;
    onChange?: (value: TCalendarMonthValue) => any;
    calendar?: TCalendarMonthCalendar;
    calendarDefault?: TCalendarMonthCalendar;
    onChangeCalendar?: (value: TCalendarMonthCalendar) => any;
    now?: boolean;
    outside?: boolean;
    range?: boolean;
    weekStartDay?: 'Monday' | 'Sunday';
    noTransition?: boolean;
    offset?: number;
    min?: AmauiDate;
    max?: AmauiDate;
    validate?: (value: AmauiDate) => boolean;
    labels?: boolean;
    dayNamesFull?: boolean;
    valid?: (value: AmauiDate, version: 'day' | 'month' | 'year') => boolean;
    renderDay?: (value: AmauiDate, props: any, day: any, outside: boolean) => React.ReactNode;
    renderDayName?: (order: number) => any;
    PaginationItemProps?: IPropsAny;
    TransitionProps?: IPropsAny;
    TransitionsProps?: IPropsAny;
}
declare const CalendarMonth: React.FC<ICalenarDays>;
export default CalendarMonth;
