"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Button_1 = __importDefault(require("../Button"));
const Icon_1 = __importDefault(require("../Icon"));
const Buttons_1 = require("../Buttons/Buttons");
const utils_2 = require("../utils");
const IconMaterialCloseSharp = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'CloseSharp', short_name: 'Close' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M6.4 19 5 17.6 10.6 12 5 6.4 6.4 5 12 10.6 17.6 5 19 6.4 13.4 12 19 17.6 17.6 19 12 13.4Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        '&.amaui-Button-root': {
            maxWidth: '100%'
        },
        '& .amaui-Icon-root': {
            pointerEvents: 'unset !important'
        }
    },
}), { name: 'amaui-Chip' });
const Chip = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiChip) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Button = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Button) || Button_1.default; }, [theme]);
    const { tonal = false, color = props.version === 'filled' ? 'inverted' : 'default', version = 'outlined', input, filter, selected: selected_, start, focus, noCheckIcon, onClick, onRemove, onSelected, onUnselected, className, children: children_ } = props, other = __rest(props, ["tonal", "color", "version", "input", "filter", "selected", "start", "focus", "noCheckIcon", "onClick", "onRemove", "onSelected", "onUnselected", "className", "children"]);
    const { classes } = useStyle();
    const [preSelected, setPreSelected] = react_1.default.useState(false);
    const [selected, setSelected] = react_1.default.useState(selected_);
    const children = children_;
    react_1.default.useEffect(() => {
        if (selected !== selected_)
            setSelected(selected_);
    }, [selected_]);
    const OtherProps = {};
    if (input) {
        OtherProps.end = (0, jsx_runtime_1.jsx)(IconMaterialCloseSharp, { onClick: (event) => {
                if ((0, utils_1.is)('function', onRemove))
                    onRemove(event);
            } });
    }
    const onSelect = () => {
        if (filter) {
            if (start) {
                if (selected) {
                    setSelected(false);
                    if ((0, utils_1.is)('function', onUnselected))
                        onUnselected();
                }
                else {
                    setSelected(true);
                    if ((0, utils_1.is)('function', onSelected))
                        onSelected();
                }
            }
            else {
                // Unselect
                if (selected) {
                    setPreSelected(false);
                    if ((0, utils_1.is)('function', onUnselected))
                        onUnselected();
                }
                else {
                    setPreSelected(true);
                    setSelected(true);
                    if ((0, utils_1.is)('function', onSelected))
                        onSelected();
                }
            }
        }
    };
    const updateSelected = () => {
        if (filter) {
            setSelected(false);
        }
    };
    return ((0, jsx_runtime_1.jsx)(Button, Object.assign({ ref: ref, tonal: tonal, version: version, color: color || (tonal ? 'neutral' : 'default'), onClick: (event) => {
            onSelect();
            // Invoke items on click method
            if ((0, utils_1.is)('function', onClick))
                onClick(event);
        }, start: start }, (!noCheckIcon && start && selected ? {
        start: ((0, jsx_runtime_1.jsx)(Buttons_1.IconDoneAnimated, { simple: true, in: true, add: true }))
    } : {}), (!noCheckIcon && !start && (selected || preSelected) ? {
        start: ((0, jsx_runtime_1.jsx)(Buttons_1.IconDoneAnimated, { in: (start ? selected : preSelected), onExited: () => updateSelected(), add: true }))
    } : {}), { focus: focus, selected: selected, chip: true, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Chip', theme) && [
                'amaui-Chip-root',
                selected && `amaui-Chip-selected`
            ],
            className,
            classes.root
        ]) }, other, OtherProps, { children: children })));
});
Chip.displayName = 'amaui-Chip';
exports.default = Chip;
