"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const utils_2 = require("../utils");
const resolve = (value) => value.replace(/^on/, '').toLowerCase();
const ClickListener = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiClickListener) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const { mouseEvent = 'onClick', touchEvent = 'onTouchEnd', contextMenu = true, include = [], includeParentQueries = [], includeQueries = [], ignoreNonExisting = true, onClickInside, onClickOutside, children } = props, other = __rest(props, ["mouseEvent", "touchEvent", "contextMenu", "include", "includeParentQueries", "includeQueries", "ignoreNonExisting", "onClickInside", "onClickOutside", "children"]);
    const refs = {
        root: react_1.default.useRef(),
        include: react_1.default.useRef(),
        includeQueries: react_1.default.useRef(),
        includeParentQueries: react_1.default.useRef(),
        ignoreNonExisting: react_1.default.useRef()
    };
    refs.include.current = include;
    refs.includeQueries.current = includeQueries;
    refs.includeParentQueries.current = includeParentQueries;
    refs.ignoreNonExisting.current = ignoreNonExisting;
    react_1.default.useEffect(() => {
        var _a;
        const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        const onMethod = (event) => {
            if (refs.root.current) {
                const elementParents = (0, utils_1.element)(event.target).parents();
                const exists = (0, utils_1.Try)(() => rootDocument.body.contains(event.target));
                if ((refs.root.current.contains(event.target) ||
                    refs.include.current.map(item => (item === null || item === void 0 ? void 0 : item.current) || item).filter(Boolean).some(item => { var _a; return (_a = item.contains) === null || _a === void 0 ? void 0 : _a.call(item, event.target); }) ||
                    refs.includeParentQueries.current.some((query) => elementParents.some(item => (0, utils_2.matches)(item)(query))) ||
                    refs.includeQueries.current.some((query) => (0, utils_2.matches)(event.target)(query)) ||
                    (!exists && refs.ignoreNonExisting.current))) {
                    if ((0, utils_1.is)('function', onClickInside))
                        onClickInside();
                }
                else {
                    if ((0, utils_1.is)('function', onClickOutside))
                        onClickOutside();
                }
            }
        };
        if (mouseEvent)
            rootDocument.addEventListener(resolve(mouseEvent), onMethod);
        if (touchEvent)
            rootDocument.addEventListener(resolve(touchEvent), onMethod, { passive: true });
        if (contextMenu)
            rootDocument.addEventListener('contextmenu', onMethod);
        return () => {
            if (mouseEvent)
                rootDocument.removeEventListener(resolve(mouseEvent), onMethod);
            if (touchEvent)
                rootDocument.removeEventListener(resolve(mouseEvent), onMethod);
            if (contextMenu)
                rootDocument.removeEventListener('contextmenu', onMethod);
        };
    }, [mouseEvent, touchEvent, contextMenu]);
    return ((0, jsx_runtime_1.jsx)(react_1.default.Fragment, { children: children && (react_1.default.cloneElement(children, Object.assign(Object.assign({ ref: (item) => {
                if (ref) {
                    if ((0, utils_1.is)('function', ref))
                        ref(item);
                    else
                        ref.current = item;
                }
                if (children.ref) {
                    if ((0, utils_1.is)('function', children.ref))
                        children.ref(item);
                    else
                        children.ref.current = item;
                }
                refs.root.current = item;
            } }, other), { className: (0, style_react_1.classNames)([
                other.className,
                children.props.className,
            ]) }))) }));
});
ClickListener.displayName = 'amaui-ClickListener';
exports.default = ClickListener;
