import React from 'react';
import { ILine } from '../Line/Line';
import { IValueBreakpoints } from '../types';
export interface IContainer extends ILine {
    alignment?: 'start' | 'center' | 'end' | Partial<Record<IValueBreakpoints, 'start' | 'center' | 'end'>>;
    paddingVertical?: 'both' | 'start' | 'end' | 'none' | Partial<Record<IValueBreakpoints, 'both' | 'start' | 'end' | 'none'>>;
    paddingHorizontal?: 'both' | 'start' | 'end' | 'none' | Partial<Record<IValueBreakpoints, 'both' | 'start' | 'end' | 'none'>>;
    fullWidth?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    maxWidth?: 'xxs' | 'xs' | 'sm' | 'rg' | 'lg' | 'xl' | 'unset' | Partial<Record<IValueBreakpoints, 'xxs' | 'xs' | 'sm' | 'rg' | 'lg' | 'xl' | 'unset'>>;
}
declare const Container: React.FC<IContainer>;
export default Container;
