import React from 'react';
import { AmauiDate } from '@amaui/date';
import { ILine } from '../Line/Line';
import { TCalendarUnit } from '../Calendar/Calendar';
import { TCalendarMonthCalendar, TCalendarMonthValue } from '../CalendarMonth/CalendarMonth';
import { ITonal, IColor, ISize, IValueBreakpoints, IElement, IElementReference, IPropsAny } from '../types';
export declare const SEPARATOR_SYMBOL = "\u2013";
export declare const SEPARATOR: string;
export interface IDatePicker extends ILine {
    tonal?: ITonal;
    color?: IColor;
    version?: 'auto' | 'mobile' | 'desktop';
    size?: ISize;
    value?: TCalendarMonthValue;
    valueDefault?: TCalendarMonthValue;
    onChange?: (value: TCalendarMonthValue) => any;
    calendar?: TCalendarMonthCalendar;
    calendarDefault?: TCalendarMonthCalendar;
    onChangeCalendar?: (value: TCalendarMonthCalendar) => any;
    now?: boolean;
    range?: boolean;
    static?: boolean;
    valid?: (value: AmauiDate, version: TCalendarUnit) => boolean;
    validate?: (value: AmauiDate) => boolean;
    min?: AmauiDate;
    max?: AmauiDate;
    calendars?: number;
    placeholder?: string;
    openMobile?: 'input' | 'select';
    modeModalSubHeadingText?: string;
    modeModalSubHeadingTextRange?: string;
    selectModeHeadingText?: string;
    inputModeHeadingText?: string;
    switch?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    useHelperText?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    name?: IElement;
    nameFrom?: string;
    nameTo?: string;
    label?: IElement;
    labelFrom?: string;
    labelTo?: string;
    today?: boolean;
    clear?: boolean;
    fullScreen?: boolean;
    heading?: boolean;
    actions?: boolean;
    readOnly?: boolean;
    disabled?: boolean;
    onClick?: (event: React.MouseEvent<any>) => any;
    onClose?: (event: React.MouseEvent<any>) => any;
    onCancel?: (event: React.MouseEvent<any>) => any;
    onToday?: (event: React.MouseEvent<any>) => any;
    onClear?: (event: React.MouseEvent<any>) => any;
    onOk?: (event: React.MouseEvent<any>) => any;
    Icon?: IElementReference;
    IconCheck?: IElementReference;
    IconEnter?: IElementReference;
    IconClose?: IElementReference;
    WrapperProps?: IPropsAny;
    CalendarProps?: IPropsAny;
    CalendarPropsDesktop?: IPropsAny;
    CalendarPropsMobile?: IPropsAny;
    TooltipProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    AdvancedTextFieldProps?: IPropsAny;
    ButtonProps?: IPropsAny;
    ModalProps?: IPropsAny;
}
declare const DatePicker: React.FC<IDatePicker>;
export default DatePicker;
