"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SEPARATOR = exports.SEPARATOR_SYMBOL = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const date_1 = require("@amaui/date");
const style_react_1 = require("@amaui/style-react");
const Icon_1 = __importDefault(require("../Icon"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Button_1 = __importDefault(require("../Button"));
const AdvancedTextField_1 = __importDefault(require("../AdvancedTextField"));
const Modal_1 = __importDefault(require("../Modal"));
const Tooltip_1 = __importDefault(require("../Tooltip"));
const Surface_1 = __importDefault(require("../Surface"));
const Line_1 = __importDefault(require("../Line"));
const Type_1 = __importDefault(require("../Type"));
const Calendar_1 = __importDefault(require("../Calendar"));
const Divider_1 = __importDefault(require("../Divider"));
const Slide_1 = __importDefault(require("../Slide"));
const ClickListener_1 = __importDefault(require("../ClickListener"));
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const IconMaterialCalendarTodayRoundedFilled = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'CalendarTodayRoundedFilled', short_name: 'CalendarToday' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M5 22Q4.175 22 3.587 21.413Q3 20.825 3 20V6Q3 5.175 3.587 4.588Q4.175 4 5 4H6V2.975Q6 2.55 6.287 2.275Q6.575 2 7 2Q7.425 2 7.713 2.287Q8 2.575 8 3V4H16V2.975Q16 2.55 16.288 2.275Q16.575 2 17 2Q17.425 2 17.712 2.287Q18 2.575 18 3V4H19Q19.825 4 20.413 4.588Q21 5.175 21 6V20Q21 20.825 20.413 21.413Q19.825 22 19 22ZM5 20H19Q19 20 19 20Q19 20 19 20V10H5V20Q5 20 5 20Q5 20 5 20Z" }) })));
});
const IconMaterialDoneRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'DoneRounded', short_name: 'Done' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M9.55 17.575Q9.35 17.575 9.175 17.512Q9 17.45 8.85 17.3L4.55 13Q4.275 12.725 4.287 12.287Q4.3 11.85 4.575 11.575Q4.85 11.3 5.275 11.3Q5.7 11.3 5.975 11.575L9.55 15.15L18.025 6.675Q18.3 6.4 18.738 6.4Q19.175 6.4 19.45 6.675Q19.725 6.95 19.725 7.387Q19.725 7.825 19.45 8.1L10.25 17.3Q10.1 17.45 9.925 17.512Q9.75 17.575 9.55 17.575Z" }) })));
});
const IconMaterialEditRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'EditRounded', short_name: 'Edit' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M5 19H6.4L15.025 10.375L13.625 8.975L5 17.6ZM19.3 8.925 15.05 4.725 16.45 3.325Q17.025 2.75 17.863 2.75Q18.7 2.75 19.275 3.325L20.675 4.725Q21.25 5.3 21.275 6.113Q21.3 6.925 20.725 7.5ZM4 21Q3.575 21 3.288 20.712Q3 20.425 3 20V17.175Q3 16.975 3.075 16.788Q3.15 16.6 3.3 16.45L13.6 6.15L17.85 10.4L7.55 20.7Q7.4 20.85 7.213 20.925Q7.025 21 6.825 21ZM14.325 9.675 13.625 8.975 15.025 10.375Z" }) })));
});
const IconMaterialCloseRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'CloseRounded', short_name: 'Close' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M12 13.4 7.1 18.3Q6.825 18.575 6.4 18.575Q5.975 18.575 5.7 18.3Q5.425 18.025 5.425 17.6Q5.425 17.175 5.7 16.9L10.6 12L5.7 7.1Q5.425 6.825 5.425 6.4Q5.425 5.975 5.7 5.7Q5.975 5.425 6.4 5.425Q6.825 5.425 7.1 5.7L12 10.6L16.9 5.7Q17.175 5.425 17.6 5.425Q18.025 5.425 18.3 5.7Q18.575 5.975 18.575 6.4Q18.575 6.825 18.3 7.1L13.4 12L18.3 16.9Q18.575 17.175 18.575 17.6Q18.575 18.025 18.3 18.3Q18.025 18.575 17.6 18.575Q17.175 18.575 16.9 18.3Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    header: {
        width: '100%',
        padding: `${theme.methods.space.value(2, 'px')} ${theme.methods.space.value(3, 'px')} 0px`,
        flex: '0 0 auto'
    },
    header_fullScreen: {
        padding: `${theme.methods.space.value(2, 'px')} 0px 0px`
    },
    actions: {
        width: '100%',
        padding: `0px ${theme.methods.space.value(1, 'px')} ${theme.methods.space.value(1.5, 'px')} ${theme.methods.space.value(1.5, 'px')}`,
        flex: '0 0 auto',
        overflowX: 'auto'
    },
    mode: {
        overflow: 'hidden'
    },
    calendar_mobile: {
        '&.amaui-Calendar-root': {
            width: '100%'
        },
        '& .amaui-Calendar-header + .amaui-Divider-root': {
            display: 'none'
        }
    },
    input_mobile: {
        '&.amaui-TextField-root': {
            width: '100%'
        }
    },
    mobile: {
        width: 'calc(100vw - 48px)',
        maxWidth: '330px',
        margin: '0 auto',
        borderRadius: theme.methods.shape.radius.value(3.5, 'px'),
        overflow: 'hidden',
        '& .amaui-Calendar-root': {
            borderRadius: '0'
        }
    },
    mobile_fullScreen: {
        height: '100vh',
        width: '100vw',
        margin: '0',
        maxWidth: 'unset',
        borderRadius: '0'
    },
    modal_input: {
        width: '100%',
        padding: `${theme.methods.space.value(2, 'px')} ${theme.methods.space.value(3, 'px')} ${theme.methods.space.value(2, 'px')}`,
        marginBottom: '12px',
        flex: '1 1 auto'
    },
    dayNames: {
        width: '100%',
        padding: `0 ${theme.methods.space.value(1, 'px')}`
    },
    dayName: {
        width: '40px',
        height: '40px',
        flex: '1 1 auto',
        userSelect: 'none'
    },
    heading: {
        width: '100%',
        marginBottom: '12px'
    },
    heading_fullScreen: {
        paddingInline: `${theme.methods.space.value(7.5, 'px')} ${theme.methods.space.value(1.5, 'px')}`
    },
    subheading: {
        width: '100%',
        marginBottom: '36px'
    },
    subheading_fullScreen: {
        margin: '8px 0',
        marginInlineStart: '60px'
    },
    divider: {
        '&.amaui-Divider-root': {
            margin: '0'
        }
    }
}), { name: 'amaui-DatePicker' });
exports.SEPARATOR_SYMBOL = `–`;
exports.SEPARATOR = ` ${exports.SEPARATOR_SYMBOL} `;
const DatePicker = react_1.default.forwardRef((props__, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiDatePicker) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props__)); }, [props__]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const Button = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Button) || Button_1.default; }, [theme]);
    const AdvancedTextField = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.AdvancedTextField) || AdvancedTextField_1.default; }, [theme]);
    const Modal = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Modal) || Modal_1.default; }, [theme]);
    const Tooltip = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Tooltip) || Tooltip_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const Calendar = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Calendar) || Calendar_1.default; }, [theme]);
    const Divider = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Divider) || Divider_1.default; }, [theme]);
    const Slide = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Slide) || Slide_1.default; }, [theme]);
    const ClickListener = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.ClickListener) || ClickListener_1.default; }, [theme]);
    const { tonal = true, color = 'primary', version: version_ = 'auto', size = 'regular', value: value_, valueDefault, onChange, calendar: calendar_, calendarDefault, onChangeCalendar, range, now, static: static_, openMobile = 'select', placeholder: placeholder_, calendars = props.range ? 2 : 1, min, max, validate, name, nameFrom, nameTo, label: label_, labelFrom: labelFrom_ = `Date from`, labelTo: labelTo_ = `Date to`, modeModalSubHeadingText = 'Select date', modeModalSubHeadingTextRange = `Date from${exports.SEPARATOR}Date to`, selectModeHeadingText = 'Select date', inputModeHeadingText = 'Enter date', useHelperText: useHelperText_, weekStartDay = 'Monday', switch: switch__, fullScreen, today, clear = true, heading: heading_ = true, actions: actions_ = true, readOnly, disabled, valid: valid_, onClick: onClick_, onClose: onClose_, onToday: onToday_, onClear: onClear_, onCancel: onCancel_, onOk: onOk_, Icon: Icon_ = IconMaterialCalendarTodayRoundedFilled, IconCheck = IconMaterialDoneRounded, IconEnter = IconMaterialEditRounded, IconClose = IconMaterialCloseRounded, WrapperProps, CalendarProps, CalendarPropsDesktop, CalendarPropsMobile, IconButtonProps, AdvancedTextFieldProps, TooltipProps, ButtonProps, ModalProps, className } = props, other = __rest(props, ["tonal", "color", "version", "size", "value", "valueDefault", "onChange", "calendar", "calendarDefault", "onChangeCalendar", "range", "now", "static", "openMobile", "placeholder", "calendars", "min", "max", "validate", "name", "nameFrom", "nameTo", "label", "labelFrom", "labelTo", "modeModalSubHeadingText", "modeModalSubHeadingTextRange", "selectModeHeadingText", "inputModeHeadingText", "useHelperText", "weekStartDay", "switch", "fullScreen", "today", "clear", "heading", "actions", "readOnly", "disabled", "valid", "onClick", "onClose", "onToday", "onClear", "onCancel", "onOk", "Icon", "IconCheck", "IconEnter", "IconClose", "WrapperProps", "CalendarProps", "CalendarPropsDesktop", "CalendarPropsMobile", "IconButtonProps", "AdvancedTextFieldProps", "TooltipProps", "ButtonProps", "ModalProps", "className"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef()
    };
    const breakpoints = {};
    theme.breakpoints.keys.forEach(key => {
        if (theme.breakpoints.media[key])
            breakpoints[key] = (0, useMediaQuery_1.default)(theme.breakpoints.media[key], { element: refs.root.current });
    });
    const label = name !== undefined ? name : label_;
    const labelFrom = nameFrom !== undefined ? nameFrom : labelFrom_;
    const labelTo = nameTo !== undefined ? nameTo : labelTo_;
    const switch_ = (0, utils_2.valueBreakpoints)(switch__, true, breakpoints, theme);
    const useHelperText = (0, utils_2.valueBreakpoints)(useHelperText_, undefined, breakpoints, theme);
    const touch = (0, useMediaQuery_1.default)('(pointer: coarse)', { element: refs.root.current });
    const [value, setValue] = react_1.default.useState(() => {
        const valueResult = (valueDefault !== undefined ? valueDefault : value_) || (now && (range ? [new date_1.AmauiDate(), new date_1.AmauiDate()] : [new date_1.AmauiDate()]));
        return ((0, utils_1.is)('array', valueResult) ? valueResult : [valueResult]).filter(Boolean);
    });
    const [calendar, setCalendar] = react_1.default.useState((calendarDefault !== undefined ? calendarDefault : calendar_) || new date_1.AmauiDate());
    const [open, setOpen] = react_1.default.useState(false);
    const [mode, setMode] = react_1.default.useState((touch ? openMobile : 'select') || 'select');
    const [error, setError] = react_1.default.useState(false);
    const valueToInput = react_1.default.useCallback((valueNew = value) => {
        let result = '';
        const [from, to] = valueNew;
        if (!(from || to))
            return '';
        const method = (item) => `${(0, date_1.format)(item, 'DD')}/${(0, date_1.format)(item, 'MM')}/${(0, date_1.format)(item, 'YYYY')}`;
        result += `${method(from)}`;
        if (range && to)
            result += `${exports.SEPARATOR}${method(to)}`;
        return result;
    }, [value, range]);
    const [input, setInput] = react_1.default.useState(valueToInput());
    const [inputModal, setInputModal] = react_1.default.useState(valueToInput());
    let version = version_;
    if (version === 'auto') {
        if (touch)
            version = 'mobile';
        else
            version = 'desktop';
    }
    const onUpdateValue = (valueNew) => {
        setValue(valueNew);
        // Update input
        setInput(valueToInput(valueNew));
        // Update input modal
        setInputModal(valueToInput(valueNew));
    };
    const errorCheck = react_1.default.useCallback((valueNew = value) => {
        // Error
        setError((valueNew || []).some((item, index) => !valid(item)));
    }, [value]);
    // Init
    react_1.default.useEffect(() => {
        // Error
        errorCheck();
    }, []);
    // Value
    react_1.default.useEffect(() => {
        if (value_ !== undefined && value_ !== value)
            onUpdateValue((((0, utils_1.is)('array', value_) ? value_ : [value_]).filter(Boolean)));
    }, [value_]);
    // Calendar
    react_1.default.useEffect(() => {
        if (calendar_ !== undefined && calendar_ !== calendar)
            setCalendar(calendar_);
    }, [calendar_]);
    const onUpdate = react_1.default.useCallback((valueNew) => {
        // Inner update
        if (!props.hasOwnProperty('value'))
            setValue(valueNew);
        if ((0, utils_1.is)('function', onChange))
            onChange(!range ? valueNew[0] : valueNew);
    }, [onChange, range]);
    const onUpdateCalendar = react_1.default.useCallback((valueNew) => {
        // Inner update
        if (!props.hasOwnProperty('calendar'))
            setCalendar(valueNew);
        if ((0, utils_1.is)('function', onChangeCalendar))
            onChangeCalendar(valueNew);
    }, [onChangeCalendar]);
    // Update only internally, without using onChange
    // since it might be canceled
    // only use onChange on
    // input change, or ok
    const onCalendarChange = react_1.default.useCallback((valueNew_) => {
        const valueNew = (0, utils_1.is)('array', valueNew_) ? valueNew_ : [valueNew_];
        if (valueNew !== value) {
            (!actions_ ? onUpdate : setValue)(valueNew);
            // Update input modal
            setInputModal(valueToInput(valueNew));
        }
    }, [value, actions_]);
    const onCalendarChangeCalendar = react_1.default.useCallback((valueNew) => {
        if (valueNew !== calendar)
            onUpdateCalendar(valueNew);
    }, [calendar]);
    const inputToValue = react_1.default.useCallback((valueNew_ = input) => {
        let valueNew = valueNew_;
        let [from, to] = valueNew.split(exports.SEPARATOR);
        from = textToAmauiDate(from);
        if (to)
            to = textToAmauiDate(to);
        valueNew = [from, to].filter(Boolean);
        return valueNew;
    }, [input]);
    const onOpen = react_1.default.useCallback(() => {
        onMode();
        setOpen(!open);
    }, [open, openMobile, version]);
    const onClose = react_1.default.useCallback((event) => {
        setOpen(false);
        if ((0, utils_1.is)('function', onClose_))
            onClose_(event);
    }, [onClose_]);
    const onReset = react_1.default.useCallback(() => {
        var _a;
        let valueNew = inputToValue();
        const isValid = valueNew && ((_a = valueNew === null || valueNew === void 0 ? void 0 : valueNew[0]) === null || _a === void 0 ? void 0 : _a.valid);
        if (isValid) {
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(valueNew[0]);
            // Update input modal
            setInputModal(input);
        }
        else {
            const dateNow = new date_1.AmauiDate();
            valueNew = [];
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(dateNow);
            // Update input
            setInput(valueToInput(valueNew));
            // Update input modal
            setInputModal(valueToInput(valueNew));
        }
    }, [input]);
    const onToday = react_1.default.useCallback((event) => {
        const valueNew = [new date_1.AmauiDate()];
        if (range)
            valueNew.push(new date_1.AmauiDate());
        // Update value
        onUpdate(valueNew);
        // Update calendar
        onUpdateCalendar(valueNew[0]);
        // Update input
        setInput(valueToInput(valueNew));
        // Update input modal
        setInputModal(valueToInput(valueNew));
        onClose(event);
        if ((0, utils_1.is)('function', onToday_))
            onToday_(event);
    }, [input, range, onToday_]);
    const onClear = react_1.default.useCallback((event) => {
        const dateNow = new date_1.AmauiDate();
        const valueNew = [];
        // Update value
        onUpdate(valueNew);
        // Update calendar
        onUpdateCalendar(dateNow);
        // Update input
        setInput(valueToInput(valueNew));
        // Update input modal
        setInputModal(valueToInput(valueNew));
        onClose(event);
        if ((0, utils_1.is)('function', onClear_))
            onClear_(event);
    }, [onClear_]);
    const onOk = react_1.default.useCallback((event) => {
        // Error
        errorCheck();
        // Update value
        onUpdate(value);
        // Update input
        setInput(valueToInput(value));
        // Update input modal
        setInputModal(valueToInput(value));
        onClose(event);
        if ((0, utils_1.is)('function', onOk_))
            onOk_(event);
    }, [value, onOk_]);
    const onCancel = react_1.default.useCallback((event) => {
        onReset();
        onClose(event);
        if ((0, utils_1.is)('function', onCancel_))
            onCancel_(event);
    }, [input, onCancel_]);
    const valid = react_1.default.useCallback((...args) => {
        if ((0, utils_1.is)('function', valid_))
            return valid_(...args);
        const amauiDate = args[0];
        if (min || max || validate) {
            let response = true;
            if ((0, utils_1.is)('function', validate))
                response = validate(amauiDate);
            if (min !== undefined)
                response = response && (0, date_1.is)(amauiDate, 'after or same', min);
            if (max !== undefined)
                response = response && (0, date_1.is)(amauiDate, 'before or same', max);
            return response;
        }
        return true;
    }, [valid_, min, max, validate]);
    const textToAmauiDate = react_1.default.useCallback((valueNew) => {
        const [valueDay, valueMonth, valueYear] = (valueNew || '').split('/');
        const amauiDate = new date_1.AmauiDate(new Date(`${valueMonth}/${valueDay}/${valueYear}`));
        return amauiDate;
    }, []);
    const onInputChange = react_1.default.useCallback((valueNew_) => {
        const valueNew = inputToValue(valueNew_);
        const validValues = valueNew.every(item => item.valid);
        // Only update values if input is valid
        // format used to make the value
        if (validValues) {
            // Error
            errorCheck(valueNew);
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(valueNew[0]);
        }
        if (!valueNew_) {
            onUpdate([null, null]);
        }
        // Update input for free typing
        setInput(valueNew_);
    }, []);
    const onInputChangeModal = react_1.default.useCallback((valueNew_) => {
        const valueNew = inputToValue(valueNew_);
        const validValues = valueNew.every(item => item.valid);
        // Only update values if input is valid
        // format used to make the value
        if (validValues) {
            // Error
            errorCheck(valueNew);
            // Update value
            onUpdate(valueNew);
            // Update calendar
            onUpdateCalendar(valueNew[0]);
        }
        // Update input for free typing
        setInputModal(valueNew_);
    }, []);
    const onMode = react_1.default.useCallback((mode_ = openMobile) => {
        setMode(() => mode_);
    }, []);
    const mask = [
        { pattern: '[0-3]' },
        (item, result, valueInput) => /^(0[0-9]|1[0-9]|2[0-9]|3[0-1]).*/.test(valueInput),
        '/',
        { pattern: '[0-1]' },
        (item, result, valueInput) => /^(0[0-9]|1[0-9]|2[0-9]|3[0-1])\/(0[0-9]|1[0-2])/.test(valueInput),
        '/',
        { pattern: '[1-2]' },
        { pattern: '[0-9]' },
        { pattern: '[0-9]' },
        { pattern: '[0-9]' }
    ];
    let placeholder = `DD/MM/YYYY`;
    // range
    if (range) {
        mask.push(' ', exports.SEPARATOR_SYMBOL, ' ', ...mask);
        placeholder += `${exports.SEPARATOR}${placeholder}`;
    }
    placeholder = placeholder_ || placeholder;
    const buttonProps = Object.assign({ tonal,
        color, version: 'text', size }, ButtonProps);
    const iconButtonProps = Object.assign({ size }, IconButtonProps);
    const actions = ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ direction: 'row', align: 'center', justify: 'space-between', className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'amaui-DatePicker-actions'
            ],
            classes.actions
        ]) }, { children: [(today || clear) && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center' }, { children: [today && ((0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onToday }, buttonProps, { children: "Today" }))), clear && ((0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onClear }, buttonProps, { children: "Clear" })))] }))), (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center' }, { children: [(0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onCancel }, buttonProps, { children: "Cancel" })), (0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onOk }, buttonProps, { children: "Ok" }))] }))] })));
    const moreProps = {};
    if (version === 'desktop') {
        moreProps.end = ((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ tonal: tonal, color: color, version: 'text', onClick: onOpen, "aria-label": `Choose date${range ? ' range' : ''}`, disabled: disabled || readOnly }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(Icon_, {}) })));
    }
    if (version === 'mobile') {
        if (!(readOnly || disabled))
            moreProps.onClick = onOpen;
    }
    let textHeading = `${(0, date_1.format)(value[0], 'd')}, ${(0, date_1.format)(value[0], 'MMM')} ${(0, date_1.format)(value[0], 'DD')}`;
    if (range) {
        textHeading = `${(0, date_1.format)(value[0], 'MMM')} ${(0, date_1.format)(value[0], 'DD')}${exports.SEPARATOR}${(0, date_1.format)(value[1], 'MMM')} ${(0, date_1.format)(value[1], 'DD')}`;
    }
    const dayNames = ['M', 'T', 'W', 'T', 'F', 'S', 'S'];
    const mobile = ((0, jsx_runtime_1.jsxs)(Surface, Object.assign({ tonal: tonal, color: color, gap: 0, direction: 'column', Component: Line, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'amaui-DatePicker-mobile'
            ],
            classes.mobile,
            fullScreen && classes.mobile_fullScreen
        ]) }, { children: [(0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'column', className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'amaui-DatePicker-header'
                    ],
                    classes.header,
                    fullScreen && classes.header_fullScreen
                ]) }, { children: [actions_ && fullScreen && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center', justify: 'space-between', style: {
                            width: '100%',
                            marginBottom: 8,
                            padding: `0px ${theme.methods.space.value(1, 'px')} 0px ${theme.methods.space.value(1.5, 'px')}`
                        } }, { children: [(0, jsx_runtime_1.jsx)(IconButton, Object.assign({ color: 'inherit', version: 'text', onClick: onClose, "aria-label": 'Close' }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconClose, {}) })), (0, jsx_runtime_1.jsx)(Button, Object.assign({ onClick: onOk }, buttonProps, { children: "Save" }))] }))), heading_ && ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'l2', className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('DatePicker', theme) && [
                                'amaui-DatePicker-subheading'
                            ],
                            classes.subheading,
                            fullScreen && classes.subheading_fullScreen
                        ]) }, { children: !range ? modeModalSubHeadingText : modeModalSubHeadingTextRange }))), mode === 'select' && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ direction: 'row', align: 'center', justify: 'space-between', className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('DatePicker', theme) && [
                                'amaui-DatePicker-heading'
                            ],
                            classes.heading,
                            fullScreen && classes.heading_fullScreen
                        ]) }, { children: [(0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'h1' }, { children: textHeading })), switch_ && ((0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ label: 'Enter date' }, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ tonal: tonal, color: 'inherit', onClick: () => onMode('input'), "aria-label": 'Enter date' }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconEnter, {}) })) })))] }))), mode === 'input' && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ direction: 'row', align: 'flex-start', justify: 'space-between', className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('DatePicker', theme) && [
                                'amaui-DatePicker-heading'
                            ],
                            classes.heading,
                            fullScreen && classes.heading_fullScreen
                        ]) }, { children: [(0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'h1' }, { children: inputModeHeadingText })), switch_ && ((0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ label: 'Select date' }, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ tonal: tonal, color: 'inherit', onClick: () => onMode('select'), "aria-label": 'Choose date' }, iconButtonProps, { children: (0, jsx_runtime_1.jsx)(Icon_, {}) })) })))] })))] })), mode === 'select' && fullScreen && ((0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 0, direction: 'row', align: 'center', justify: 'space-between', className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'amaui-DatePicker-day-names'
                    ],
                    classes.dayNames
                ]) }, { children: dayNames.map((day, index) => ((0, jsx_runtime_1.jsx)(Line, Object.assign({ version: 'b3', direction: 'row', align: 'center', justify: 'center', Component: Type, className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('DatePicker', theme) && [
                            'amaui-DatePicker-day-name'
                        ],
                        classes.dayName
                    ]) }, { children: day }), index))) }))), (0, jsx_runtime_1.jsx)(Divider, { tonal: false, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'amaui-DatePicker-divider'
                    ],
                    classes.divider
                ]) }), mode === 'select' && ((0, jsx_runtime_1.jsx)(Calendar, Object.assign({ version: !fullScreen ? 'regular' : 'year', tonal: tonal, color: color, value: value, menu: 'month', menu_month_previous_unit: fullScreen ? 'year' : 'month', menu_month_next_unit: fullScreen ? 'year' : 'month', calendar: calendar, onChange: onCalendarChange, onChangeCalendar: onCalendarChangeCalendar, now: now, size: size, range: range, calendars: 1, valid: valid, min: min, max: max, validate: validate, CalendarMonthProps: {
                    outside: false,
                    labels: !fullScreen
                } }, CalendarProps, CalendarPropsMobile, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'amaui-DatePicker-calendar',
                        'amaui-DatePicker-version-mobile'
                    ],
                    CalendarProps === null || CalendarProps === void 0 ? void 0 : CalendarProps.className,
                    CalendarPropsMobile === null || CalendarPropsMobile === void 0 ? void 0 : CalendarPropsMobile.className,
                    classes.calendar,
                    classes.calendar_mobile
                ]) }))), mode === 'input' && ((0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 1.5, direction: 'row', align: 'flex-start', className: (0, style_react_1.classNames)([
                    classes.modal_input
                ]) }, { children: (0, jsx_runtime_1.jsx)(AdvancedTextField, Object.assign({ tonal: tonal, color: color, version: 'outlined', size: size, label: label, mask: mask, placeholder: placeholder, value: inputModal, onChange: onInputChangeModal, helperText: useHelperText ? placeholder : undefined, error: error, readOnly: readOnly, disabled: disabled }, AdvancedTextFieldProps, { className: (0, style_react_1.classNames)([
                        AdvancedTextFieldProps === null || AdvancedTextFieldProps === void 0 ? void 0 : AdvancedTextFieldProps.className,
                        classes.input_mobile
                    ]) })) }))), fullScreen && ((0, jsx_runtime_1.jsx)(Divider, { tonal: false, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('DatePicker', theme) && [
                        'amaui-DatePicker-divider'
                    ],
                    classes.divider
                ]) })), actions_ && react_1.default.cloneElement(actions, {
                style: {
                    paddingTop: theme.methods.space.value(1, 'px')
                }
            })] })));
    const desktop = ((0, jsx_runtime_1.jsx)(Calendar, Object.assign({ tonal: tonal, color: color, value: value, calendar: calendar, onChange: onCalendarChange, onChangeCalendar: onCalendarChangeCalendar, now: now, size: size, range: range, calendars: calendars, valid: valid, min: min, max: max, validate: validate, belowCalendars: actions_ ? actions : undefined }, CalendarProps, CalendarPropsDesktop, { className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'amaui-DatePicker-calendar',
                'amaui-DatePicker-version-desktop'
            ],
            CalendarProps === null || CalendarProps === void 0 ? void 0 : CalendarProps.className,
            CalendarPropsDesktop === null || CalendarPropsDesktop === void 0 ? void 0 : CalendarPropsDesktop.className,
            classes.calendar,
            classes.calendar_desktop
        ]) })));
    if (static_) {
        if (version === 'mobile')
            return mobile;
        if (version === 'desktop')
            return desktop;
    }
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'column' }, WrapperProps, { className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('DatePicker', theme) && [
                'amaui-DatePicker-root',
                WrapperProps === null || WrapperProps === void 0 ? void 0 : WrapperProps.className,
                range && `amaui-DatePicker-range`,
                readOnly && `amaui-DatePicker-read-only`,
                disabled && `amaui-DatePicker-disabled`
            ],
            className,
            classes.root
        ]) }, { children: [(0, jsx_runtime_1.jsx)(AdvancedTextField, Object.assign({ rootRef: item => {
                    if (ref) {
                        if ((0, utils_1.is)('function', ref))
                            ref(item);
                        else
                            ref.current = item;
                    }
                    refs.root.current = item;
                }, tonal: tonal, color: color, version: 'outlined', size: size, label: label, mask: mask, placeholder: placeholder, value: input, onChange: onInputChange, helperText: useHelperText ? placeholder : undefined, endVerticalAlign: 'center', error: error, readOnly: readOnly, disabled: disabled }, moreProps, other, AdvancedTextFieldProps)), version === 'mobile' && ((0, jsx_runtime_1.jsx)(Modal, Object.assign({ open: open, modalWrapperSurface: false, TransitionComponent: Slide, fullScreen: fullScreen, onClose: onClose }, ModalProps, { children: mobile }))), version === 'desktop' && ((0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ open: open, portal: true, anchorElement: refs.root.current, alignment: 'center', position: 'bottom', hover: false, focus: false, longPress: false, maxWidth: 'unset', noMargin: true, label: ((0, jsx_runtime_1.jsx)(ClickListener, Object.assign({ onClickOutside: onCancel, includeParentQueries: ['.amaui-Calendar-list'] }, { children: desktop }))) }, TooltipProps)))] })));
});
DatePicker.displayName = 'amaui-DatePicker';
exports.default = DatePicker;
