import React from 'react';
import { ILine } from '../Line/Line';
import { ITonal, IColor, IRef, IElementReference, IPropsAny } from '../types';
export declare type TFileChooseValue = File | Array<File>;
export interface IFileChoose extends ILine {
    tonal?: ITonal;
    color?: IColor;
    inputRef?: IRef;
    max?: number;
    allowedTypes?: Array<string>;
    files?: Array<File>;
    valueDefault?: TFileChooseValue;
    value?: TFileChooseValue;
    multiple?: boolean;
    accept?: string;
    capture?: boolean | 'user' | 'environment';
    remove?: boolean;
    renderFiles?: (value: TFileChooseValue, onRemove: (index: number) => any) => any;
    onClick?: (event: React.MouseEvent<any>) => any;
    onChange?: (value: TFileChooseValue) => any;
    IconStart?: IElementReference;
    inputProps?: IPropsAny;
    WrapperProps?: IPropsAny;
    ComponentProps?: IPropsAny;
}
declare const FileChoose: React.FC<IFileChoose>;
export default FileChoose;
