"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Icon_1 = __importDefault(require("../Icon"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Line_1 = __importDefault(require("../Line"));
const Tooltip_1 = __importDefault(require("../Tooltip"));
const IFrame_1 = __importDefault(require("../IFrame"));
const utils_2 = require("../utils");
const IconMaterialSmartphone = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'Smartphone', short_name: 'Smartphone', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M7 23q-.825 0-1.412-.587Q5 21.825 5 21V3q0-.825.588-1.413Q6.175 1 7 1h10q.825 0 1.413.587Q19 2.175 19 3v18q0 .825-.587 1.413Q17.825 23 17 23Zm0-5h10V6H7Zm0 2v1h10v-1ZM7 4h10V3H7Zm0-1v1-1Zm0 18v-1 1Z" }) })));
});
const IconMaterialTabletMac = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'TabletMac', short_name: 'TabletMac', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M5 23q-.825 0-1.413-.587Q3 21.825 3 21V3q0-.825.587-1.413Q4.175 1 5 1h14q.825 0 1.413.587Q21 2.175 21 3v18q0 .825-.587 1.413Q19.825 23 19 23Zm0-7h14V6H5Zm0 2v3h14v-3ZM5 4h14V3H5Zm0-1v1-1Zm0 18v-3 3Zm7-.5q.425 0 .713-.288.287-.287.287-.712t-.287-.712Q12.425 18.5 12 18.5t-.712.288Q11 19.075 11 19.5t.288.712q.287.288.712.288Z" }) })));
});
const IconMaterialComputer = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'Computer', short_name: 'Computer', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M4 18q-.825 0-1.412-.587Q2 16.825 2 16V5q0-.825.588-1.413Q3.175 3 4 3h16q.825 0 1.413.587Q22 4.175 22 5v11q0 .825-.587 1.413Q20.825 18 20 18Zm0-2h16V5H4v11Zm-2 5q-.425 0-.712-.288Q1 20.425 1 20t.288-.712Q1.575 19 2 19h20q.425 0 .712.288.288.287.288.712t-.288.712Q22.425 21 22 21Zm2-5V5v11Z" }) })));
});
const IconMaterialDesktopWindows = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'DesktopWindows', short_name: 'DesktopWindows', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M9 22q-.425 0-.712-.288Q8 21.425 8 21t.288-.712Q8.575 20 9 20h1v-2H4q-.825 0-1.412-.587Q2 16.825 2 16V5q0-.825.588-1.413Q3.175 3 4 3h16q.825 0 1.413.587Q22 4.175 22 5v11q0 .825-.587 1.413Q20.825 18 20 18h-6v2h1q.425 0 .713.288.287.287.287.712t-.287.712Q15.425 22 15 22Zm-5-6h16V5H4v11Zm0 0V5v11Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => ({
    '@p': {
        '*[data-theme] .amaui-Carousel-root, *[data-theme] .amaui-VideoPlayer-root, *[data-theme] .amaui-AudioPlayer-root, *[data-theme] .amaui-Share-root, *[data-theme] .amaui-website-Header-root, *[data-theme] .amaui-website-Footer-root, *[data-theme] .amaui-website-BackTo-root, *[data-theme] .amaui-websites-Resume-to, *[data-theme] .amaui-Resume-menu, *[data-theme] .amaui-websites-VisitorChat-speed-dial, *[data-theme] .amaui-websites-Form-root, *[data-theme] .amaui-websites-Reservation-root, *[data-theme] .amaui-Links-more, *[data-theme] .amaui-ImageGallery-root': {
            pointerEvents: 'none'
        }
    },
    root: {
        position: 'relative',
        overflow: 'hidden'
    },
    options: {
        overflowX: 'auto',
        overflowY: 'hidden',
        padding: `${theme.methods.space.value(1.5, 'px')} ${theme.methods.space.value(3, 'px')}`,
        '& > *': {
            flex: '0 0 auto'
        }
    },
    wrapper: {
        margin: '0 4px 24px',
        minHeight: '15vh',
        height: 0,
        border: `0.5px solid ${theme.palette.text.divider}`,
        borderRadius: theme.methods.shape.radius.value(2),
        boxShadow: theme.shadows.values.default[1],
        overflow: 'hidden',
        '&.amaui-Line-root': {
            width: 'calc(100% - 8px)'
        }
    },
    IFrame: {
        position: 'relative'
    },
    iframe: {
        width: '100%',
        height: '100%'
    }
}), { name: 'amaui-Frame' });
const Frame = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiFrame) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const Tooltip = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Tooltip) || Tooltip_1.default; }, [theme]);
    const IFrameElement = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IFrame) || IFrame_1.default; }, [theme]);
    const { url, src, value, startOptions, endOptions, IconMobile = IconMaterialSmartphone, IconTablet = IconMaterialTabletMac, IconLaptop = IconMaterialComputer, IconDesktop = IconMaterialDesktopWindows, iframeProps, IFrameProps, OptionProps, OptionsProps, OptionsWrapperProps, WrapperProps, className, children } = props, other = __rest(props, ["url", "src", "value", "startOptions", "endOptions", "IconMobile", "IconTablet", "IconLaptop", "IconDesktop", "iframeProps", "IFrameProps", "OptionProps", "OptionsProps", "OptionsWrapperProps", "WrapperProps", "className", "children"]);
    const { classes } = useStyle();
    const [responsive, setResponsive] = react_1.default.useState();
    const onResponsive = react_1.default.useCallback((value_) => {
        setResponsive((previous) => {
            if (previous === value_)
                return '';
            return value_;
        });
    }, []);
    const responsiveOptions = [
        { name: 'Mobile', icon: IconMobile, disabled: (0, utils_1.isEnvironment)('browser') && window.innerWidth < 375 },
        { name: 'Tablet', icon: IconTablet, disabled: (0, utils_1.isEnvironment)('browser') && window.innerWidth < 768 },
        { name: 'Laptop', icon: IconLaptop, disabled: (0, utils_1.isEnvironment)('browser') && window.innerWidth < 1440 },
        { name: 'Desktop', icon: IconDesktop, disabled: (0, utils_1.isEnvironment)('browser') && window.innerWidth < 1920 }
    ];
    const WrapperStyle = {};
    if (responsive) {
        // iphone SE
        if (responsive === 'Mobile') {
            WrapperStyle.maxWidth = 375;
            WrapperStyle.maxHeight = 667;
        }
        // ipad mini
        if (responsive === 'Tablet') {
            WrapperStyle.maxWidth = 768;
            WrapperStyle.maxHeight = 1024;
        }
        // laptop
        if (responsive === 'Laptop') {
            WrapperStyle.maxWidth = 1440;
            WrapperStyle.maxHeight = 768;
        }
        // desktop
        if (responsive === 'Desktop') {
            WrapperStyle.maxWidth = 1920;
            WrapperStyle.maxHeight = 1080;
        }
    }
    const main = (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [children, value && !children && ((0, jsx_runtime_1.jsx)(IFrameElement, Object.assign({ className: (0, style_react_1.classNames)([
                    classes.IFrame
                ]), WrapperProps: {
                    align: 'center',
                    justify: 'center'
                } }, { children: value || children }))), (url || src) && !(value || children) && ((0, jsx_runtime_1.jsx)("iframe", Object.assign({ title: 'frame', src: url || src }, iframeProps, { className: (0, style_react_1.classNames)([
                    iframeProps === null || iframeProps === void 0 ? void 0 : iframeProps.className,
                    classes.iframe
                ]) })))] });
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ ref: ref, gap: 0, align: 'center', flex: true, fullWidth: true, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Frame', theme) && [
                'amaui-Frame-root'
            ],
            className,
            classes.root
        ]) }, other, { children: [(0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 0.5, direction: 'row', align: 'center', justify: {
                    xxs: 'flex-start',
                    xs: 'flex-start',
                    default: 'flex-end'
                }, fullWidth: true }, OptionsWrapperProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('Frame', theme) && [
                        'amaui-Frame-options-wrapper'
                    ],
                    OptionsWrapperProps === null || OptionsWrapperProps === void 0 ? void 0 : OptionsWrapperProps.className
                ]) }, { children: (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0.4, direction: 'row', align: 'center', justify: 'flex-end' }, OptionsProps, { className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('Frame', theme) && [
                            'amaui-Frame-options'
                        ],
                        OptionsProps === null || OptionsProps === void 0 ? void 0 : OptionsProps.className,
                        classes.options
                    ]) }, { children: [startOptions, responsiveOptions.map((item, index) => ((0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ label: item.name }, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ size: 'small', selected: item.name === responsive, onClick: () => onResponsive(item.name), disabled: item.disabled }, OptionProps, { className: (0, style_react_1.classNames)([
                                    (0, utils_2.staticClassName)('Frame', theme) && [
                                        'amaui-Frame-option'
                                    ],
                                    OptionProps === null || OptionProps === void 0 ? void 0 : OptionProps.className
                                ]) }, { children: (0, jsx_runtime_1.jsx)(item.icon, {}) })) }), index))), endOptions] })) })), (0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 0, align: 'center', flex: true, fullWidth: true }, WrapperProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('Frame', theme) && [
                        'amaui-Frame-wrapper'
                    ],
                    WrapperProps === null || WrapperProps === void 0 ? void 0 : WrapperProps.className,
                    classes.wrapper
                ]), style: Object.assign(Object.assign({}, WrapperStyle), WrapperProps === null || WrapperProps === void 0 ? void 0 : WrapperProps.style) }, { children: main }))] })));
});
Frame.displayName = 'amaui-Frame';
exports.default = Frame;
