"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const __1 = require("..");
const Grow = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiGrow) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const refs = {
        root: react_1.default.useRef()
    };
    const { in: inProp, prefix, run, append, add, enter, exit, enterOnAdd, exitOnAdd, noAbruption, removeOnExited, delay, duration: duration_, timing_function, addTransition, onTransition, onAppended, onAdd, onAdding, onAdded, onEnter, onEntering, onEntered, onExit, onExiting, onExited, onRemoved, className, style, children } = props, other = __rest(props, ["in", "prefix", "run", "append", "add", "enter", "exit", "enterOnAdd", "exitOnAdd", "noAbruption", "removeOnExited", "delay", "duration", "timing_function", "addTransition", "onTransition", "onAppended", "onAdd", "onAdding", "onAdded", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited", "onRemoved", "className", "style", "children"]);
    const styles = (status) => {
        var _a;
        const { opacity = 1, transform = 'scale(1)' } = (refs.root.current && window.getComputedStyle((_a = refs.root) === null || _a === void 0 ? void 0 : _a.current)) || {};
        const allStyles = {
            appended: {
                visibility: 'hidden'
            },
            add: {
                transition: 'none',
                opacity: 0,
                transform: `scale(0.74)`
            },
            adding: {
                opacity: 1,
                transform: `scale(1)`
            },
            added: {
                opacity: 1,
                transform: `scale(1)`
            },
            enter: {
                transition: 'none',
                opacity: 0,
                transform: `scale(0.74)`
            },
            entering: {
                opacity: 1,
                transform: `scale(1)`
            },
            entered: {
                opacity: 1,
                transform: `scale(1)`
            },
            exit: {
                opacity,
                transform
            },
            exiting: {
                opacity: 0,
                transform: `scale(0.74)`
            },
            exited: {
                opacity: 0,
                transform: `scale(0.74)`
            }
        };
        return allStyles[status];
    };
    const duration = (status, property = 'opacity') => {
        const properties = {
            opacity: theme.transitions.duration.sm,
            transform: theme.transitions.duration.xs
        };
        return `${((0, utils_1.is)('simple', duration) ? duration : duration[status]) || properties[property]}ms`;
    };
    const timingFunction = status => ((0, utils_1.is)('simple', timing_function) ? timing_function : timing_function[status]) || theme.transitions.timing_function.standard;
    return ((0, jsx_runtime_1.jsx)(__1.Transition, Object.assign({}, props, { children: (status, ref_) => {
            var _a, _b;
            return react_1.default.cloneElement(children, Object.assign(Object.assign({}, other), { ref: (item) => {
                    refs.root.current = item;
                    if (ref) {
                        if ((0, utils_1.is)('function', ref))
                            ref(item);
                        else
                            ref.current = item;
                    }
                    if (ref_) {
                        if ((0, utils_1.is)('function', ref_))
                            ref_(item);
                        else
                            ref_.current = item;
                    }
                    if (children.ref) {
                        if ((0, utils_1.is)('function', children.ref))
                            children.ref(item);
                        else
                            children.ref.current = item;
                    }
                }, className: (0, style_react_1.classNames)([
                    className,
                    (_a = children === null || children === void 0 ? void 0 : children.props) === null || _a === void 0 ? void 0 : _a.className
                ]), style: Object.assign(Object.assign(Object.assign({ visibility: status === 'exited' && !inProp ? 'hidden' : undefined, transition: `opacity ${duration(status)} ${timingFunction(status)}, transform ${duration(status, 'transform')} ${timingFunction(status)} ${status === 'exiting' ? '74ms' : '0ms'} ${addTransition ? `, ${addTransition}` : ''}` }, styles(status)), (_b = children === null || children === void 0 ? void 0 : children.props) === null || _b === void 0 ? void 0 : _b.style), style) }));
        } })));
});
Grow.displayName = 'amaui-Grow';
exports.default = Grow;
