"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Line_1 = __importDefault(require("../Line"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        width: '100%',
        height: '100%'
    },
    hidden: {
        height: 0,
        width: 0,
        opacity: 0,
        visibility: 'hidden'
    }
}), { name: 'amaui-IFrame' });
const IFrame = react_1.default.forwardRef((props_, ref) => {
    var _a, _b, _c, _d;
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiIFrame) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const { id, WrapperProps, className, children } = props, other = __rest(props, ["id", "WrapperProps", "className", "children"]);
    const { classes } = useStyle();
    const [init, setInit] = react_1.default.useState(false);
    const [show, setShow] = react_1.default.useState(false);
    const refs = {
        root: react_1.default.useRef()
    };
    const iframeDocument = (_b = (_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.contentWindow) === null || _b === void 0 ? void 0 : _b.document;
    const iframeBody = (_d = (_c = refs.root.current) === null || _c === void 0 ? void 0 : _c.contentWindow) === null || _d === void 0 ? void 0 : _d.document.body;
    const refresh = react_1.default.useCallback(() => {
        var _a, _b, _c, _d;
        if (iframeDocument) {
            const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
            // Add iframe ref to iframe document
            iframeDocument.iframe = refs.root.current;
            iframeDocument.iframeWindow = (_b = refs.root.current) === null || _b === void 0 ? void 0 : _b.contentWindow;
            // Head
            (_c = iframeDocument.head) === null || _c === void 0 ? void 0 : _c.replaceWith(rootDocument.createElement('head'));
            (0, utils_2.importIframeStyles)(iframeDocument);
            // Default
            const styleDefault = rootDocument.createElement('style');
            styleDefault.innerHTML = `
        body {
          background-color: transparent;
          padding: 0px;
        }

        body::-webkit-scrollbar {
          height: 0px;
          width: 0px;
        }
      `;
            (_d = iframeDocument.head) === null || _d === void 0 ? void 0 : _d.append(styleDefault);
            // Body
            if (iframeBody)
                iframeBody.dir = rootDocument.body.dir;
        }
    }, [iframeDocument]);
    react_1.default.useEffect(() => {
        if (init && !show)
            setTimeout(() => {
                refresh();
                setShow(true);
            }, 740);
    }, [init]);
    react_1.default.useEffect(() => {
        refresh();
        if (!init)
            setInit(true);
    }, [id, refs.root.current, children, theme]);
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, flex: true, fullWidth: true }, WrapperProps, { children: [(0, jsx_runtime_1.jsx)(Line, Object.assign({ className: classes.hidden }, { children: children })), (0, jsx_runtime_1.jsx)("iframe", Object.assign({ ref: item => {
                    if (ref) {
                        if ((0, utils_1.is)('function', ref))
                            ref(item);
                        else
                            ref.current = item;
                    }
                    refs.root.current = item;
                }, title: id, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('IFrame', theme) && [
                        'amaui-IFrame-root'
                    ],
                    className,
                    classes.root
                ]) }, other, { children: init && iframeBody && react_dom_1.default.createPortal(react_1.default.cloneElement(children, {
                    iframeRef: refs.root.current,
                    style: Object.assign(Object.assign(Object.assign({}, children === null || children === void 0 ? void 0 : children.props.style), { transition: theme.methods.transitions.make('opacity') }), (show ? {
                        opacity: 1
                    } : {
                        opacity: 0
                    }))
                }), iframeBody) }))] })));
});
IFrame.displayName = 'amaui-IFrame';
exports.default = IFrame;
