import React from 'react';
import { IBaseElement, IPropsAny } from '../types';
export declare type TImageCrop = {
    x?: number;
    y?: number;
    width?: number;
    height?: number;
};
export interface IImageCrop extends IBaseElement {
    image?: string | HTMLCanvasElement;
    minWidth?: number;
    minHeight?: number;
    maxWidth?: number;
    maxHeight?: number;
    selectorDefault?: TImageCrop;
    selector?: TImageCrop;
    onSelectorChange?: (value: TImageCrop) => any;
    type?: string;
    quality?: number;
    aspectRatio?: number;
    gridLines?: boolean;
    dynamicParent?: boolean;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    TooltipProps?: IPropsAny;
}
declare const ImageCrop: React.FC<IImageCrop>;
export default ImageCrop;
