import React from 'react';
import { IMedia } from '@amaui/api-utils';
import { ILine } from '../Line/Line';
import { IElementReference } from '../types';
export interface IImageGalleryItem extends IMedia {
    url?: string;
    urlSmall?: string;
    src?: string;
    srcSmall?: string;
}
export interface IImageGallery extends ILine {
    version?: 'regular' | 'modal';
    open?: boolean;
    size?: 'small' | 'regular' | 'large';
    onClose?: () => any;
    value?: number;
    items?: IImageGalleryItem[];
    incrementZoom?: number;
    minZoom?: number;
    maxZoom?: number;
    overflow?: boolean;
    arrows?: boolean;
    ImageProps?: any;
    ImageWrapperProps?: any;
    IconButtonProps?: any;
    IconStart?: IElementReference;
    IconEnd?: IElementReference;
    IconClose?: IElementReference;
}
declare const ImageGallery: React.FC<IImageGallery>;
export default ImageGallery;
