"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Line_1 = __importDefault(require("../Line"));
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        position: 'relative',
        '& img': {
            display: 'block',
            width: '100%',
            height: 'auto',
            objectFit: 'cover',
            flex: '1 1 auto'
        }
    },
    version_masonry: {
        display: 'block',
        height: 'auto'
    }
}), { name: 'amaui-ImageListItem' });
const ImageListItem = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiImageListItem) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const { rows: rows_, columns: columns_, version = 'standard', Component = 'li', className, style, children: children_ } = props, other = __rest(props, ["rows", "columns", "version", "Component", "className", "style", "children"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef()
    };
    const breakpoints = {};
    theme.breakpoints.keys.forEach(key => {
        if (theme.breakpoints.media[key])
            breakpoints[key] = (0, useMediaQuery_1.default)(theme.breakpoints.media[key], { element: refs.root.current });
    });
    const rows = (0, utils_2.valueBreakpoints)(rows_, 1, breakpoints, theme);
    const columns = (0, utils_2.valueBreakpoints)(columns_, 1, breakpoints, theme);
    const styles = {
        root: {}
    };
    if (version !== 'masonry') {
        styles.root.gridRowEnd = `span ${rows}`;
        styles.root.gridColumnEnd = `span ${columns}`;
    }
    const children = react_1.default.Children.toArray(children_);
    if (children.length > 1)
        other.justify = 'flex-end';
    return ((0, jsx_runtime_1.jsx)(Line, Object.assign({ ref: item => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, gap: 0, direction: 'column', align: 'center', justify: 'center', Component: Component, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('ImageListItem', theme) && [
                'amaui-ImageListItem-root'
            ],
            className,
            classes.root,
            classes[`version_${version}`]
        ]), style: Object.assign(Object.assign({}, styles.root), style) }, other, { children: children })));
});
ImageListItem.displayName = 'amaui-ImageListItem';
exports.default = ImageListItem;
