import React from 'react';
import { ILine } from '../Line/Line';
import { ITonal, IColor, IVersion, ISize, IElement, IPropsAny } from '../types';
export interface ILabel extends ILine {
    tonal?: ITonal;
    color?: IColor;
    colorUnchecked?: IColor;
    version?: IVersion;
    size?: ISize;
    position?: 'start' | 'top' | 'bottom' | 'end';
    input?: IElement;
    label?: IElement;
    name?: IElement;
    checkedDefault?: boolean;
    value?: any;
    checked?: any;
    onChange?: (value: boolean, event?: React.ChangeEvent<any>) => any;
    error?: boolean;
    helperText?: string;
    footer?: IElement;
    disabled?: boolean;
    LabelProps?: IPropsAny;
    TypeProps?: IPropsAny;
}
declare const Label: React.FC<ILabel>;
export default Label;
