import React from 'react';
import { IBaseElement, ITonal, IColor, ISize, IStyle, IElement, IPropsAny } from '../types';
export interface ILinearMeter extends IBaseElement {
    tonal?: ITonal;
    color?: IColor;
    size?: ISize;
    parts?: number;
    lineCap?: 'inherit' | 'round' | 'square' | 'butt';
    orientation?: 'vertical' | 'horizontal';
    linePosition?: 'start' | 'center' | 'end';
    width?: number;
    height?: number;
    padding?: number;
    paddingVertical?: number;
    paddingHorizontal?: number;
    gap?: number;
    border?: boolean;
    background?: boolean;
    boundaryWidth?: number;
    lineProgress?: boolean;
    linesVisible?: boolean;
    marksVisible?: boolean;
    labelsVisible?: boolean;
    marks?: Array<{
        size?: number;
        position?: number;
        padding?: number;
        [property: string]: any;
    }>;
    markSize?: number;
    markWidth?: number;
    labels?: Array<{
        value?: number;
        position?: number;
        padding?: number;
        style?: IStyle;
        [property: string]: any;
    }>;
    additional?: IElement;
    textProps?: IPropsAny;
    pathProps?: IPropsAny;
    SvgProps?: IPropsAny;
    MarkProps?: IPropsAny;
    LabelProps?: IPropsAny;
    BackgroundProps?: IPropsAny;
    BorderProps?: IPropsAny;
    LineProps?: IPropsAny;
    LineMainProps?: IPropsAny;
    LinesProgressProps?: IPropsAny;
    LineProgressProps?: IPropsAny;
}
declare const LinearMeter: React.FC<ILinearMeter>;
export default LinearMeter;
