"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const style_react_1 = require("@amaui/style-react");
const Icon_1 = __importDefault(require("../Icon"));
const Section_1 = __importDefault(require("../Section"));
const Menu_1 = __importDefault(require("../Menu"));
const Share_1 = __importDefault(require("../Share"));
const Line_1 = __importDefault(require("../Line"));
const Type_1 = __importDefault(require("../Type"));
const Button_1 = __importDefault(require("../Button"));
const ListItem_1 = __importDefault(require("../ListItem"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Confirm_1 = require("../Confirm");
const utils_1 = require("@amaui/utils");
const utils_2 = require("../utils");
const IconMaterialShareRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'Share', short_name: 'Share', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M18 22q-1.25 0-2.125-.875T15 19q0-.175.025-.363.025-.187.075-.337l-7.05-4.1q-.425.375-.95.587Q6.575 15 6 15q-1.25 0-2.125-.875T3 12q0-1.25.875-2.125T6 9q.575 0 1.1.212.525.213.95.588l7.05-4.1q-.05-.15-.075-.337Q15 5.175 15 5q0-1.25.875-2.125T18 2q1.25 0 2.125.875T21 5q0 1.25-.875 2.125T18 8q-.575 0-1.1-.213-.525-.212-.95-.587L8.9 11.3q.05.15.075.337Q9 11.825 9 12t-.025.362q-.025.188-.075.338l7.05 4.1q.425-.375.95-.588Q17.425 16 18 16q1.25 0 2.125.875T21 19q0 1.25-.875 2.125T18 22Zm0-16q.425 0 .712-.287Q19 5.425 19 5t-.288-.713Q18.425 4 18 4t-.712.287Q17 4.575 17 5t.288.713Q17.575 6 18 6ZM6 13q.425 0 .713-.288Q7 12.425 7 12t-.287-.713Q6.425 11 6 11t-.713.287Q5 11.575 5 12t.287.712Q5.575 13 6 13Zm12 7q.425 0 .712-.288Q19 19.425 19 19t-.288-.712Q18.425 18 18 18t-.712.288Q17 18.575 17 19t.288.712Q17.575 20 18 20Zm0-15ZM6 12Zm12 7Z" }) })));
});
const IconMaterialMoreVertRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'MoreVert', short_name: 'MoreVert', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M12 20q-.825 0-1.412-.587Q10 18.825 10 18q0-.825.588-1.413Q11.175 16 12 16t1.413.587Q14 17.175 14 18q0 .825-.587 1.413Q12.825 20 12 20Zm0-6q-.825 0-1.412-.588Q10 12.825 10 12t.588-1.413Q11.175 10 12 10t1.413.587Q14 11.175 14 12q0 .825-.587 1.412Q12.825 14 12 14Zm0-6q-.825 0-1.412-.588Q10 6.825 10 6t.588-1.412Q11.175 4 12 4t1.413.588Q14 5.175 14 6t-.587 1.412Q12.825 8 12 8Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        padding: `${theme.methods.space.value(5, 'px')} ${theme.methods.space.value(3, 'px')}`
    },
    wrapper: {
        maxWidth: '1024px'
    },
    profile: {
        width: '140px',
        height: '140px',
        borderRadius: theme.methods.shape.radius.value(40, 'px'),
        backgroundSize: 'cover',
        backgroundPosition: 'center',
        backgroundRepeat: 'no-repeat',
        border: `4px solid ${theme.palette.light ? theme.palette.color.primary[99] : theme.palette.color.primary[5]}`,
        cursor: 'default',
        userSelect: 'none'
    },
    cover: {
        height: '100vh',
        maxHeight: '274px',
        borderRadius: theme.methods.shape.radius.value(5, 'px'),
        backgroundSize: 'cover',
        backgroundPosition: 'center',
        backgroundRepeat: 'no-repeat',
        cursor: 'default',
        userSelect: 'none'
    },
    name: {
        wordBreak: 'break-word'
    },
    summary: {
        wordBreak: 'break-word',
        maxWidth: '540px'
    },
    links: {
        marginTop: '40px',
        padding: `0 ${theme.methods.space.value(3, 'px')}`
    },
    linkWrapper: {
        maxWidth: '740px'
    },
    link: {
        '&.amaui-Button-root': {
            whiteSpace: 'normal',
            wordBreak: 'break-word',
            flex: '1 1 auto !important'
        }
    },
    more: {
        flex: '0 0 auto'
    }
}), { name: 'amaui-Links' });
const Element = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiLinks) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Section = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Section) || Section_1.default; }, [theme]);
    const Menu = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Menu) || Menu_1.default; }, [theme]);
    const Share = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Share) || Share_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const Button = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Button) || Button_1.default; }, [theme]);
    const ListItem = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.ListItem) || ListItem_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const { classes } = useStyle();
    const { name, short_description, cover, profile, links, share = true, start, end, IconMore = IconMaterialMoreVertRounded, IconShare = IconMaterialShareRounded, className } = props, other = __rest(props, ["name", "short_description", "cover", "profile", "links", "share", "start", "end", "IconMore", "IconShare", "className"]);
    const confirm = (0, Confirm_1.useConfirm)();
    const onOpenLink = react_1.default.useCallback(async (item) => {
        const confirmed = (item.sensitivity && !['none'].includes(item.sensitivity)) ? await confirm.open({
            name: 'Sensitive URL',
            description: `This is URL might contain sensitive information, confirm you are 18+ to continue.`
        }) : true;
        if (confirmed) {
            window.open(item.url, 'blank');
        }
    }, []);
    return ((0, jsx_runtime_1.jsxs)(Section, Object.assign({ ref: ref, gap: 2, align: 'center', maxWidth: false, padding: false, fullWidth: true, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Links', theme) && [
                'amaui-Links-root'
            ],
            className,
            classes.root
        ]) }, other, { children: [start, (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1.4, fullWidth: true, className: classes.wrapper }, { children: [(profile || cover) && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, align: 'center', fullWidth: true }, { children: [cover && ((0, jsx_runtime_1.jsx)(Line, { fullWidth: true, className: classes.cover, style: {
                                    backgroundImage: `url('${(cover === null || cover === void 0 ? void 0 : cover.url) || (cover === null || cover === void 0 ? void 0 : cover.src) || (cover === null || cover === void 0 ? void 0 : cover.urlSmall) || (cover === null || cover === void 0 ? void 0 : cover.srcSmall)}')`
                                } })), profile && ((0, jsx_runtime_1.jsx)(Line, { fullWidth: true, className: classes.profile, style: {
                                    marginTop: cover ? -71 : 0,
                                    backgroundImage: `url('${(profile === null || profile === void 0 ? void 0 : profile.urlSmall) || (profile === null || profile === void 0 ? void 0 : profile.srcSmall) || (profile === null || profile === void 0 ? void 0 : profile.url) || (profile === null || profile === void 0 ? void 0 : profile.src)}')`
                                } }))] }))), (name || short_description) && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1, align: 'center', fullWidth: true }, { children: [name && ((0, jsx_runtime_1.jsx)(Type, { version: 'h3', align: 'center', fullWidth: true, dangerouslySetInnerHTML: {
                                    __html: (0, utils_1.textToInnerHTML)(name)
                                }, className: classes.name })), short_description && ((0, jsx_runtime_1.jsx)(Type, { version: 'b2', align: 'center', fullWidth: true, dangerouslySetInnerHTML: {
                                    __html: (0, utils_1.textToInnerHTML)(short_description)
                                }, className: classes.summary }))] }))), !!(links === null || links === void 0 ? void 0 : links.length) && ((0, jsx_runtime_1.jsx)(Line, Object.assign({ gap: 1.4, align: 'center', fullWidth: true, className: classes.links }, { children: links.map((item, index) => {
                            var _a;
                            return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1, direction: 'row', align: 'center', justify: 'center', fullWidth: true, className: classes.linkWrapper }, { children: [(0, jsx_runtime_1.jsx)(Button, Object.assign({ tonal: true }, item.props, { version: [undefined, 'default'].includes(item.version) ? 'outlined' : 'filled', elevation: item.version === 'primary', color: item.version === 'primary' ? 'primary' : item.version === 'secondary' ? 'secondary' : 'default', fullWidth: true, onClick: () => onOpenLink(item), className: (0, style_react_1.classNames)([
                                            `amaui-Links-link-version-${item.version}`,
                                            (_a = item.props) === null || _a === void 0 ? void 0 : _a.className,
                                            classes.link
                                        ]) }, { children: item.name || 'Link' })), (0, jsx_runtime_1.jsx)(Menu, Object.assign({ menuItems: [
                                            (0, jsx_runtime_1.jsx)(ListItem, { start: ((0, jsx_runtime_1.jsx)(IconShare, { size: 'small' })), startAlign: 'center', primary: ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3' }, { children: "Share" }))), menu: item.share ? ((0, jsx_runtime_1.jsx)(Share, { version: 'menu-items', name: item.name, url: item.url, ListItemProps: {
                                                        size: 'small',
                                                        noBackground: true
                                                    } })) : undefined, MenuProps: {
                                                    ListProps: {
                                                        noChildrenTransform: true
                                                    }
                                                }, size: 'small', button: true, disabled: !item.share })
                                        ] }, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ size: 'small', className: (0, style_react_1.classNames)([
                                                (0, utils_2.staticClassName)('Links', theme) && [
                                                    'amaui-Links-more'
                                                ],
                                                classes.more
                                            ]), disabled: !item.share }, { children: (0, jsx_runtime_1.jsx)(IconMore, {}) })) }))] }), index));
                        }) })))] })), share && ((0, jsx_runtime_1.jsx)(Share, {})), end] })));
});
Element.displayName = 'amaui-Links';
exports.default = Element;
