import React from 'react';
import { ISurface } from '../Surface/Surface';
import { IColor, IElement, ISize, IHTMLElement, IElementReference, IPropsAny } from '../types';
export interface IListItem extends ISurface {
    colorSelected?: IColor;
    menu?: IElement;
    menuId?: string;
    menuOpen?: boolean;
    openMenu?: boolean;
    openMenuDefault?: boolean;
    openList?: boolean;
    openListDefault?: boolean;
    menuItem?: boolean;
    list?: IElement;
    inset?: boolean;
    primary?: IElement;
    secondary?: IElement;
    tertiary?: IElement;
    preselected?: boolean;
    selected?: boolean;
    start?: IElement;
    startAlign?: 'start' | 'center' | 'end';
    end?: IElement;
    endAlign?: 'start' | 'center' | 'end';
    size?: ISize;
    noPadding?: boolean;
    href?: string;
    button?: boolean;
    shape?: 'round';
    shapePosition?: 'both' | 'start' | 'end' | 'none';
    footer?: IElement;
    include?: Array<IHTMLElement>;
    tabIndex?: string | number;
    menuCloseOnClick?: boolean;
    listCloseOnClick?: boolean;
    interaction?: boolean;
    indicator?: boolean;
    noBackground?: boolean;
    noOutline?: boolean;
    disabled?: boolean;
    onClick?: (event: React.MouseEvent<any>) => any;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    onClose?: () => any;
    RootComponent?: IElementReference;
    ExpandIcon?: IElementReference;
    ListTransitionComponent?: IElementReference;
    WrapperProps?: IPropsAny;
    ListProps?: IPropsAny;
    RootProps?: IPropsAny;
    InteractionProps?: IPropsAny;
    PrimaryProps?: IPropsAny;
    SecondaryProps?: IPropsAny;
    TertiaryProps?: IPropsAny;
    ListTransitionComponentProps?: IPropsAny;
    ExpandProps?: IPropsAny;
    MainProps?: IPropsAny;
    MenuProps?: IPropsAny;
    AsideProps?: IPropsAny;
    AsideStartProps?: IPropsAny;
    AsideEndProps?: IPropsAny;
}
declare const ListItem: React.FC<IListItem>;
export default ListItem;
