"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Surface_1 = __importDefault(require("../Surface"));
const Icon_1 = __importDefault(require("../Icon"));
const Interaction_1 = __importDefault(require("../Interaction"));
const Type_1 = __importDefault(require("../Type"));
const List_1 = __importDefault(require("../List"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Menu_1 = __importDefault(require("../Menu"));
const Expand_1 = __importDefault(require("../Expand"));
const Fade_1 = __importDefault(require("../Fade"));
const utils_2 = require("../utils");
const IconMaterialExpandMoreRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'ExpandMoreRounded', short_name: 'ExpandMore' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M12 14.95Q11.8 14.95 11.625 14.887Q11.45 14.825 11.3 14.675L6.675 10.05Q6.4 9.775 6.413 9.362Q6.425 8.95 6.7 8.675Q6.975 8.4 7.4 8.4Q7.825 8.4 8.1 8.675L12 12.575L15.925 8.65Q16.2 8.375 16.613 8.387Q17.025 8.4 17.3 8.675Q17.575 8.95 17.575 9.375Q17.575 9.8 17.3 10.075L12.7 14.675Q12.55 14.825 12.375 14.887Q12.2 14.95 12 14.95Z" }) })));
});
const IconMaterialArrowRightRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'ArrowRightRounded', short_name: 'ArrowRight' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M11.7 15.3Q11.225 15.775 10.613 15.512Q10 15.25 10 14.575V9.425Q10 8.75 10.613 8.488Q11.225 8.225 11.7 8.7L14.3 11.3Q14.45 11.45 14.525 11.625Q14.6 11.8 14.6 12Q14.6 12.2 14.525 12.375Q14.45 12.55 14.3 12.7Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => {
    const overflow = {
        width: '100%',
        overflow: 'hidden',
        textOverflow: 'ellipsis'
    };
    return {
        wrapper: {
            width: '100%'
        },
        root: {
            // Reset
            margin: '0',
            padding: '0',
            '-webkit-appearance': 'none',
            appearance: 'none',
            border: 'none',
            textDecoration: 'none',
            color: 'inherit',
            boxSizing: 'border-box',
            position: 'relative',
            display: 'inline-flex',
            width: '100%'
        },
        shape_round_position_both: {
            borderRadius: theme.methods.shape.radius.value(40, 'px')
        },
        shape_round_position_start: {
            borderEndStartRadius: theme.methods.shape.radius.value(40, 'px'),
            borderStartStartRadius: theme.methods.shape.radius.value(40, 'px')
        },
        shape_round_position_end: {
            borderStartEndRadius: theme.methods.shape.radius.value(40, 'px'),
            borderEndEndRadius: theme.methods.shape.radius.value(40, 'px')
        },
        shape_round_position_none: {
            borderRadius: '0'
        },
        button: {
            cursor: 'pointer',
            userSelect: 'none'
        },
        size_small: {
            padding: `${theme.methods.space.value('rg') * 0.5}px ${theme.methods.space.value('rg') * 0.75}px`,
            minHeight: '24px'
        },
        size_regular: {
            padding: `${theme.methods.space.value('rg')}px ${theme.methods.space.value('rg')}px`,
            minHeight: '40px'
        },
        size_large: {
            padding: `${theme.methods.space.value('rg') * 1.5}px ${theme.methods.space.value('rg') * 1.25}px`,
            minHeight: '56px'
        },
        menuItem_size_small: {
            padding: `${theme.methods.space.value('sm') * 0.5}px ${theme.methods.space.value('rg') * 0.75}px`
        },
        menuItem_size_regular: {
            padding: `${theme.methods.space.value('sm') * 0.75}px ${theme.methods.space.value('rg')}px`
        },
        menuItem_size_large: {
            padding: `${theme.methods.space.value('sm') * 1}px ${theme.methods.space.value('rg') * 1.25}px`
        },
        inset_size_small: {
            paddingInlineStart: `${(56 + theme.methods.space.value('rg')) * 0.75}px`
        },
        inset_size_regular: {
            paddingInlineStart: `${56 + theme.methods.space.value('rg')}px`
        },
        inset_size_large: {
            paddingInlineStart: `${(56 + theme.methods.space.value('rg')) * 1.25}px`
        },
        menuItem_inset_size_small: {
            paddingInlineStart: theme.methods.space.value(7, 'px')
        },
        menuItem_inset_size_regular: {
            paddingInlineStart: theme.methods.space.value(7, 'px')
        },
        menuItem_inset_size_large: {
            paddingInlineStart: theme.methods.space.value(7, 'px')
        },
        middle: {
            position: 'relative',
            display: 'inline-flex',
            flex: '1 1 auto',
            width: '100%',
            flexDirection: 'column',
            // Fix for white-space: nowrap & flex: 1 1 auto
            minWidth: '0',
            alignSelf: 'center'
        },
        menuItem_middle: {
            marginInlineEnd: '44px'
        },
        text: Object.assign(Object.assign({}, overflow), { whiteSpace: 'pre-wrap', textAlign: 'start' }),
        text_primary: {
            opacity: '1'
        },
        text_primary_weight: {
            fontWeight: '500'
        },
        text_secondary: {
            opacity: theme.palette.visual_contrast.default.opacity.primary
        },
        text_tertiary: {
            opacity: theme.palette.visual_contrast.default.opacity.secondary
        },
        aside: {
            position: 'relative',
            display: 'inline-flex',
            flex: '0 0 auto',
            alignSelf: 'flex-start'
        },
        align_start: {
            alignSelf: 'flex-start'
        },
        align_center: {
            alignSelf: 'center'
        },
        align_end: {
            alignSelf: 'flex-end'
        },
        start_icon: {
            paddingInline: `0 ${theme.methods.space.value(1.5, 'px')}`
        },
        start_button: {
            paddingInline: `0 ${theme.methods.space.value(1.5, 'px')}`
        },
        start_switch: {
            paddingInline: `0 ${theme.methods.space.value(1.5, 'px')}`
        },
        menuItem_start_icon: {
            paddingInlineEnd: theme.methods.space.value(2, 'px')
        },
        menuItem_start_button: {
            paddingInlineEnd: theme.methods.space.value(1.5, 'px')
        },
        menuItem_start_switch: {
            paddingInlineEnd: theme.methods.space.value(1.5, 'px')
        },
        end_icon: {
            paddingInlineStart: theme.methods.space.value(1.5, 'px'),
            paddingInlineEnd: theme.methods.space.value(1, 'px')
        },
        end_button: {
            paddingInlineStart: theme.methods.space.value(1.5, 'px'),
            paddingInlineEnd: '0'
        },
        end_switch: {
            paddingInlineStart: theme.methods.space.value(1.5, 'px'),
            paddingInlineEnd: '0'
        },
        menuItem_end_icon: {
            paddingInlineStart: theme.methods.space.value(1.5, 'px')
        },
        menuItem_end_button: {
            paddingInlineStart: theme.methods.space.value(1.5, 'px')
        },
        menuItem_end_switch: {
            paddingInlineStart: theme.methods.space.value(1.5, 'px')
        },
        middle_disabled: {
            opacity: theme.palette.visual_contrast.default.opacity.disabled
        },
        icon: {
            transition: theme.methods.transitions.make('transform')
        },
        icon_open: {
            transform: 'rotate(-180deg)'
        },
        noPadding: {
            padding: '0px'
        },
        noBackground: {
            '&.amaui-Surface-root': {
                background: 'none'
            }
        },
        disabled: {
            pointerEvents: 'none',
            userSelect: 'none',
            cursor: 'default'
        }
    };
}, { name: 'amaui-ListItem' });
const ListItemDelays = {
    Transition: {
        enter: 70
    }
};
const ListItem = react_1.default.forwardRef((props_, ref) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiListItem) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Interaction = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Interaction) || Interaction_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const List = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.List) || List_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const Menu = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Menu) || Menu_1.default; }, [theme]);
    const Expand = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Expand) || Expand_1.default; }, [theme]);
    const Fade = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Fade) || Fade_1.default; }, [theme]);
    const { tonal = true, color = 'default', colorSelected = props.color, menu, menuId, menuOpen, openMenu: openMenu_, openMenuDefault, openList: openList_, openListDefault, menuItem, list: list_, inset, primary = props.children, secondary, tertiary, preselected, selected, start, startAlign = props.menuItem ? 'center' : 'start', end: end_, endAlign = 'center', size = 'regular', noPadding, href, button, shape = 'round', shapePosition = 'none', footer, include, tabIndex, menuCloseOnClick, listCloseOnClick, interaction, indicator = true, noOutline, noBackground, disabled, onClick: onClick_, onFocus: onFocus_, onBlur: onBlur_, onMouseEnter: onMouseEnter_, onMouseLeave: onMouseLeave_, onClose: onClose_, RootComponent: RootComponent_ = 'div', ExpandIcon = IconMaterialExpandMoreRounded, ListTransitionComponent = Fade, WrapperProps, ListProps, RootProps, InteractionProps, PrimaryProps, SecondaryProps, TertiaryProps, ListTransitionComponentProps: ListTransitionComponentProps_, ExpandProps, MainProps, AsideProps, AsideStartProps, AsideEndProps, MenuProps = {
        autoSelect: true
    }, Component = 'li', className, style, children } = props, other = __rest(props, ["tonal", "color", "colorSelected", "menu", "menuId", "menuOpen", "openMenu", "openMenuDefault", "openList", "openListDefault", "menuItem", "list", "inset", "primary", "secondary", "tertiary", "preselected", "selected", "start", "startAlign", "end", "endAlign", "size", "noPadding", "href", "button", "shape", "shapePosition", "footer", "include", "tabIndex", "menuCloseOnClick", "listCloseOnClick", "interaction", "indicator", "noOutline", "noBackground", "disabled", "onClick", "onFocus", "onBlur", "onMouseEnter", "onMouseLeave", "onClose", "RootComponent", "ExpandIcon", "ListTransitionComponent", "WrapperProps", "ListProps", "RootProps", "InteractionProps", "PrimaryProps", "SecondaryProps", "TertiaryProps", "ListTransitionComponentProps", "ExpandProps", "MainProps", "AsideProps", "AsideStartProps", "AsideEndProps", "MenuProps", "Component", "className", "style", "children"]);
    const { classes } = useStyle();
    const [openMenu, setOpenMenu] = react_1.default.useState(openMenuDefault !== undefined ? openMenuDefault : openMenu_);
    const [openList, setOpenList] = react_1.default.useState(openListDefault !== undefined ? openListDefault : openList_);
    const [hover, setHover] = react_1.default.useState(false);
    const [focus, setFocus] = react_1.default.useState(false);
    const refs = {
        root: react_1.default.useRef(),
        props: react_1.default.useRef(),
        openMenu: react_1.default.useRef(),
        openList: react_1.default.useRef(),
        focus: react_1.default.useRef(),
        ids: {
            primary: react_1.default.useId(),
            secondary: react_1.default.useId()
        }
    };
    refs.props.current = props;
    refs.openMenu.current = openMenu;
    refs.openList.current = openList;
    refs.focus.current = focus;
    const styles = {
        root: {},
        icon: { color: 'default' },
        wrapper: {},
        primary: {},
        secondary: {},
        tertiary: {}
    };
    let RootComponent = RootComponent_;
    const ListTransitionComponentProps = Object.assign({ add: true, delay: {
            enter: ListItemDelays.Transition.enter
        } }, ListTransitionComponentProps_);
    const list = list_ && react_1.default.Children.toArray(list_).map((item, index) => (react_1.default.cloneElement(item, Object.assign({ key: index, onClick: (event) => {
            if (item.props.listCloseOnClick)
                onCloseList();
            if ((0, utils_1.is)('function', item.props.onClick))
                item.props.onClick(event);
        } }, item === null || item === void 0 ? void 0 : item.props))));
    const onClick = react_1.default.useCallback((event) => {
        if (!refs.props.current.disabled) {
            if (refs.props.current.list)
                setOpenList(!refs.openList.current);
        }
        if ((0, utils_1.is)('function', onClick_))
            onClick_(event);
    }, [onClick_]);
    let end = end_;
    if (menu)
        end = end_ || (0, jsx_runtime_1.jsx)(IconMaterialArrowRightRounded, {});
    if (list)
        end = end_ || (indicator && ((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ size: 24, fontSize: 24, onClick: onClick, className: (0, style_react_1.classNames)([
                (0, utils_2.staticClassName)('ListItem', theme) && [
                    'amaui-ListItem-icon-button'
                ],
                classes.iconButton
            ]) }, { children: (0, jsx_runtime_1.jsx)(ExpandIcon, { className: (0, style_react_1.classNames)([
                    classes.icon,
                    openList && classes.icon_open
                ]) }) }))));
    react_1.default.useEffect(() => {
        var _a;
        const onKeyDown = (event) => {
            if (!refs.props.current.disabled) {
                if (menu) {
                    if (refs.openMenu.current && ((theme.direction === 'ltr' && event.key === 'ArrowLeft') || (theme.direction === 'rtl' && event.key === 'ArrowRight')))
                        setOpenMenu(false);
                    if (!refs.openMenu.current && ((theme.direction === 'ltr' && event.key === 'ArrowRight') || (theme.direction === 'rtl' && event.key === 'ArrowLeft')))
                        setOpenMenu(true);
                }
                else if (list) {
                    if (refs.openList.current && (event.key === 'ArrowUp' || (theme.direction === 'ltr' && event.key === 'ArrowLeft') || (theme.direction === 'rtl' && event.key === 'ArrowRight')))
                        setOpenMenu(false);
                    if (!refs.openList.current && (event.key === 'ArrowDown' || (theme.direction === 'ltr' && event.key === 'ArrowRight') || (theme.direction === 'rtl' && event.key === 'ArrowLeft')))
                        setOpenMenu(true);
                    if (event.key === 'Enter' && refs.focus.current)
                        onClick();
                }
                else {
                    if (event.key === 'Enter' && !refs.props.current.button && refs.focus.current) {
                        if ((0, utils_1.is)('function', refs.props.current.onClick))
                            refs.props.current.onClick(event);
                    }
                }
            }
        };
        const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        rootDocument.addEventListener('keydown', onKeyDown);
        return () => {
            rootDocument.removeEventListener('keydown', onKeyDown);
        };
    }, []);
    react_1.default.useEffect(() => {
        if (openMenu_ !== openMenu)
            setOpenMenu(openMenu_);
    }, [openMenu_]);
    react_1.default.useEffect(() => {
        if (openList_ !== openList)
            setOpenList(openList_);
    }, [openList_]);
    react_1.default.useEffect(() => {
        if (menuOpen && preselected)
            refs.root.current.focus();
    }, [preselected, menuOpen]);
    react_1.default.useEffect(() => {
        if (menu)
            setOpenMenu(hover || preselected || selected);
    }, [hover]);
    react_1.default.useEffect(() => {
        if (menu)
            setOpenMenu(hover || focus || preselected || selected);
    }, [focus]);
    const onMouseEnter = react_1.default.useCallback((event) => {
        if (!disabled)
            setHover(true);
        if ((0, utils_1.is)('function', onMouseEnter_))
            onMouseEnter_(event);
    }, []);
    const onMouseLeave = react_1.default.useCallback((event) => {
        if (!disabled) {
            setHover(false);
            setFocus(false);
        }
        if ((0, utils_1.is)('function', onMouseLeave_))
            onMouseLeave_(event);
    }, []);
    const onFocus = react_1.default.useCallback((event) => {
        if (event.target === event.currentTarget && !disabled)
            setFocus(true);
        if ((0, utils_1.is)('function', onFocus_))
            onFocus_(event);
    }, []);
    const onBlur = react_1.default.useCallback((event) => {
        if (event.target === event.currentTarget && !disabled)
            setFocus(false);
        if ((0, utils_1.is)('function', onBlur_))
            onBlur_(event);
    }, []);
    const onCloseList = react_1.default.useCallback(() => {
        if (!disabled) {
            setOpenList(false);
            setHover(false);
            setFocus(false);
            // if (is('function', onClose_)) onClose_();
        }
    }, []);
    const onCloseMenu = react_1.default.useCallback(() => {
        if (!disabled) {
            setOpenMenu(false);
            setHover(false);
            setFocus(false);
            // if (is('function', onClose_)) onClose_();
        }
    }, []);
    if (href)
        RootComponent = 'a';
    const isSelected = selected !== undefined ? selected : openMenu || openList;
    const colorToUse = isSelected ? colorSelected : color;
    ListTransitionComponentProps.in = !!openList;
    return ((0, jsx_runtime_1.jsxs)(Surface, Object.assign({ ref: item => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else if (ref === null || ref === void 0 ? void 0 : ref.current)
                    ref.current = item;
            }
            refs.root.current = item;
        }, tonal: tonal, color: colorToUse, tabIndex: tabIndex !== undefined ? tabIndex : (button && !disabled) ? 0 : undefined, onFocus: onFocus, onBlur: onBlur, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave, "aria-labelledby": refs.ids.primary, "aria-describedby": refs.ids.secondary, "aria-selected": selected, "aria-haspopup": !!menu, "aria-expanded": openMenu, Component: Component }, WrapperProps, { className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('ListItem', theme) && [
                'amaui-ListItem-wrapper'
            ],
            WrapperProps === null || WrapperProps === void 0 ? void 0 : WrapperProps.className,
            className,
            classes.wrapper,
            noBackground && classes.noBackground
        ]), noOutline: noOutline, style: styles.wrapper }, other, { children: [(0, jsx_runtime_1.jsxs)(RootComponent, Object.assign({ href: href, onClick: onClick, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('ListItem', theme) && [
                        'amaui-ListItem-root',
                        menu && `amaui-ListItem-menu`,
                        list && `amaui-ListItem-list`,
                        menuItem && `amaui-ListItem-menu-item`,
                        menuOpen && `amaui-ListItem-menu-open`,
                        openMenu && `amaui-ListItem-open-menu`,
                        openList && `amaui-ListItem-open-list`,
                        preselected && `amaui-ListItem-preselected`,
                        isSelected && `amaui-ListItem-selected`,
                        hover && `amaui-ListItem-hover`,
                        focus && `amaui-ListItem-focus`,
                        disabled && `amaui-ListItem-disabled`,
                        inset && !start && `amaui-ListItem-inset`,
                        menuItem && [
                            inset && `amaui-ListItem-menu-item-inset`
                        ],
                    ],
                    classes.root,
                    !menuItem && classes[`size_${size}`],
                    classes[`shape_${shape}_position_${shapePosition}`],
                    inset && !start && classes[`inset_size_${size}`],
                    menuItem && [
                        classes[`menuItem_size_${size}`],
                        inset && classes[`menuItem_inset_size_${size}`]
                    ],
                    (href || button) && classes.button,
                    noPadding && classes.noPadding,
                    disabled && classes.disabled
                ]), style: Object.assign(Object.assign({}, style), styles.root), disabled: disabled }, RootProps, { children: [(href || button || interaction) && ((0, jsx_runtime_1.jsx)(Interaction, Object.assign({ border: false, preselected: focus || preselected || undefined, selected: isSelected, disabled: disabled }, InteractionProps))), start && ((0, jsx_runtime_1.jsx)("span", Object.assign({}, AsideProps, AsideStartProps, { className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('ListItem', theme) && [
                                'amaui-ListItem-aside',
                                'amaui-ListItem-start',
                                `amaui-ListItem-start-${['amaui-Avatar', 'amaui-IconButton', 'amaui-Checkbox', 'amaui-Radio'].includes((_a = start === null || start === void 0 ? void 0 : start.type) === null || _a === void 0 ? void 0 : _a.displayName) ? 'button' : ['amaui-Switch'].includes((_b = start === null || start === void 0 ? void 0 : start.type) === null || _b === void 0 ? void 0 : _b.displayName) ? 'switch' : 'icon'}`
                            ],
                            AsideProps === null || AsideProps === void 0 ? void 0 : AsideProps.className,
                            AsideStartProps === null || AsideStartProps === void 0 ? void 0 : AsideStartProps.className,
                            classes.aside,
                            classes.start,
                            classes[`align_${startAlign}`],
                            classes[`${menuItem ? 'menuItem_' : ''}start_${['amaui-Avatar', 'amaui-IconButton', 'amaui-Checkbox', 'amaui-Radio'].includes((_c = start === null || start === void 0 ? void 0 : start.type) === null || _c === void 0 ? void 0 : _c.displayName) ? 'button' : ['amaui-Switch'].includes((_d = start === null || start === void 0 ? void 0 : start.type) === null || _d === void 0 ? void 0 : _d.displayName) ? 'switch' : 'icon'}`]
                        ]) }, { children: (0, utils_1.is)('string', start) ? start : react_1.default.cloneElement(start, {
                            color: ((_e = start.props) === null || _e === void 0 ? void 0 : _e.color) || 'inherit',
                            size: ((_f = start.props) === null || _f === void 0 ? void 0 : _f.size) !== undefined ? (_g = start.props) === null || _g === void 0 ? void 0 : _g.size : ['amaui-Switch'].includes((_h = start === null || start === void 0 ? void 0 : start.type) === null || _h === void 0 ? void 0 : _h.displayName) ? 'small' : 'regular',
                            disabled
                        }) }))), (0, jsx_runtime_1.jsxs)("span", Object.assign({}, MainProps, { className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('ListItem', theme) && [
                                'amaui-ListItem-middle'
                            ],
                            MainProps === null || MainProps === void 0 ? void 0 : MainProps.className,
                            classes.middle,
                            menuItem && classes.menuItem_middle,
                            disabled && classes.middle_disabled
                        ]) }, { children: [primary !== undefined && ((0, utils_1.is)('simple', primary) ? ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b2', id: refs.ids.primary }, PrimaryProps, { className: (0, style_react_1.classNames)([
                                    (0, utils_2.staticClassName)('ListItem', theme) && [
                                        'amaui-ListItem-text',
                                        'amaui-ListItem-text-primary'
                                    ],
                                    PrimaryProps === null || PrimaryProps === void 0 ? void 0 : PrimaryProps.className,
                                    classes.text,
                                    classes.text_primary,
                                    !menuItem && classes.text_primary_weight
                                ]), style: Object.assign(Object.assign({}, styles.primary), PrimaryProps === null || PrimaryProps === void 0 ? void 0 : PrimaryProps.style) }, { children: primary }))) : react_1.default.cloneElement(primary, {
                                id: refs.ids.primary
                            })), secondary !== undefined && ((0, utils_1.is)('simple', secondary) ? ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b2', id: refs.ids.secondary }, SecondaryProps, { className: (0, style_react_1.classNames)([
                                    (0, utils_2.staticClassName)('ListItem', theme) && [
                                        'amaui-ListItem-text',
                                        'amaui-ListItem-text-secondary'
                                    ],
                                    SecondaryProps === null || SecondaryProps === void 0 ? void 0 : SecondaryProps.className,
                                    classes.text,
                                    classes.text_secondary
                                ]), style: Object.assign(Object.assign({}, styles.secondary), SecondaryProps === null || SecondaryProps === void 0 ? void 0 : SecondaryProps.style) }, { children: secondary }))) : react_1.default.cloneElement(secondary, {
                                id: refs.ids.secondary
                            })), tertiary !== undefined && ((0, utils_1.is)('simple', tertiary) ? ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b2' }, TertiaryProps, { className: (0, style_react_1.classNames)([
                                    (0, utils_2.staticClassName)('ListItem', theme) && [
                                        'amaui-ListItem-text',
                                        'amaui-ListItem-text-tertiary'
                                    ],
                                    TertiaryProps === null || TertiaryProps === void 0 ? void 0 : TertiaryProps.className,
                                    classes.text,
                                    classes.text_tertiary
                                ]), style: Object.assign(Object.assign({}, styles.tertiary), TertiaryProps === null || TertiaryProps === void 0 ? void 0 : TertiaryProps.style) }, { children: tertiary }))) : tertiary)] })), end && ((0, jsx_runtime_1.jsx)("span", Object.assign({}, AsideProps, AsideEndProps, { className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('ListItem', theme) && [
                                'amaui-ListItem-aside',
                                'amaui-ListItem-end',
                                `amaui-ListItem-end-${['amaui-Avatar', 'amaui-IconButton', 'amaui-Checkbox', 'amaui-Radio'].includes((_j = end === null || end === void 0 ? void 0 : end.type) === null || _j === void 0 ? void 0 : _j.displayName) ? 'button' : ['amaui-Switch'].includes((_k = end === null || end === void 0 ? void 0 : end.type) === null || _k === void 0 ? void 0 : _k.displayName) ? 'switch' : 'icon'}`
                            ],
                            AsideProps === null || AsideProps === void 0 ? void 0 : AsideProps.className,
                            AsideEndProps === null || AsideEndProps === void 0 ? void 0 : AsideEndProps.classname,
                            classes.aside,
                            classes.end,
                            classes[`align_${endAlign}`],
                            classes[`${menuItem ? 'menuItem_' : ''}end_${['amaui-Avatar', 'amaui-IconButton', 'amaui-Checkbox', 'amaui-Radio'].includes((_l = end === null || end === void 0 ? void 0 : end.type) === null || _l === void 0 ? void 0 : _l.displayName) ? 'button' : ['amaui-Switch'].includes((_m = end === null || end === void 0 ? void 0 : end.type) === null || _m === void 0 ? void 0 : _m.displayName) ? 'switch' : 'icon'}`]
                        ]) }, { children: (0, utils_1.is)('string', end) ? end : react_1.default.cloneElement(end, {
                            color: ((_o = end.props) === null || _o === void 0 ? void 0 : _o.color) || 'inherit',
                            size: ((_p = end.props) === null || _p === void 0 ? void 0 : _p.size) !== undefined ? (_q = end.props) === null || _q === void 0 ? void 0 : _q.size : ['amaui-Switch'].includes((_r = end === null || end === void 0 ? void 0 : end.type) === null || _r === void 0 ? void 0 : _r.displayName) ? 'small' : 'regular',
                            disabled
                        }) })))] })), footer, (0, jsx_runtime_1.jsx)(Expand, Object.assign({ in: openList, parent: refs.root.current }, ExpandProps, { children: (0, jsx_runtime_1.jsx)(ListTransitionComponent, Object.assign({}, ListTransitionComponentProps, { children: (0, jsx_runtime_1.jsx)(List, Object.assign({ indent: 5 }, ListProps, { className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('ListItem', theme) && [
                                'amaui-ListItem-list'
                            ],
                            ListProps === null || ListProps === void 0 ? void 0 : ListProps.className,
                            classes.list
                        ]) }, { children: list })) })) })), menu && ((0, jsx_runtime_1.jsx)(Menu, Object.assign({ open: !!openMenu, include: include, onClose: onCloseMenu, closeOnClickAway: false, anchorElement: refs.root.current, menuItems: menu, transformOrigin: 'left top', transformOriginSwitch: 'right top', transformOriginRtl: 'left top', transformOriginRtlSwitch: 'right top', position: 'right', alignment: 'start', onMouseEnter: onMouseEnter }, MenuProps)))] })));
});
ListItem.displayName = 'amaui-ListItem';
exports.default = ListItem;
