"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Fade_1 = __importDefault(require("../Fade"));
const LinearProgress_1 = __importDefault(require("../LinearProgress"));
const Context_1 = __importDefault(require("./Context"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        zIndex: theme.z_index.tooltip - 14,
        '&.amaui-LinearProgress-root': {
            height: '2px'
        },
        '& .amaui-LinearProgress-buffer': {
            background: 'transparent'
        }
    },
    fixed: {
        insetInline: '0',
        '&.amaui-LinearProgress-root': {
            position: 'fixed'
        }
    },
    position_top: {
        top: '0'
    },
    position_bottom: {
        bottom: '0'
    }
}), { name: 'amaui-MainProgress' });
const MainProgress = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiMainProgress) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Fade = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Fade) || Fade_1.default; }, [theme]);
    const LinearProgress = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.LinearProgress) || LinearProgress_1.default; }, [theme]);
    const { min = 0, max = 99, firstIncrement = true, incrementMin = 4, incrementMax = 14, stepMin = 1, stepMax = 4, stepInterval = 700, onStart, onIncrement, onUpdate, onDone, fixed = true, position = 'top', TransitionComponent = Fade, TransitionComponentProps = {}, className, children } = props, other = __rest(props, ["min", "max", "firstIncrement", "incrementMin", "incrementMax", "stepMin", "stepMax", "stepInterval", "onStart", "onIncrement", "onUpdate", "onDone", "fixed", "position", "TransitionComponent", "TransitionComponentProps", "className", "children"]);
    const { classes } = useStyle();
    const [inProp, setInProp] = react_1.default.useState(false);
    const [value, setValue] = react_1.default.useState(min);
    const refs = {
        value_: react_1.default.useRef({}),
        value: react_1.default.useRef(),
        min: react_1.default.useRef(),
        max: react_1.default.useRef(),
        firstIncrement: react_1.default.useRef(),
        incrementMin: react_1.default.useRef(),
        incrementMax: react_1.default.useRef(),
        stepInterval: react_1.default.useRef(),
        stepMin: react_1.default.useRef(),
        stepMax: react_1.default.useRef(),
        TransitionComponentProps: react_1.default.useRef(),
        linearProgress: react_1.default.useRef(),
        interval: react_1.default.useRef(),
        props: react_1.default.useRef()
    };
    refs.value.current = value;
    refs.props.current = props;
    refs.min.current = min;
    refs.max.current = max;
    refs.firstIncrement.current = firstIncrement;
    refs.incrementMin.current = incrementMin;
    refs.incrementMax.current = incrementMax;
    refs.stepInterval.current = stepInterval;
    refs.stepMin.current = stepMin;
    refs.stepMax.current = stepMax;
    refs.TransitionComponentProps.current = TransitionComponentProps;
    const clear = () => {
        if (refs.interval.current) {
            clearInterval(refs.interval.current);
            refs.interval.current = undefined;
        }
    };
    const start = react_1.default.useCallback((value_) => {
        // Reset
        clear();
        // Update
        refs.linearProgress.current = value_;
        // Open
        setInProp(true);
        // Set initial value to min
        const min_ = refs.min.current !== undefined ? refs.min.current : 0;
        const max_ = refs.max.current !== undefined ? refs.max.current : 0;
        setValue(min_);
        // start inc interval for steps
        // in refs.interval
        // in interval, remove interval if value is >= max
        if (min_ < max_) {
            const stepInterval_ = refs.stepInterval.current !== undefined ? refs.stepInterval.current : 700;
            refs.interval.current = setInterval(() => {
                if (refs.value.current >= max_)
                    clearInterval(refs.interval.current);
                setValue(previousValue => (0, utils_1.clamp)(previousValue + (0, utils_1.random)(refs.stepMin.current, refs.stepMax.current), refs.min.current, refs.max.current));
            }, stepInterval_);
        }
        if ((0, utils_1.is)('function', onStart))
            onStart();
    }, []);
    const increment = react_1.default.useCallback(() => {
        // Inc value random between incrementMin, incrementMax, with clam to min, max
        let valueNew = refs.value.current;
        valueNew += (0, utils_1.clamp)((0, utils_1.random)(refs.incrementMin.current, refs.incrementMax.current), refs.min.current, refs.max.current);
        setValue(valueNew);
        if ((0, utils_1.is)('function', onIncrement))
            onIncrement(valueNew);
    }, []);
    const update = react_1.default.useCallback((value_) => {
        const valueNew = value_;
        setValue(valueNew);
        if ((0, utils_1.is)('function', onUpdate))
            onUpdate(valueNew);
    }, []);
    const done = react_1.default.useCallback(async () => {
        clear();
        // Update value to 100
        setValue(100);
        // Update inProp to false with the timeout value
        const timeout = theme.transitions.duration.rg + 44;
        await (0, utils_1.wait)(timeout);
        setInProp(false);
        if ((0, utils_1.is)('function', onDone))
            onDone();
    }, []);
    const onExited = () => {
        // Reset
        setValue(0);
    };
    react_1.default.useEffect(() => {
        if (inProp) {
            if (refs.firstIncrement.current)
                increment();
        }
    }, [inProp]);
    TransitionComponentProps.in = inProp;
    refs.value_.current.start = start;
    refs.value_.current.increment = increment;
    refs.value_.current.update = update;
    refs.value_.current.done = done;
    return ((0, jsx_runtime_1.jsxs)(Context_1.default.Provider, Object.assign({ value: refs.value_.current }, { children: [(0, jsx_runtime_1.jsx)(TransitionComponent, Object.assign({ in: inProp, onExited: onExited }, TransitionComponentProps, { children: (0, jsx_runtime_1.jsx)(LinearProgress, Object.assign({ ref: ref, value: value, version: 'determinate', className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('MainProgress', theme) && [
                            `amaui-MainProgress-root`
                        ],
                        className,
                        classes.root,
                        classes[`position_${position}`],
                        fixed && classes.fixed
                    ]) }, other, refs.linearProgress.current)) })), children] })));
});
MainProgress.displayName = 'amaui-MainProgress';
exports.default = MainProgress;
