import React from 'react';
import { ILine } from '../Line/Line';
import { IMediaObject, IPropsAny } from '../types';
export interface IMediasItem {
    value: IMediaObject;
    props?: any;
}
export declare type IMediasMediaVersion = 'image' | 'audio' | 'video' | 'other';
export interface IMedias extends ILine {
    size?: 'small' | 'regular' | 'large';
    values?: IMediasItem | IMediasItem[];
    imageGallery?: boolean;
    show?: IMediasMediaVersion[];
    noName?: boolean;
    IconDocument?: any;
    NameProps?: IPropsAny;
    WrapperProps?: IPropsAny;
    ImageProps?: IPropsAny;
    AudioProps?: IPropsAny;
    VideoProps?: IPropsAny;
    OtherProps?: IPropsAny;
    ItemsProps?: IPropsAny;
    ImageItemsProps?: IPropsAny;
    AudioItemsProps?: IPropsAny;
    VideoItemsProps?: IPropsAny;
    OtherItemsProps?: IPropsAny;
}
declare const Medias: React.FC<IMedias>;
export default Medias;
