import React from 'react';
import { ITooltip } from '../Tooltip/Tooltip';
import { IElement, IHTMLElement, IPropsAny } from '../types';
export declare const MENUS: {
    open: any[];
    priority: (value: any) => boolean;
    add: (value: any) => void;
    remove: (value: any) => void;
};
export interface IMenu extends Omit<ITooltip, 'name' | 'label'> {
    open?: boolean;
    openDefault?: boolean;
    name?: ((method: (item: any, index: number) => any) => any) | IElement;
    label?: ((method: (item: any, index: number) => any) => any) | IElement;
    menuItems?: Array<IElement>;
    include?: Array<IHTMLElement>;
    includeParentQueries?: Array<string>;
    includeQueries?: Array<string>;
    ignoreNonExisting?: boolean;
    autoSelect?: boolean;
    autoSelectOnBlur?: boolean;
    resetKeyboardNavigation?: boolean;
    closeOnClickAway?: boolean;
    onSelect?: (value: any) => any;
    onOpen?: () => any;
    onClose?: () => any;
    ListProps?: IPropsAny;
    ModalProps?: IPropsAny;
    WrapperProps?: IPropsAny;
    ClickListenerProps?: IPropsAny;
}
declare const Menu: React.FC<IMenu>;
export default Menu;
