import React from 'react';
import { TTransitionStatus } from '../Transition';
import { ILine } from '../Line/Line';
import { IElement, ITonal, IStyle, IElementReference, IPropsAny, IVersion, IColor } from '../types';
export declare type TMenuDesktopValue = string | number;
export declare type TMenuDesktopItem = {
    value?: TMenuDesktopValue;
    label?: IElement;
    name?: IElement;
    menu?: IElement;
    disabled?: boolean;
};
export interface IMenuDesktop extends ILine {
    tonal?: ITonal;
    color?: IColor;
    version?: IVersion;
    items?: Array<TMenuDesktopItem>;
    valueDefault?: TMenuDesktopValue;
    value_?: TMenuDesktopValue;
    openOnHover?: boolean;
    openOnClick?: boolean;
    openOnFocus?: boolean;
    renderItem?: (item: TMenuDesktopItem, index: number) => any;
    indicator?: boolean;
    menuTransition?: boolean;
    menuTransitionClassName?: (status: TTransitionStatus, open: TMenuDesktopValue) => string;
    menuTransitionStyle?: (status: TTransitionStatus, open: TMenuDesktopValue) => IStyle;
    onOpen?: () => any;
    onClose?: () => any;
    onChange?: (value: TMenuDesktopValue) => any;
    TransitionComponent?: IElementReference;
    IconIndicator?: IElementReference;
    AppendProps?: IPropsAny;
    TypeProps?: IPropsAny;
    ItemProps?: IPropsAny;
    IconProps?: IPropsAny;
    TransitionComponentProps?: IPropsAny;
    WrapperProps?: IPropsAny;
    WrapperMenuProps?: IPropsAny;
}
declare const MenuDesktop: React.FC<IMenuDesktop>;
export default MenuDesktop;
