import React from 'react';
import { TMethod } from '@amaui/utils';
import { IBaseElement, IColor, IElementReference, IPropsAny, IRef, ISize, ITonal } from '../types';
export interface IModal extends IBaseElement {
    tonal?: ITonal;
    color?: IColor;
    size?: ISize;
    open?: boolean;
    openDefault?: boolean;
    mainRef?: IRef;
    backgroundRef?: IRef;
    partialyOpened?: boolean | number;
    minWidth?: 'xss' | 'xs' | 'sm' | 'rg' | 'lg' | 'xl' | 'xxl';
    maxWidth?: 'xss' | 'xs' | 'sm' | 'rg' | 'lg' | 'xl' | 'xxl';
    fullScreen?: boolean;
    fullWidth?: boolean;
    background?: boolean;
    modalWrapper?: boolean;
    modalWrapperSurface?: boolean;
    portal?: boolean;
    focus?: boolean;
    freezeScroll?: boolean;
    disableKeyboardClose?: boolean;
    disableBackgroundClose?: boolean;
    backgroundInvisible?: boolean;
    onClose?: TMethod;
    NoSurfaceProps?: IPropsAny;
    SurfaceProps?: IPropsAny;
    BackgroundProps?: IPropsAny;
    PortalProps?: IPropsAny;
    TransitionComponentProps?: IPropsAny;
    BackgroundComponent?: IElementReference;
    TransitionComponent?: IElementReference;
}
declare const Modal: React.FC<IModal>;
export default Modal;
