"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const style_react_1 = require("@amaui/style-react");
const Icon_1 = __importDefault(require("../Icon"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Menu_1 = __importDefault(require("../Menu/Menu"));
const utils_1 = require("../utils");
const IconMaterialMoreVert = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'MoreVert', short_name: 'MoreVert', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M12 20q-.825 0-1.412-.587Q10 18.825 10 18q0-.825.588-1.413Q11.175 16 12 16t1.413.587Q14 17.175 14 18q0 .825-.587 1.413Q12.825 20 12 20Zm0-6q-.825 0-1.412-.588Q10 12.825 10 12t.588-1.413Q11.175 10 12 10t1.413.587Q14 11.175 14 12q0 .825-.587 1.412Q12.825 14 12 14Zm0-6q-.825 0-1.412-.588Q10 6.825 10 6t.588-1.412Q11.175 4 12 4t1.413.588Q14 5.175 14 6t-.587 1.412Q12.825 8 12 8Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    iconButton: {
        flex: '0 0 auto'
    }
}), { name: 'amaui-MoreOptions' });
const MoreOptions = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiMoreOptions) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Menu = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Menu) || Menu_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const { menuItems, Icon: Icon_ = IconMaterialMoreVert, IconButtonProps, className } = props, other = __rest(props, ["menuItems", "Icon", "IconButtonProps", "className"]);
    const { classes } = useStyle();
    const onClick = react_1.default.useCallback((event) => {
        //  event.stopPropagation();
    }, []);
    return ((0, jsx_runtime_1.jsx)(Menu, Object.assign({ alignment: 'center', onClick: onClick, menuItems: menuItems }, other, { ListProps: Object.assign({ color: 'themed', size: 'small' }, other === null || other === void 0 ? void 0 : other.ListProps), className: (0, style_react_1.classNames)([
            (0, utils_1.staticClassName)('MoreOptions', theme) && [
                'amaui-MoreOptions-root'
            ],
            className,
            classes.root
        ]) }, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ color: 'inherit', size: 'small', disabled: !(menuItems === null || menuItems === void 0 ? void 0 : menuItems.length), onClick: onClick }, IconButtonProps, { className: (0, style_react_1.classNames)([
                (0, utils_1.staticClassName)('MoreOptions', theme) && [
                    'amaui-MoreOptions-icon-button'
                ],
                IconButtonProps === null || IconButtonProps === void 0 ? void 0 : IconButtonProps.className,
                classes.iconButton
            ]) }, { children: (0, jsx_runtime_1.jsx)(Icon_, {}) })) })));
});
MoreOptions.displayName = 'amaui-MoreOptions';
exports.default = MoreOptions;
