"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        pointerEvents: 'auto',
        touchAction: 'none'
    }
}), { name: 'amaui-Move' });
const Move = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiMove) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const { classes } = useStyle();
    const { version = 'regular', manage = false, manageLevel = 0, disabled, onMouseDown: onMouseDown_, onTouchStart: onTouchStart_, Component = 'div', className, style, children } = props, other = __rest(props, ["version", "manage", "manageLevel", "disabled", "onMouseDown", "onTouchStart", "Component", "className", "style", "children"]);
    const refs = {
        root: react_1.default.useRef(),
        values: react_1.default.useRef(),
        version: react_1.default.useRef(),
        mouseDown: react_1.default.useRef(),
        onMouseDown: react_1.default.useRef(),
        onTouchStart: react_1.default.useRef(),
        previousMouseEvent: react_1.default.useRef(),
        disabled: react_1.default.useRef()
    };
    const [mouseDown, setMouseDown] = react_1.default.useState(false);
    const [values, setValues] = react_1.default.useState({});
    refs.version.current = version;
    refs.values.current = values;
    refs.mouseDown.current = mouseDown;
    refs.onMouseDown.current = onMouseDown_;
    refs.onTouchStart.current = onTouchStart_;
    refs.disabled.current = disabled;
    const styles = {
        root: {}
    };
    const onMouseDown = react_1.default.useCallback((event) => {
        setMouseDown(true);
        if ((0, utils_1.is)('function', refs.onMouseDown.current))
            refs.onMouseDown.current(event);
    }, []);
    const onTouchStart = react_1.default.useCallback((event) => {
        setMouseDown(true);
        if ((0, utils_1.is)('function', refs.onTouchStart.current))
            refs.onTouchStart.current(event);
    }, []);
    const onMouseUp = react_1.default.useCallback((event) => {
        setMouseDown(false);
        refs.previousMouseEvent.current = undefined;
        if ((0, utils_1.is)('function', refs.onMouseDown.current))
            refs.onMouseDown.current(event);
    }, []);
    react_1.default.useEffect(() => {
        var _a;
        const onMove = (x_, y_) => {
            if (refs.mouseDown.current && refs.previousMouseEvent.current && !refs.disabled.current) {
                const { clientX: xPrevious, clientY: yPrevious } = refs.previousMouseEvent.current;
                const x = x_ - xPrevious;
                const y = y_ - yPrevious;
                const transform = refs.root.current.style.transform;
                const { left: left_, top: top_ } = refs.root.current.style;
                const [xTransform, yTransform] = ((transform === null || transform === void 0 ? void 0 : transform.match(/[-+]?\d+\.?\d*/g)) || [0, 0]).map((item) => Number(item));
                const left = +(left_ || '').replace('px', '');
                const top = +(top_ || '').replace('px', '');
                const valuesNew = Object.assign(Object.assign({}, refs.values.current), { x: x + (left || xTransform || 0), y: y + (top || yTransform || 0) });
                if (refs.version.current === 'regular')
                    refs.root.current.style.transform = `translate(${valuesNew.x}px, ${valuesNew.y}px)`;
                else {
                    refs.root.current.style.position = 'fixed';
                    refs.root.current.style.left = `${valuesNew.x}px`;
                    refs.root.current.style.top = `${valuesNew.y}px`;
                }
                setValues(valuesNew);
            }
        };
        const onMouseMove = (event) => {
            if (refs.mouseDown.current && !refs.disabled.current) {
                const { clientY, clientX } = event;
                onMove(clientX, clientY);
                refs.previousMouseEvent.current = event;
            }
        };
        const onTouchMove = (event) => {
            if (refs.mouseDown.current && !refs.disabled.current) {
                const { clientY, clientX } = event.touches[0];
                onMove(clientX, clientY);
                refs.previousMouseEvent.current = event;
                // Normalize for use as a mouseDown value
                refs.previousMouseEvent.current.clientY = clientY;
                refs.previousMouseEvent.current.clientX = clientX;
            }
        };
        if (manage && refs.root.current) {
            const parents = (0, utils_1.element)(refs.root.current).parents();
            const parent = parents[manageLevel || 0];
            if (parent && !['HTML', 'html', 'BODY', 'body', 'HEAD', 'head'].includes(parent.tagName)) {
                parent.style.pointerEvents = 'none';
                styles.root.pointerEvents = 'auto';
            }
        }
        const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        rootDocument.addEventListener('mouseup', onMouseUp);
        rootDocument.addEventListener('mousemove', onMouseMove);
        rootDocument.addEventListener('touchend', onMouseUp);
        rootDocument.addEventListener('touchmove', onTouchMove, { passive: true });
        return () => {
            rootDocument.removeEventListener('mouseup', onMouseUp);
            rootDocument.removeEventListener('mousemove', onMouseMove);
            rootDocument.removeEventListener('touchend', onMouseUp);
            rootDocument.removeEventListener('touchmove', onTouchMove);
        };
    }, []);
    return ((0, jsx_runtime_1.jsx)(Component, Object.assign({ ref: item => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, onMouseDown: onMouseDown, onTouchStart: onTouchStart, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Move', theme) && [
                'amaui-Move-root'
            ],
            className,
            classes.root
        ]), style: Object.assign(Object.assign({}, styles.root), style) }, other, { children: children })));
});
Move.displayName = 'amaui-Move';
exports.default = Move;
