import React from 'react';
import { ITooltip } from '../Tooltip/Tooltip';
import { ITonal, IColor, IElement, IElementReference, IPropsAny } from '../types';
export declare type INavigationItemVersion = 'regular' | 'auto';
export interface INavigationItem extends ITooltip {
    tonal?: ITonal;
    color?: IColor;
    version?: 'regular' | 'auto';
    value?: any;
    vertical?: boolean;
    name?: IElement;
    label?: IElement;
    icon?: IElement;
    iconSelected?: IElement;
    selected?: boolean;
    disabled?: boolean;
    IconWrapperComponent?: IElementReference;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    onKeyDown?: (event: React.KeyboardEvent<any>) => any;
    onMouseDown?: (event: React.MouseEvent<any>) => any;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    onTouchStart?: (event: React.TouchEvent<any>) => any;
    TooltipProps?: IPropsAny;
    IconWrapperProps?: IPropsAny;
}
declare const NavigationItem: React.FC<INavigationItem>;
export default NavigationItem;
