"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const AdvancedTextField_1 = __importDefault(require("../AdvancedTextField"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Icon_1 = __importDefault(require("../Icon"));
const utils_2 = require("../utils");
const IconMaterialKeyboardArrowUpRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'KeyboardArrowUpRounded', short_name: 'KeyboardArrowUp' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M6.7 14.7Q6.425 14.425 6.425 14Q6.425 13.575 6.7 13.3L11.3 8.7Q11.45 8.55 11.625 8.487Q11.8 8.425 12 8.425Q12.2 8.425 12.388 8.5Q12.575 8.575 12.7 8.7L17.3 13.3Q17.575 13.575 17.575 14Q17.575 14.425 17.3 14.7Q17.025 14.975 16.6 14.975Q16.175 14.975 15.9 14.7L12 10.8L8.1 14.7Q7.825 14.975 7.4 14.975Q6.975 14.975 6.7 14.7Z" }) })));
});
const IconMaterialKeyboardArrowDownRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'KeyboardArrowDownRounded', short_name: 'KeyboardArrowDown' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M12 14.975Q11.8 14.975 11.613 14.9Q11.425 14.825 11.3 14.7L6.7 10.1Q6.425 9.825 6.425 9.4Q6.425 8.975 6.7 8.7Q6.975 8.425 7.4 8.425Q7.825 8.425 8.1 8.7L12 12.6L15.9 8.7Q16.175 8.425 16.6 8.425Q17.025 8.425 17.3 8.7Q17.575 8.975 17.575 9.4Q17.575 9.825 17.3 10.1L12.7 14.7Q12.55 14.85 12.375 14.912Q12.2 14.975 12 14.975Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => ({
    root: {}
}), { name: 'amaui-NumericTextField' });
const NumericTextField = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiNumericTextField) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const AdvancedTextField = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.AdvancedTextField) || AdvancedTextField_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const { valueDefault, value: value_, onChange: onChange_, min, max, increment = true, decrement = true, incrementValue = 1, decrementValue = 1, onFocus: onFocus_, onBlur: onBlur_, IconIncrement = IconMaterialKeyboardArrowUpRounded, IconDecrement = IconMaterialKeyboardArrowDownRounded, IconButtonProps, className } = props, other = __rest(props, ["valueDefault", "value", "onChange", "min", "max", "increment", "decrement", "incrementValue", "decrementValue", "onFocus", "onBlur", "IconIncrement", "IconDecrement", "IconButtonProps", "className"]);
    const { classes } = useStyle();
    const [init, setInit] = react_1.default.useState(false);
    const [focus, setFocus] = react_1.default.useState(false);
    const [value, setValue] = react_1.default.useState(valueDefault !== undefined ? valueDefault : value_);
    const refs = {
        root: react_1.default.useRef(),
        value: react_1.default.useRef(),
        focus: react_1.default.useRef(),
        min: react_1.default.useRef(),
        max: react_1.default.useRef()
    };
    refs.value.current = value;
    refs.focus.current = focus;
    refs.min.current = min;
    refs.max.current = max;
    react_1.default.useEffect(() => {
        setInit(true);
    }, []);
    react_1.default.useEffect(() => {
        var _a;
        const method = (event) => {
            if (['ArrowUp', 'ArrowDown', 'End', 'Home'].includes(event.key)) {
                event.preventDefault();
            }
            switch (event.key) {
                case 'End':
                    if (refs.focus.current && refs.min.current !== undefined) {
                        let valueNew = refs.min.current;
                        if (props.thousand)
                            valueNew = (0, utils_1.numberWithCommas)(valueNew);
                        if (props.prefix !== undefined)
                            valueNew = `${props.prefix}${valueNew}`;
                        onChange(valueNew);
                    }
                    return;
                case 'Home':
                    if (refs.focus.current && refs.max.current !== undefined) {
                        let valueNew = refs.max.current;
                        if (props.thousand)
                            valueNew = (0, utils_1.numberWithCommas)(valueNew);
                        if (props.prefix !== undefined)
                            valueNew = `${props.prefix}${valueNew}`;
                        onChange(valueNew);
                    }
                    return;
                case 'ArrowUp':
                    if (refs.focus.current)
                        onIncrement();
                    return;
                case 'ArrowDown':
                    if (refs.focus.current)
                        onDecrement();
                    return;
                default:
                    break;
            }
        };
        const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        rootDocument.addEventListener('keydown', method);
        return () => {
            // Clean up
            rootDocument.removeEventListener('keydown', method);
        };
    }, []);
    react_1.default.useEffect(() => {
        if (init) {
            if (value_ !== value)
                setValue(value_);
        }
    }, [value_]);
    const onFocus = react_1.default.useCallback((event) => {
        setFocus(true);
        if ((0, utils_1.is)('function', onFocus_))
            onFocus_(event);
    }, []);
    const onBlur = react_1.default.useCallback((event) => {
        setFocus(false);
        if ((0, utils_1.is)('function', onBlur_))
            onBlur_(event);
    }, []);
    const onChange = (valueNew_) => {
        let valueNew = valueNew_;
        if (['', ' ', props.prefix, `${props.prefix} `, undefined].includes(valueNew))
            valueNew = '';
        if (!(['', ' ', '+', '-', `${props.prefix}+`, `${props.prefix}-`, undefined].includes(valueNew))) {
            if (props.prefix !== undefined)
                valueNew = valueNew.replace(props.prefix, '');
            if (props.thousand)
                valueNew = valueNew.replace(new RegExp(`\\${props.thousandSeparator || ','}`, 'g'), '');
            const min_ = min !== undefined ? min : Number.MIN_SAFE_INTEGER;
            const max_ = max !== undefined ? max : Number.MAX_SAFE_INTEGER;
            valueNew = (0, utils_1.clamp)(+valueNew, min_, max_);
            if (props.thousand)
                valueNew = (0, utils_1.numberWithCommas)(valueNew);
            if (props.prefix !== undefined)
                valueNew = `${props.prefix}${valueNew}`;
        }
        // Update inner or controlled
        if (!props.hasOwnProperty('value'))
            setValue(valueNew);
        if ((0, utils_1.is)('function', onChange_))
            onChange_(valueNew);
    };
    const onIncrement = () => {
        let valueNew = refs.value.current || '0';
        if (props.prefix !== undefined)
            valueNew = valueNew.replace(props.prefix, '');
        if (props.thousand)
            valueNew = valueNew.replace(new RegExp(`\\${props.thousandSeparator || ','}`, 'g'), '');
        const min_ = min !== undefined ? min : Number.MIN_SAFE_INTEGER;
        const max_ = max !== undefined ? max : Number.MAX_SAFE_INTEGER;
        valueNew = (0, utils_1.clamp)(+valueNew + incrementValue, min_, max_);
        if (props.thousand)
            valueNew = (0, utils_1.numberWithCommas)(valueNew);
        if (props.prefix !== undefined)
            valueNew = `${props.prefix}${valueNew}`;
        // Update
        onChange(valueNew);
    };
    const onDecrement = () => {
        let valueNew = refs.value.current || '0';
        if (props.prefix !== undefined)
            valueNew = valueNew.replace(props.prefix, '');
        if (props.thousand)
            valueNew = valueNew.replace(new RegExp(`\\${props.thousandSeparator || ','}`, 'g'), '');
        const min_ = min !== undefined ? min : Number.MIN_SAFE_INTEGER;
        const max_ = max !== undefined ? max : Number.MAX_SAFE_INTEGER;
        valueNew = (0, utils_1.clamp)(+valueNew - decrementValue, min_, max_);
        if (props.thousand)
            valueNew = (0, utils_1.numberWithCommas)(valueNew);
        if (props.prefix !== undefined)
            valueNew = `${props.prefix}${valueNew}`;
        // Update
        onChange(valueNew);
    };
    const end = [];
    const iconButtonProps = {
        size: 24,
        fontSize: '1.5rem'
    };
    if (decrement)
        end.push((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ onClick: onDecrement }, iconButtonProps, IconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconDecrement, {}) })));
    if (increment)
        end.push((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ onClick: onIncrement }, iconButtonProps, IconButtonProps, { children: (0, jsx_runtime_1.jsx)(IconIncrement, {}) })));
    return ((0, jsx_runtime_1.jsx)(AdvancedTextField, Object.assign({ ref: item => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, value: value, onFocus: onFocus, onBlur: onBlur, onChange: onChange, validate: (valueNew_) => {
            if (valueNew_.startsWith(' ') || valueNew_.endsWith(' '))
                return;
            if (['', ' ', props.prefix, `${props.prefix} `, `${props.prefix}+`, `${props.prefix}-`, undefined].includes(valueNew_))
                return true;
            let valueNew = valueNew_;
            if (props.prefix !== undefined)
                valueNew = valueNew_.replace(props.prefix, '');
            if (props.thousand)
                valueNew = valueNew.replace(new RegExp(`\\${props.thousandSeparator || ','}`, 'g'), '');
            valueNew = +valueNew;
            return (0, utils_1.is)('number', valueNew);
        }, end: end, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('NumericTextField', theme) && [
                'amaui-NumericTextField-root'
            ],
            className,
            classes.root
        ]) }, other)));
});
NumericTextField.displayName = 'amaui-NumericTextField';
exports.default = NumericTextField;
