"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Type_1 = __importDefault(require("../Type"));
const Button_1 = __importDefault(require("../Button"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    size_small: {
        '&.amaui-Button-root': {
            width: 'unset',
            minWidth: '30px',
            paddingInline: theme.methods.space.value(0.5, 'px')
        }
    },
    size_regular: {
        '&.amaui-Button-root': {
            width: 'unset',
            minWidth: '40px',
            paddingInline: theme.methods.space.value(1, 'px')
        }
    },
    size_large: {
        '&.amaui-Button-root': {
            width: 'unset',
            minWidth: '50px',
            paddingInline: theme.methods.space.value(1.25, 'px')
        }
    }
}), { name: 'amaui-PaginationItem' });
const PaginationItem = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiPaginationItem) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Button = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Button) || Button_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const { tonal = false, color = 'default', version = 'text', elevation = false, size = 'regular', TypeProps, className, children } = props, other = __rest(props, ["tonal", "color", "version", "elevation", "size", "TypeProps", "className", "children"]);
    const { classes } = useStyle();
    return ((0, jsx_runtime_1.jsx)(Button, Object.assign({ ref: ref, tonal: tonal, color: color, version: version, elevation: elevation, size: size, icon: true, noFontSize: true, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('PaginationItem', theme) && [
                'amaui-PaginationItem-root'
            ],
            className,
            classes.root,
            classes[`size_${size}`]
        ]) }, other, { children: (0, utils_1.is)('simple', children) ?
            ((0, jsx_runtime_1.jsx)(Type, Object.assign({}, TypeProps, { children: children }))) :
            children })));
});
PaginationItem.displayName = 'amaui-PaginationItem';
exports.default = PaginationItem;
