import React from 'react';
import { IBaseElement, IPropsAny, IStyle, IValueBreakpoints } from '../types';
export declare type TParallaxDirection = 'vertical' | 'horizontal';
export interface IParallax extends IBaseElement {
    value?: number;
    root?: Element | DocumentFragment;
    render?: (value: number, root: Element | DocumentFragment, rate: number, scrollDirection: TParallaxDirection, transformDirection: TParallaxDirection, transition: string, props: IPropsAny) => IStyle;
    rate?: number | ((value: number) => number);
    scrollDirection?: TParallaxDirection;
    transformDirection?: TParallaxDirection;
    transition?: string;
    disabled?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
}
declare const Parallax: React.FC<IParallax>;
export default Parallax;
