"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {}
}), { name: 'amaui-Parallax' });
const Parallax = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiParallax) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const { value: value_, 
    // element
    root = window.document, render, 
    // value or a method
    rate = -1, scrollDirection = 'vertical', transformDirection = 'vertical', transition = `transform ${theme.transitions.duration.xxs}`, disabled: disabled_, className, style, children } = props, other = __rest(props, ["value", "root", "render", "rate", "scrollDirection", "transformDirection", "transition", "disabled", "className", "style", "children"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef(),
        value: react_1.default.useRef(),
        scrollDirection: react_1.default.useRef(),
        transformDirection: react_1.default.useRef(),
        rate: react_1.default.useRef(),
        disabled: react_1.default.useRef()
    };
    const breakpoints = {};
    theme.breakpoints.keys.forEach(key => {
        if (theme.breakpoints.media[key])
            breakpoints[key] = (0, useMediaQuery_1.default)(theme.breakpoints.media[key], { element: refs.root.current });
    });
    const disabled = (0, utils_2.valueBreakpoints)(disabled_, false, breakpoints, theme);
    const [value, setValue] = react_1.default.useState(0);
    refs.value.current = value;
    refs.scrollDirection.current = scrollDirection;
    refs.transformDirection.current = transformDirection;
    refs.rate.current = rate;
    refs.disabled.current = disabled;
    const update = () => {
        let valueNew;
        if (refs.disabled.current)
            return;
        // Element rect
        const rect = refs.root.current.getBoundingClientRect();
        // Viewport
        if (
        // Vertically
        (
        // Element in view
        (rect.y >= 0 && rect.bottom <= window.innerHeight) ||
            // Element y out of view, but bottom in view
            (rect.y < 0 && rect.bottom >= 0) ||
            // Element bottom out of view, but y in view
            (rect.bottom > window.innerHeight && rect.y <= window.innerHeight)) &&
            // Horizontally
            (
            // Element in view
            (rect.x >= 0 && rect.right <= window.innerWidth) ||
                // Element x out of view, but right in view
                (rect.x < 0 && rect.right >= 0) ||
                // Element right out of view, but x in view
                (rect.right > window.innerWidth && rect.y <= window.innerWidth))) {
            const padding = Math.abs((window.innerHeight - rect.height) / 2);
            const max = rect.height + padding;
            valueNew = (((window.innerHeight - rect.y) / max) - 1) * 100;
        }
        if (valueNew !== undefined && valueNew !== refs.value.current)
            setValue((0, utils_1.clamp)(valueNew, -100, 100));
    };
    react_1.default.useEffect(() => {
        // Update on init
        if (!props.hasOwnProperty('value'))
            update();
    }, []);
    react_1.default.useEffect(() => {
        if (!props.hasOwnProperty('value') && (root === null || root === void 0 ? void 0 : root.addEventListener))
            root.addEventListener('scroll', update);
        return () => {
            if (!props.hasOwnProperty('value') && (root === null || root === void 0 ? void 0 : root.addEventListener))
                root.removeEventListener('scroll', update);
        };
    }, [root]);
    react_1.default.useEffect(() => {
        if (value_ !== undefined && value_ !== refs.value.current)
            setValue(value_);
    }, [value_]);
    let styles = {};
    if ((0, utils_1.is)('function', render))
        styles = Object.assign({}, render(value, root, rate, scrollDirection, transformDirection, transition, props));
    else {
        let valueUpdate = 0;
        if ((0, utils_1.is)('function', rate))
            valueUpdate = rate(value);
        else
            valueUpdate = value * rate;
        if (transformDirection === 'vertical')
            styles.transform = `translate3d(0, ${valueUpdate}%, 0)`;
        else
            styles.transform = `translate3d(${valueUpdate}%, 0, 0)`;
        styles.transition = transition;
    }
    return ((0, utils_1.is)('function', children) ?
        children(value, styles, other) :
        react_1.default.cloneElement(children, Object.assign({ className: (0, style_react_1.classNames)([
                (0, utils_2.staticClassName)('Parallax', theme) && [
                    `amaui-Parallax-root`
                ],
                className,
                classes.root
            ]), ref: (item) => {
                if (ref) {
                    if ((0, utils_1.is)('function', ref))
                        ref(item);
                    else
                        ref.current = item;
                }
                refs.root.current = item;
                if (children.ref) {
                    if ((0, utils_1.is)('function', children.ref))
                        children.ref(item);
                    else
                        children.ref.current = item;
                }
            }, style: Object.assign(Object.assign({}, children.props.style), styles) }, other)));
});
Parallax.displayName = 'amaui-Parallax';
exports.default = Parallax;
