"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Line_1 = __importDefault(require("../Line"));
const Type_1 = __importDefault(require("../Type"));
const Surface_1 = __importDefault(require("../Surface"));
const Chart_1 = __importDefault(require("../Chart"));
const Path_1 = __importDefault(require("../Path"));
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        '& .amaui-Chart-wrapper': {
            aspectRatio: '1',
            maxWidth: '240px',
            height: 'unset',
            overflow: 'hidden'
        }
    },
    legend_item: {
        userSelect: 'none'
    },
    legend_icon: {
        width: '10px',
        height: '2px'
    },
    text: Object.assign(Object.assign({}, theme.typography.values.b3), { textAnchor: 'middle', alignmentBaseline: 'middle', userSelect: 'none' }),
    append_wrapper: {
        userSelect: 'none',
        pointerEvents: 'none'
    },
    append: {
        padding: `${theme.methods.space.value(1.5, 'px')} ${theme.methods.space.value(2.5, 'px')}`,
        borderRadius: theme.methods.shape.radius.value(1.5, 'px')
    },
    append_icon: {
        width: '8px',
        height: '8px',
        borderRadius: theme.methods.shape.radius.value(40, 'px')
    }
}), { name: 'amaui-PieChart' });
const PieChart = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiPieChart) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const Chart = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Chart) || Chart_1.default; }, [theme]);
    const Path = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Path) || Path_1.default; }, [theme]);
    const { tonal = true, color = 'primary', values, animate: animate_, animateTimeout: animateTimeout_, names, gap = 4, innerOffset = 0, tooltipRender: tooltipRender_, PathProps, LegendItemProps, className } = props, other = __rest(props, ["tonal", "color", "values", "animate", "animateTimeout", "names", "gap", "innerOffset", "tooltipRender", "PathProps", "LegendItemProps", "className"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef(),
        rects: react_1.default.useRef(),
        pathStyle: react_1.default.useRef(),
        animate: react_1.default.useRef(),
        animateTimeout: react_1.default.useRef(),
        init: react_1.default.useRef(),
        theme: react_1.default.useRef()
    };
    const breakpoints = {};
    theme.breakpoints.keys.forEach(key => {
        if (theme.breakpoints.media[key])
            breakpoints[key] = (0, useMediaQuery_1.default)(theme.breakpoints.media[key], { element: refs.root.current });
    });
    const animate = (0, utils_2.valueBreakpoints)(animate_, true, breakpoints, theme);
    const animateTimeout = (0, utils_2.valueBreakpoints)(animateTimeout_, 140, breakpoints, theme);
    const [value, setValue] = react_1.default.useState();
    const [init, setInit] = react_1.default.useState();
    refs.theme.current = theme;
    refs.animate.current = animate;
    refs.animateTimeout.current = animateTimeout;
    refs.init.current = init;
    const LegendItem = react_1.default.useCallback((props__) => {
        const { item = {}, className: className_ } = props__, other_ = __rest(props__, ["item", "className"]);
        const { color: color_, tone = 'main', name = 'No name' } = item;
        return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1, direction: 'row', align: 'center' }, LegendItemProps, { className: (0, style_react_1.classNames)([
                (0, utils_2.staticClassName)('PieChart', theme) && [
                    'amaui-PieChart-legend-item'
                ],
                className_,
                LegendItemProps === null || LegendItemProps === void 0 ? void 0 : LegendItemProps.className,
                classes.legend_item
            ]) }, other_, { children: [(0, jsx_runtime_1.jsx)("span", { className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('PieChart', theme) && [
                            'amaui-PieChart-legend-icon'
                        ],
                        classes.legend_icon
                    ]), style: {
                        background: !refs.theme.current.palette.color[color_] ? color_ : refs.theme.current.palette.color[color_][tone]
                    } }), (0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3' }, { children: name }))] })));
    }, [theme]);
    const make = () => {
        // Make values into x, y, coordinates
        // normalized in rect width, height values
        // invert y so 0, 0 is at bottom left
        if (refs.rects.current && values) {
            const { width, height } = refs.rects.current.wrapper;
            // Legend
            const legend_ = values.map((item) => {
                return {
                    item,
                    element: ((0, jsx_runtime_1.jsx)(LegendItem, { item: item }))
                };
            });
            const center = width / 2;
            const radius = (width / 2) - (gap / 2);
            const total = 360;
            const valueTotal = values.reduce((result, itemValue) => result += itemValue.values[0], 0);
            const angles = {
                start: (0, utils_2.angleToCoordinates)(0, center, center, radius)
            };
            let anglePrevious = 0;
            let anglePreviousInner = 0;
            let value_ = [];
            let d = '';
            // Elements
            const elements_ = (0, utils_1.copy)(values).map((item, index) => {
                const { color: color_, tone = 'main' } = item;
                const partPercentage = (0, utils_1.percentageFromValueWithinRange)(item.values[0], 0, valueTotal);
                let part = total * (partPercentage / 100);
                if (partPercentage === 100)
                    part -= 0.0001;
                const startInner = (0, utils_2.angleToCoordinates)(anglePreviousInner, center, center, radius * innerOffset);
                // Move from inner value
                if (index === 0)
                    value_.push('M', startInner.x, startInner.y, 
                    // Move to 0 deg
                    'L', angles.start.x, angles.start.y);
                const angleEnd = anglePrevious + part;
                const angleEndInner = anglePreviousInner + part;
                const angleText = anglePrevious + (part / 2);
                const angleTextCoordinates = (0, utils_2.angleToCoordinates)(angleText, center, center, (radius - (radius - (radius * innerOffset)) / 2));
                angles.end = (0, utils_2.angleToCoordinates)(angleEnd, center, center, radius);
                angles.endInner = (0, utils_2.angleToCoordinates)(angleEndInner, center, center, radius * innerOffset);
                angles.move = (0, utils_2.angleToCoordinates)(angleEnd, center, center, radius);
                angles.moveInner = (0, utils_2.angleToCoordinates)(angleEnd, center, center, radius * innerOffset);
                // Arc
                let invert = 0;
                if (part > 180)
                    invert = 1;
                value_.push('A', radius, radius, 0, invert, 1, angles.end.x, angles.end.y);
                // To donut value or center
                if (innerOffset) {
                    const endInner = (0, utils_2.angleToCoordinates)(angleEndInner, center, center, radius * innerOffset);
                    value_.push('L', endInner.x, endInner.y);
                    value_.push('A', radius * innerOffset, radius * innerOffset, 0, invert, 0, startInner.x, startInner.y);
                }
                value_.push('Z');
                // path
                d = value_.join(' ');
                anglePrevious = angleEnd;
                anglePreviousInner = angleEndInner;
                // Move for the next value
                if (index < values.length - 1) {
                    value_ = [
                        'M', angles.moveInner.x, angles.moveInner.y,
                        'L', angles.move.x, angles.move.y
                    ];
                }
                return {
                    item,
                    element: ((0, jsx_runtime_1.jsxs)("g", { children: [(0, jsx_runtime_1.jsx)(Path, Object.assign({ d: d, fill: !refs.theme.current.palette.color[color_] ? color_ : refs.theme.current.palette.color[color_][tone], stroke: gap > 0 ? refs.theme.current.palette.background.default.primary : 'none', strokeWidth: gap }, PathProps, { style: Object.assign(Object.assign(Object.assign(Object.assign({}, PathProps === null || PathProps === void 0 ? void 0 : PathProps.style), ((refs.animate.current && refs.init.current !== 'animated') && {
                                    opacity: 0,
                                    transform: 'scale(0)'
                                })), { transformBox: 'fill-box', transformOrigin: 'center' }), refs.pathStyle.current) })), partPercentage >= 7 && ((0, jsx_runtime_1.jsx)("text", Object.assign({ x: angleTextCoordinates.x, y: angleTextCoordinates.y, className: (0, style_react_1.classNames)([
                                    (0, utils_2.staticClassName)('PieChart', theme) && [
                                        'amaui-PieChart-text'
                                    ],
                                    classes.text
                                ]), fill: refs.theme.current.methods.palette.color.text(!refs.theme.current.palette.color[color_] ? color_ : refs.theme.current.palette.color[color_][tone], true, 'light'), style: Object.assign(Object.assign(Object.assign(Object.assign({}, PathProps === null || PathProps === void 0 ? void 0 : PathProps.style), ((refs.animate.current && refs.init.current !== 'animated') && {
                                    opacity: 0
                                })), ((refs.animate.current && refs.init.current === 'animated') && {
                                    opacity: 1
                                })), refs.pathStyle.current) }, { children: `${partPercentage.toFixed(1)}%`.replace('.0%', '%') })))] }))
                };
            });
            // Sort
            elements_.sort((a, b) => { var _a, _b, _c, _d; return ((_b = (_a = a === null || a === void 0 ? void 0 : a.item) === null || _a === void 0 ? void 0 : _a.values) === null || _b === void 0 ? void 0 : _b[0]) - ((_d = (_c = b === null || b === void 0 ? void 0 : b.item) === null || _c === void 0 ? void 0 : _c.values) === null || _d === void 0 ? void 0 : _d[0]); });
            // Update children value
            setValue({
                legend: legend_,
                elements: elements_
            });
        }
    };
    const initMethod = react_1.default.useCallback(() => {
        if (animate) {
            if (!init) {
                refs.pathStyle.current = {
                    transition: theme.methods.transitions.make(['transform', 'opacity'], { timing_function: 'decelerated' })
                };
                setInit(true);
                setTimeout(() => {
                    refs.pathStyle.current = Object.assign(Object.assign({}, refs.pathStyle.current), { opacity: 1, transform: 'scale(1)' });
                    setInit('animated');
                }, refs.animateTimeout.current);
            }
        }
    }, [init, animate]);
    react_1.default.useEffect(() => {
        make();
        initMethod();
    }, [values, theme, animate, init]);
    const onUpdateRects = (valueNew) => {
        refs.rects.current = valueNew;
        make();
    };
    const tooltipRender = (0, utils_1.is)('function', tooltipRender_) ? tooltipRender_ : (values_) => {
        const { name, color: color_, tone = 'main', values: values__ } = values_;
        const valueTotal = values.reduce((result, itemValue) => result += itemValue.values[0], 0);
        const valueValue = values__[0];
        const valuePercentage = (((valueValue / valueTotal) * 100).toFixed(1)).replace('.0', '');
        return {
            element: ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ tonal: tonal, color: color, elevation: 1, gap: 0.5, direction: 'column', Component: Surface, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('PieChart', theme) && [
                        'amaui-PieChart-append'
                    ],
                    classes.append
                ]) }, { children: [(0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1, direction: 'row', align: 'center' }, { children: [(0, jsx_runtime_1.jsx)("span", { className: (0, style_react_1.classNames)([
                                    (0, utils_2.staticClassName)('PieChart', theme) && [
                                        'amaui-LineChart-append-icon'
                                    ],
                                    classes.append_icon
                                ]), style: {
                                    background: !refs.theme.current.palette.color[color_] ? color_ : refs.theme.current.palette.color[color_][tone]
                                } }), (0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3' }, { children: name }))] })), (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0.4, direction: 'column' }, { children: [(0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1, direction: 'row', align: 'center' }, { children: [(0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3', style: {
                                            fontWeight: 600
                                        } }, { children: (names === null || names === void 0 ? void 0 : names.value) || 'Value' })), (0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3' }, { children: valueValue }))] })), (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1, direction: 'row', align: 'center' }, { children: [(0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3', style: {
                                            fontWeight: 600
                                        } }, { children: (names === null || names === void 0 ? void 0 : names.percentage) || 'Percentage' })), (0, jsx_runtime_1.jsxs)(Type, Object.assign({ version: 'b3' }, { children: [valuePercentage, "%"] }))] }))] }))] })))
        };
    };
    return ((0, jsx_runtime_1.jsx)(Chart, Object.assign({ ref: item => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, tonal: tonal, color: color, values: values, names: names, elements: value === null || value === void 0 ? void 0 : value.elements, legend: value === null || value === void 0 ? void 0 : value.legend, labels: false, marks: false, borders: false, tooltipRender: tooltipRender, onUpdateRects: onUpdateRects, elementTooltip: true, noMain: true, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('PieChart', theme) && [
                'amaui-PieChart-root'
            ],
            className,
            classes.root
        ]) }, other)));
});
PieChart.displayName = 'amaui-PieChart';
exports.default = PieChart;
