"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Line_1 = __importDefault(require("../Line/Line"));
const Type_1 = __importDefault(require("../Type"));
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    'version_row-50': {
        '& > *': {
            flex: '1 1 50%'
        }
    },
    'version_row-20': {
        '& > *:first-child': {
            flex: '1 1 20%'
        },
        '& > *:last-child': {
            flex: '1 1 80%'
        }
    },
    text: {
        wordBreak: 'break-word'
    }
}), { name: 'amaui-Property' });
const Property = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiProperty) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const { version: version_ = 'row-20', size = 'regular', name, value: value_, separator, responsive = true, mediaQuery = `(max-width: 768px)`, ItemProps, NameProps, NameWrapperProps, ValueProps, className, children } = props, other = __rest(props, ["version", "size", "name", "value", "separator", "responsive", "mediaQuery", "ItemProps", "NameProps", "NameWrapperProps", "ValueProps", "className", "children"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef()
    };
    const mobile = (0, useMediaQuery_1.default)(mediaQuery, { element: refs.root.current });
    let version = version_;
    if (responsive && mobile) {
        version = 'column';
    }
    const value = value_ !== undefined ? value_ : children;
    const propsRoot = {};
    if (version === 'column') {
        propsRoot.gap = 0.5;
        propsRoot.direction = 'column';
        propsRoot.align = 'flex-start';
    }
    if (version.includes('row')) {
        propsRoot.gap = 2;
        propsRoot.direction = 'row';
        propsRoot.align = 'flex-start';
    }
    if (version === 'row') {
        propsRoot.justify = 'flex-start';
    }
    else if (['row-20', 'row-50', 'row-between'].includes(version)) {
        propsRoot.justify = 'space-between';
    }
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ ref: (item) => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, fullWidth: true, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Property', theme) && [
                'amaui-Property-root'
            ],
            className,
            classes.root,
            classes[`version_${version}`]
        ]) }, propsRoot, other, { children: [(0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'row' }, NameWrapperProps, { children: [(0, utils_1.is)('simple', name) ? ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: size === 'large' ? 'l1' : size === 'regular' ? 'l2' : 'l3' }, ItemProps, NameProps, { className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('Property', theme) && [
                                'amaui-Property-name'
                            ],
                            ItemProps === null || ItemProps === void 0 ? void 0 : ItemProps.className,
                            NameProps === null || NameProps === void 0 ? void 0 : NameProps.className,
                            classes.text,
                            classes.name
                        ]) }, { children: name }))) : name, separator] })), (0, utils_1.is)('simple', value) ? ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: size === 'large' ? 'b1' : size === 'regular' ? 'b2' : 'b3' }, ItemProps, ValueProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('Property', theme) && [
                        'amaui-Property-name'
                    ],
                    ItemProps === null || ItemProps === void 0 ? void 0 : ItemProps.className,
                    ValueProps === null || ValueProps === void 0 ? void 0 : ValueProps.className,
                    classes.text,
                    classes.name
                ]) }, { children: value }))) : value] })));
});
Property.displayName = 'amaui-Property';
exports.default = Property;
