"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const IconButton_1 = __importDefault(require("../IconButton"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        position: 'relative',
        '& *': {
            boxSizing: 'border-box'
        }
    },
    input: {
        position: 'absolute',
        inset: '0',
        width: '100%',
        height: '100%',
        opacity: '0',
        cursor: 'inherit',
        zIndex: '1'
    },
    icon: {
        zIndex: '1',
        pointerEvents: 'none'
    },
    iconBox: {
        width: '1em',
        height: '1em',
        border: '0.12em solid currentColor',
        borderRadius: `calc(${theme.shape.radius.unit / 8} * 0.75em)`
    },
    iconDot: {
        display: 'inline-flex',
        justifyContent: 'center',
        alignItems: 'center',
        position: 'absolute',
        inset: '0',
        width: '100%',
        height: '100%',
        background: 'currentColor',
        borderRadius: `calc(${theme.shape.radius.unit / 8} * 0.75em)`,
        zIndex: '3',
        transform: 'scale(0)',
        transition: theme.methods.transitions.make('transform', { duration: 'xxs' })
    },
    checked: {
        transform: 'scale(0.5)'
    },
    disabled: {
        cursor: 'default'
    }
}), { name: 'amaui-Radio' });
const IconItem = (props) => {
    const { size, Component = 'span', className, style, children } = props, other = __rest(props, ["size", "Component", "className", "style", "children"]);
    const styles = {
        root: {}
    };
    const fontSize = (0, utils_2.iconSizeToFontSize)(size);
    styles.root.fontSize = `calc(${fontSize} / 1.2)`;
    return ((0, jsx_runtime_1.jsx)(Component, Object.assign({ className: className, style: Object.assign(Object.assign({}, style), styles.root), size: size }, { children: children && react_1.default.cloneElement(children, Object.assign({}, other)) })));
};
const Radio = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiRadio) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const { tonal = true, color = 'primary', version = 'text', render, inputRef, colorUnchecked = 'default', valueDefault: valueDefault_, checkedDefault: checkedDefault_, value: value_, checked: checked_, onChange, disabled, Component = 'span', className, children } = props, other = __rest(props, ["tonal", "color", "version", "render", "inputRef", "colorUnchecked", "valueDefault", "checkedDefault", "value", "checked", "onChange", "disabled", "Component", "className", "children"]);
    const checkedDefault = valueDefault_ !== undefined ? valueDefault_ : checkedDefault_;
    const checked = value_ !== undefined ? value_ : checked_;
    const [value, setValue] = react_1.default.useState((checkedDefault !== undefined ? checkedDefault : checked) || false);
    const refs = {
        value: react_1.default.useRef(),
        input: react_1.default.useRef()
    };
    refs.value.current = value;
    const { classes } = useStyle();
    const styles = {
        iconBox: {}
    };
    react_1.default.useEffect(() => {
        if (checked !== undefined && checked !== refs.value.current)
            setValue(checked);
    }, [checked]);
    const onUpdate = (event) => {
        if (!disabled) {
            // Inner controlled checkbox
            if (!props.hasOwnProperty('checked'))
                setValue(event.target.checked);
            if ((0, utils_1.is)('function', onChange))
                onChange(event.target.checked, event);
        }
    };
    const onKeyDown = (event) => {
        switch (event.key) {
            case 'Enter':
                if (refs.input.current)
                    refs.input.current.click();
                break;
            default:
                break;
        }
    };
    let palette;
    if (!theme.palette.color[color])
        palette = theme.methods.color(color);
    if (tonal) {
        // Text
        // Outlined
        if (['text', 'outlined', undefined].includes(version)) {
            styles.iconBox.color = styles.iconBox.color = theme.methods.palette.color.value(color, 30, true, palette);
        }
        // Outlined
        if (version === 'outlined')
            styles.iconBox.color = styles.iconBox.color = theme.methods.palette.color.value(color, 50, true, palette);
    }
    let colorValue = color;
    if (!value)
        colorValue = colorUnchecked;
    return ((0, jsx_runtime_1.jsx)(IconButton, Object.assign({ ref: ref, tabIndex: !disabled ? 0 : -1, tonal: tonal, color: colorValue, version: version, onKeyDown: onKeyDown, firstLevelChildren: ((0, jsx_runtime_1.jsx)("input", { ref: item => {
                if (inputRef)
                    inputRef.current = item;
                refs.input.current = item;
            }, tabIndex: -1, type: 'checkbox', checked: value, onChange: onUpdate, className: (0, style_react_1.classNames)([
                (0, utils_2.staticClassName)('Radio', theme) && [
                    'amaui-Radio-input'
                ],
                classes.input
            ]), disabled: disabled })), role: 'radio', "aria-checked": value, "aria-disabled": disabled, disabled: disabled, Component: Component, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Radio', theme) && [
                'amaui-Radio-root',
                `amaui-Radio-version-${version}`,
                value && `amaui-Radio-checked`,
                disabled && `amaui-Radio-disabled`
            ],
            className,
            classes.root,
            disabled && classes.disabled
        ]) }, other, { children: (0, utils_1.is)('function', render) ? render(value, Object.assign(Object.assign(Object.assign({}, props), other), { tonal, color, version })) : (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(IconItem, { Component: 'div', className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('Radio', theme) && [
                            'amaui-Radio-icon',
                            'amaui-Radio-icon-box'
                        ],
                        classes.icon,
                        classes.iconBox,
                        classes[version],
                        disabled && classes.disabled
                    ]), style: styles.iconBox }), (0, jsx_runtime_1.jsx)(IconItem, { Component: 'div', className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('Radio', theme) && [
                            'amaui-Radio-icon',
                            'amaui-Radio-icon-dot'
                        ],
                        classes.icon,
                        classes.iconDot,
                        value && classes.checked
                    ]) })] }) })));
});
Radio.displayName = 'amaui-Radio';
exports.default = Radio;
