"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Fade_1 = __importDefault(require("../Fade"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
}), { name: 'amaui-Reveal' });
const Reveal = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiReveal) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Fade = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Fade) || Fade_1.default; }, [theme]);
    const { inDefault, offset, offsetReveal, offsetUnreveal, unreveal, inClassName, onChange, noTransition, Component: Component_ = Fade, className, children } = props, other = __rest(props, ["inDefault", "offset", "offsetReveal", "offsetUnreveal", "unreveal", "inClassName", "onChange", "noTransition", "Component", "className", "children"]);
    const { classes } = useStyle();
    const [inProp, setInProp] = react_1.default.useState(inDefault !== undefined ? inDefault : false);
    const refs = {
        root: react_1.default.useRef(),
        props: react_1.default.useRef(),
        in: react_1.default.useRef()
    };
    refs.props.current = props;
    refs.in.current = inProp;
    const updateIn = react_1.default.useCallback((value) => {
        setInProp(value);
        if ((0, utils_1.is)('function', onChange))
            onChange(value);
    }, [onChange]);
    react_1.default.useEffect(() => {
        var _a;
        // Listen to window scroll value
        const method = () => {
            var _a, _b;
            if (refs.root.current) {
                const rect = refs.root.current.getBoundingClientRect();
                const rootWindow = (0, utils_1.isEnvironment)('browser') ? (((_b = (_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) === null || _b === void 0 ? void 0 : _b.defaultView) || window) : undefined;
                // Reveal
                if (!refs.in.current) {
                    const offset_ = refs.props.current.offsetReveal !== undefined ? refs.props.current.offsetReveal : refs.props.current.offset !== undefined ? refs.props.current.offset : 0;
                    if (
                    // Top
                    (
                    // Top
                    (rect.top - offset_ < rootWindow.innerHeight && rect.top - offset_ > 0) &&
                        (
                        // Left
                        (rect.left - offset_ < rootWindow.innerWidth && rect.left - offset_ > 0) ||
                            // Right
                            (rect.left - offset_ < rootWindow.innerWidth && rect.right + offset_ > 0))) ||
                        // Left
                        (
                        // Left
                        (rect.left - offset_ < rootWindow.innerWidth && rect.left - offset_ > 0) &&
                            (
                            // Top
                            (rect.top - offset_ < rootWindow.innerHeight && rect.top - offset_ > 0) ||
                                // Bottom
                                (rect.top - offset_ < rootWindow.innerHeight && rect.bottom + offset_ > 0))) ||
                        // Right
                        (
                        // Right
                        (rect.left - offset_ < rootWindow.innerWidth && rect.right + offset_ > 0) &&
                            (
                            // Top
                            (rect.top - offset_ < rootWindow.innerHeight && rect.top - offset_ > 0) ||
                                // Bottom
                                (rect.top - offset_ < rootWindow.innerHeight && rect.bottom + offset_ > 0))) ||
                        // Bottom
                        (
                        // Bottom
                        (rect.top - offset_ < rootWindow.innerHeight && rect.bottom + offset_ > 0) &&
                            (
                            // Left
                            (rect.left - offset_ < rootWindow.innerWidth && rect.left - offset_ > 0) ||
                                // Right
                                (rect.left - offset_ < rootWindow.innerWidth && rect.right + offset_ > 0))))
                        updateIn(true);
                }
                else if (refs.props.current.unreveal) {
                    const offset_ = refs.props.current.offsetUnreveal !== undefined ? refs.props.current.offsetUnreveal : refs.props.current.offset !== undefined ? refs.props.current.offset : 0;
                    if (
                    // Top
                    rect.bottom + offset_ < 0 ||
                        // Left
                        rect.right + offset_ < 0 ||
                        // Right
                        rect.left - offset_ > rootWindow.innerWidth ||
                        // Bottom
                        rect.top - offset_ > rootWindow.innerHeight)
                        updateIn(false);
                }
            }
        };
        // Initial
        setTimeout(() => {
            method();
        }, 14);
        const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        if (refs.root.current) {
            rootDocument.addEventListener('scroll', method);
        }
        return () => {
            if (refs.root.current) {
                rootDocument.removeEventListener('scroll', method);
            }
        };
    }, []);
    const Component = !noTransition ? Component_ : react_1.default.Fragment;
    if (!noTransition)
        other.in = inProp;
    const ComponentProps = !noTransition && Object.assign({}, other);
    return ((0, jsx_runtime_1.jsx)(Component, Object.assign({}, ComponentProps, { children: react_1.default.cloneElement(children, {
            ref: (item) => {
                if (ref) {
                    if ((0, utils_1.is)('function', ref))
                        ref(item);
                    else
                        ref.current = item;
                }
                refs.root.current = item;
            },
            className: (0, style_react_1.classNames)([
                (0, utils_2.staticClassName)('Reveal', theme) && [
                    'amaui-Reveal-root',
                    unreveal && `amaui-Reveal-unreveal`,
                    inProp ? `amaui-Reveal-revealed` : `amaui-Reveal-unrevealed`
                ],
                className,
                children.props.className,
                classes.root,
                inProp && inClassName
            ])
        }) })));
});
Reveal.displayName = 'amaui-Reveal';
exports.default = Reveal;
