import React from 'react';
import { ILine } from '../Line/Line';
import { ITonal, IColor, IVersion, IPropsAny, IElement, IElementReference } from '../types';
export interface IRichTextEditor extends ILine {
    tonal?: ITonal;
    color?: IColor;
    version?: IVersion;
    value?: string;
    onChange?: (event: React.ChangeEvent<any>) => any;
    render?: (version: string, props: IPropsAny, value: string, update: (command: string) => any) => IElement;
    miniMenu?: boolean;
    miniMenuInclude?: Array<string>;
    exclude?: Array<string>;
    updates?: boolean;
    actions?: boolean;
    fontFamilies?: Array<{
        value?: string;
        label?: string;
    }>;
    addFontFamilies?: Array<{
        value?: string;
        label?: string;
    }>;
    IconItalic?: IElementReference;
    IconUnderline?: IElementReference;
    IconBold?: IElementReference;
    IconStrikeLine?: IElementReference;
    IconColor?: IElementReference;
    IconBackground?: IElementReference;
    IconAlignLeft?: IElementReference;
    IconAlignCenter?: IElementReference;
    IconAlignRight?: IElementReference;
    IconAlignJustify?: IElementReference;
    IconIndent?: IElementReference;
    IconOutdent?: IElementReference;
    IconSuperscript?: IElementReference;
    IconSubscript?: IElementReference;
    IconListOrdered?: IElementReference;
    IconListUnordered?: IElementReference;
    IconHorizontalRule?: IElementReference;
    IconLinkAdd?: IElementReference;
    IconLinkRemove?: IElementReference;
    IconQuote?: IElementReference;
    IconImage?: IElementReference;
    IconVideo?: IElementReference;
    IconVideoYoutube?: IElementReference;
    IconTable?: IElementReference;
    IconCode?: IElementReference;
    IconDrawing?: IElementReference;
    IconCopy?: IElementReference;
    IconCut?: IElementReference;
    IconPaste?: IElementReference;
    IconDelete?: IElementReference;
    IconClear?: IElementReference;
    IconSelectAll?: IElementReference;
    IconSave?: IElementReference;
    IconPrint?: IElementReference;
    IconUndo?: IElementReference;
    IconRedo?: IElementReference;
    AppendProps?: IPropsAny;
    ToolbarProps?: IPropsAny;
    ToolbarUpdatesProps?: IPropsAny;
    ToolbarActionsProps?: IPropsAny;
    ToggleButtonProps?: IPropsAny;
    ToggleButtonsProps?: IPropsAny;
    DividerProps?: IPropsAny;
    SelectProps?: IPropsAny;
    ListItemProps?: IPropsAny;
    TooltipProps?: IPropsAny;
    MiniMenuProps?: IPropsAny;
    DrawingProps?: IPropsAny;
    IconProps?: IPropsAny;
    ColorTextFieldProps?: IPropsAny;
}
declare const RichTextEditor: React.FC<IRichTextEditor>;
export default RichTextEditor;
