import React from 'react';
import { IBaseElement, ITonal, IColor, ISize, IStyle, IElement, IPropsAny } from '../types';
export interface IRoundMeter extends IBaseElement {
    tonal?: ITonal;
    color?: IColor;
    size?: ISize;
    parts?: number;
    lineCap?: 'inherit' | 'round' | 'square' | 'butt';
    padding?: number;
    gap?: number;
    border?: boolean;
    background?: boolean;
    boundary?: number;
    boundaryWidth?: number;
    arcProgress?: boolean;
    arcsVisible?: boolean;
    marksVisible?: boolean;
    labelsVisible?: boolean;
    marks?: Array<{
        size?: number;
        position?: number;
        padding?: number;
        [property: string]: any;
    }>;
    markSize?: number;
    markWidth?: number;
    labels?: Array<{
        value?: number;
        position?: number;
        padding?: number;
        style?: IStyle;
        [property: string]: any;
    }>;
    renderLabel?: (x: number, y: number, value: number, otherProps: any) => React.ReactNode;
    childrenPosition?: 'pre' | 'pre-marks' | 'pre-labels' | 'post';
    additional?: IElement;
    textProps?: IPropsAny;
    pathProps?: IPropsAny;
    SvgProps?: IPropsAny;
    MarkProps?: IPropsAny;
    LabelProps?: IPropsAny;
    BackgroundProps?: IPropsAny;
    BorderProps?: IPropsAny;
    ArcProps?: IPropsAny;
    ArcMainProps?: IPropsAny;
    ArcsProgressProps?: IPropsAny;
    ArcProgressProps?: IPropsAny;
}
declare const RoundMeter: React.FC<IRoundMeter>;
export default RoundMeter;
