import React from 'react';
import { ISurface } from '../Surface/Surface';
import { IElementReference, IPropsAny } from '../types';
export declare type TTrackValueVersion = 'image' | 'canvas';
export interface IScreenCapture extends ISurface {
    nameDefault?: string;
    name?: string;
    onChangeName?: (value: string) => any;
    view?: boolean;
    entirePage?: boolean;
    free?: boolean;
    type?: string;
    quality?: number;
    onInit?: (supported: boolean) => any;
    onView?: (event: React.MouseEvent<any> | KeyboardEvent) => any;
    onEntirePage?: (event: React.MouseEvent<any> | KeyboardEvent) => any;
    onFree?: (event: React.MouseEvent<any> | KeyboardEvent) => any;
    onFreeSave?: (event: React.MouseEvent<any> | KeyboardEvent) => any;
    onFreeClose?: (event: React.MouseEvent<any> | KeyboardEvent) => any;
    IconView?: IElementReference;
    IconEntirePage?: IElementReference;
    IconFree?: IElementReference;
    IconDownload?: IElementReference;
    TextFieldProps?: IPropsAny;
    TooltipProps?: IPropsAny;
    IconButtonProps?: IPropsAny;
    ImageCropProps?: IPropsAny;
}
declare const ScreenCapture: React.FC<IScreenCapture>;
export default ScreenCapture;
