import React from 'react';
import { TPaletteVersion } from '@amaui/style-react';
import { ILine } from '../Line/Line';
import { IValueBreakpoints, IMediaObject, IPropsAny } from '../types';
export declare type ISize = 'extra_small' | 'small' | 'regular' | 'large' | 'extra_large' | 'extra_extra_large';
export interface ISection extends ILine {
    themed?: boolean;
    title?: string | Partial<Record<IValueBreakpoints, string>>;
    description?: string | Partial<Record<IValueBreakpoints, string>>;
    show?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    reveal?: boolean;
    backgroundColor?: TPaletteVersion;
    backgroundGradient?: TPaletteVersion[];
    backgroundImage?: IMediaObject;
    backgroundVideo?: IMediaObject;
    overlay?: TPaletteVersion;
    overlayBlur?: number | boolean;
    size?: ISize | Partial<Partial<Record<IValueBreakpoints, ISize>>>;
    margin?: ISize | boolean | Partial<Partial<Record<IValueBreakpoints, ISize | boolean>>>;
    marginVertical?: ISize | boolean | Partial<Partial<Record<IValueBreakpoints, ISize | boolean>>>;
    padding?: ISize | boolean | Partial<Partial<Record<IValueBreakpoints, ISize | boolean>>>;
    maxWidth?: ISize | boolean | Partial<Partial<Record<IValueBreakpoints, ISize | boolean>>>;
    start?: any;
    end?: any;
    MainProps?: IPropsAny;
    TitleProps?: IPropsAny;
    DescriptionProps?: IPropsAny;
    HeaderProps?: IPropsAny;
    RevealProps?: IPropsAny;
    AdditionalProps?: IPropsAny;
}
declare const Section: React.FC<ISection>;
export default Section;
