"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Icon_1 = __importDefault(require("../Icon"));
const Line_1 = __importDefault(require("../Line"));
const Properties_1 = __importDefault(require("../Properties"));
const Section_1 = __importDefault(require("../Section/Section"));
const Type_1 = __importDefault(require("../Type"));
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const IconMaterialMapRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'Map', short_name: 'Map', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M14.35 20.775 9 18.9l-4.65 1.8q-.5.2-.925-.113Q3 20.275 3 19.75v-14q0-.325.188-.575.187-.25.512-.375l4.65-1.575q.325-.1.65-.113.325-.012.65.113L15 5.1l4.65-1.8q.5-.2.925.112.425.313.425.838v14q0 .325-.188.575-.187.25-.512.375l-4.65 1.575q-.325.1-.65.112-.325.013-.65-.112ZM14 18.55V6.85l-4-1.4v11.7Zm2 0 3-1V5.7l-3 1.15ZM5 18.3l3-1.15V5.45l-3 1ZM16 6.85v11.7Zm-8-1.4v11.7Z" }) })));
});
const IconMaterialCallRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'Call', short_name: 'Call', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M19.95 21q-3.225 0-6.287-1.438-3.063-1.437-5.425-3.8-2.363-2.362-3.8-5.425Q3 7.275 3 4.05q0-.45.3-.75t.75-.3H8.1q.35 0 .625.225t.325.575l.65 3.5q.05.35-.012.637-.063.288-.288.513L6.975 10.9q1.05 1.8 2.638 3.375Q11.2 15.85 13.1 17l2.35-2.35q.225-.225.588-.338.362-.112.712-.062l3.45.7q.35.075.575.337.225.263.225.613v4.05q0 .45-.3.75t-.75.3ZM6.025 9l1.65-1.65L7.25 5H5.025q.125 1.025.35 2.025.225 1 .65 1.975ZM19 18.95v-2.2l-2.35-.475-1.675 1.675q.975.425 1.988.675 1.012.25 2.037.325Zm-4-1.025ZM6.025 9Z" }) })));
});
const IconMaterialMailRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'Mail', short_name: 'Mail', viewBox: '0 0 24 24' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M4 20q-.825 0-1.412-.587Q2 18.825 2 18V6q0-.825.588-1.412Q3.175 4 4 4h16q.825 0 1.413.588Q22 5.175 22 6v12q0 .825-.587 1.413Q20.825 20 20 20ZM20 8l-7.475 4.675q-.125.075-.263.112-.137.038-.262.038t-.262-.038q-.138-.037-.263-.112L4 8v10h16Zm-8 3 8-5H4ZM4 8v.25-1.475.025V6v.8-.013V8.25 8v10Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    text: {
        wordBreak: 'break-word'
    },
    map: {
        position: 'relative',
        height: '400px',
        borderRadius: theme.methods.shape.radius.value(3),
        overflow: 'hidden'
    },
    backgroundOverlay: {
        position: 'absolute',
        inset: '0',
        zIndex: '4'
    }
}), { name: 'amaui-SectionContact' });
const Element = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiSectionContact) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Properties = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Properties) || Properties_1.default; }, [theme]);
    const Section = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Section) || Section_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const { map, mapPosition: mapPosition_ = 'left', heading, summary, address, phone, email, IconAddress = IconMaterialMapRounded, IconPhone = IconMaterialCallRounded, IconEmail = IconMaterialMailRounded, MapProps, HeadingProps, SummaryProps, PropertiesProps, className } = props, other = __rest(props, ["map", "mapPosition", "heading", "summary", "address", "phone", "email", "IconAddress", "IconPhone", "IconEmail", "MapProps", "HeadingProps", "SummaryProps", "PropertiesProps", "className"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef()
    };
    const mobile = (0, useMediaQuery_1.default)('(max-width: 768px)', { element: refs.root.current });
    let mapPosition = mapPosition_;
    if (mobile) {
        if (mapPosition === 'left')
            mapPosition = 'top';
        else if (mapPosition === 'right')
            mapPosition = 'bottom';
    }
    let styleOverlay = {};
    if (map === null || map === void 0 ? void 0 : map.overlay) {
        const palette = theme.palette.color[map === null || map === void 0 ? void 0 : map.overlay] || theme.methods.color(map === null || map === void 0 ? void 0 : map.overlay);
        styleOverlay = Object.assign(Object.assign({}, styleOverlay), { backgroundColor: theme.methods.palette.color.alpha(theme.methods.palette.color.value(undefined, 95, true, palette), 0.54) });
    }
    const mapElement = (map === null || map === void 0 ? void 0 : map.apiKey) && (map === null || map === void 0 ? void 0 : map.latitude) && (map === null || map === void 0 ? void 0 : map.longitude) && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ fullWidth: true, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('SectionContact', theme) && [
                'amaui-SectionContact-map'
            ],
            classes.map
        ]) }, { children: [map.overlay && ((0, jsx_runtime_1.jsx)("div", { className: (0, style_react_1.classNames)([
                    classes.backgroundOverlay
                ]), style: Object.assign({}, styleOverlay) })), (0, jsx_runtime_1.jsx)("iframe", { title: 'amaui-google-map', src: `https://www.google.com/maps/embed/v1/place?q=${map === null || map === void 0 ? void 0 : map.latitude},${map === null || map === void 0 ? void 0 : map.longitude}${(map === null || map === void 0 ? void 0 : map.apiKey) ? `&key=${map === null || map === void 0 ? void 0 : map.apiKey}` : ''}`, width: '100%', height: '100%', loading: 'lazy', allowFullScreen: true, referrerPolicy: 'no-referrer-when-downgrade' })] })));
    const properties = [];
    if (address)
        properties.push({ name: (0, jsx_runtime_1.jsx)(IconAddress, {}), value: address });
    if (phone)
        properties.push({ name: (0, jsx_runtime_1.jsx)(IconPhone, {}), value: phone });
    if (email)
        properties.push({ name: (0, jsx_runtime_1.jsx)(IconEmail, {}), value: email });
    return ((0, jsx_runtime_1.jsxs)(Section, Object.assign({ ref: (item) => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, MainProps: {
            gap: 4
        }, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('SectionContact', theme) && [
                'amaui-SectionContact-root'
            ],
            className,
            classes.root
        ]) }, other, { children: [mapPosition === 'top' && mapElement, (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 4, direction: 'row', fullWidth: true }, { children: [mapPosition === 'left' && mapElement, (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 5, flex: true, fullWidth: true, style: {
                            paddingTop: ['left', 'right'].includes(mapPosition) ? 24 : 0
                        } }, { children: [(heading || summary) && ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0.5 }, { children: [heading && ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 't1', dangerouslySetInnerHTML: {
                                            __html: (0, utils_1.textToInnerHTML)(heading)
                                        } }, HeadingProps, { className: (0, style_react_1.classNames)([
                                            (0, utils_2.staticClassName)('SectionContact', theme) && [
                                                'amaui-SectionContact-heading'
                                            ],
                                            HeadingProps === null || HeadingProps === void 0 ? void 0 : HeadingProps.className,
                                            classes.text
                                        ]) }))), summary && ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b3', dangerouslySetInnerHTML: {
                                            __html: (0, utils_1.textToInnerHTML)(summary)
                                        } }, SummaryProps, { className: (0, style_react_1.classNames)([
                                            (0, utils_2.staticClassName)('SectionContact', theme) && [
                                                'amaui-SectionContact-summary'
                                            ],
                                            SummaryProps === null || SummaryProps === void 0 ? void 0 : SummaryProps.className,
                                            classes.text
                                        ]) })))] }))), !!properties.length && ((0, jsx_runtime_1.jsx)(Properties, Object.assign({ version: 'row', gap: 1, values: properties }, PropertiesProps, { PropertyProps: Object.assign({ responsive: false }, PropertiesProps === null || PropertiesProps === void 0 ? void 0 : PropertiesProps.PropertyProps) })))] })), mapPosition === 'right' && mapElement] })), mapPosition === 'bottom' && mapElement] })));
});
Element.displayName = 'amaui-SectionContact';
exports.default = Element;
