"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Text_1 = __importDefault(require("../Text"));
const Image_1 = __importDefault(require("../Image"));
const Section_1 = __importDefault(require("../Section/Section"));
const AudioPlayer_1 = __importDefault(require("../AudioPlayer"));
const VideoPlayer_1 = __importDefault(require("../VideoPlayer"));
const Line_1 = __importDefault(require("../Line"));
const Type_1 = __importDefault(require("../Type"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    wrapperRow: {
        '&.amaui-Line-direction-row': {
            '& > *': {
                width: '50%'
            }
        }
    }
}), { name: 'amaui-SectionTextMedia' });
const SectionTextMedia = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiSectionTextMedia) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Text = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Text) || Text_1.default; }, [theme]);
    const Image = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Image) || Image_1.default; }, [theme]);
    const Section = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Section) || Section_1.default; }, [theme]);
    const AudioPlayer = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.AudioPlayer) || AudioPlayer_1.default; }, [theme]);
    const VideoPlayer = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.VideoPlayer) || VideoPlayer_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const { classes } = useStyle();
    const { size, title, description, mediaPosition = 'top', media, MainProps, TitleProps, WrapperProps, TextProps, MediaProps, className } = props, other = __rest(props, ["size", "title", "description", "mediaPosition", "media", "MainProps", "TitleProps", "WrapperProps", "TextProps", "MediaProps", "className"]);
    const refs = {
        root: react_1.default.useRef()
    };
    let mediaElement;
    const mediaProps = Object.assign({ size, themed: true, color: 'primary' }, MediaProps);
    const mime = (media === null || media === void 0 ? void 0 : media.mime) || '';
    if (mime.includes('image')) {
        mediaElement = ((0, jsx_runtime_1.jsx)(Image, Object.assign({ src: (0, utils_1.is)('string', media) ? media : media === null || media === void 0 ? void 0 : media.src }, mediaProps)));
    }
    if (mime.includes('audio')) {
        mediaElement = ((0, jsx_runtime_1.jsx)(AudioPlayer, Object.assign({ src: (0, utils_1.is)('string', media) ? media : media === null || media === void 0 ? void 0 : media.src, name: media === null || media === void 0 ? void 0 : media.name, meta: media === null || media === void 0 ? void 0 : media.meta, versions: media === null || media === void 0 ? void 0 : media.versions, mime: media === null || media === void 0 ? void 0 : media.mime }, mediaProps)));
    }
    if (mime.includes('video')) {
        mediaElement = ((0, jsx_runtime_1.jsx)(VideoPlayer, Object.assign({ src: (0, utils_1.is)('string', media) ? media : media === null || media === void 0 ? void 0 : media.src, name: media === null || media === void 0 ? void 0 : media.name, meta: media === null || media === void 0 ? void 0 : media.meta, versions: media === null || media === void 0 ? void 0 : media.versions, thumbnails: media === null || media === void 0 ? void 0 : media.thumbnails, mime: media === null || media === void 0 ? void 0 : media.mime }, mediaProps)));
    }
    return ((0, jsx_runtime_1.jsx)(Section, Object.assign({ ref: (item) => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, size: size, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('SectionTextMedia', theme) && [
                'amaui-SectionTextMedia-root'
            ],
            className,
            classes.root
        ]) }, other, { children: (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 7, fullWidth: true }, MainProps, { className: (0, style_react_1.classNames)([
                MainProps === null || MainProps === void 0 ? void 0 : MainProps.className,
                classes.header
            ]) }, { children: [(0, utils_1.is)('string', title) && ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: size === 'large' ? 'h1' : size === 'regular' ? 'h2' : 'h3', align: 'center' }, TitleProps, { dangerouslySetInnerHTML: {
                        __html: (0, utils_1.textToInnerHTML)(title)
                    } }))), (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 4, direction: {
                        xxs: 'column',
                        xs: 'column',
                        sm: 'column',
                        md: 'column',
                        default: ['left', 'right'].includes(mediaPosition) ? 'row' : 'column'
                    }, align: ['left', 'right'].includes(mediaPosition) ? 'center' : 'center', justify: ['left', 'right'].includes(mediaPosition) ? 'flex-start' : 'center', fullWidth: true }, WrapperProps, { className: (0, style_react_1.classNames)([
                        classes.wrapper,
                        media && classes.wrapperRow
                    ]) }, { children: [['top', 'left'].includes(mediaPosition) && mediaElement, (0, utils_1.is)('string', description) && ((0, jsx_runtime_1.jsx)(Text, Object.assign({ align: 'center', columns: 1 }, TextProps, { TypeProps: Object.assign(Object.assign({}, TextProps === null || TextProps === void 0 ? void 0 : TextProps.TypeProps), { version: size === 'large' ? 'b1' : [undefined, 'regular'].includes(size) ? 'b2' : 'b3' }), value: description }))), ['bottom', 'right'].includes(mediaPosition) && mediaElement] }))] })) })));
});
SectionTextMedia.displayName = 'amaui-SectionTextMedia';
exports.default = SectionTextMedia;
