"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Icon_1 = __importDefault(require("../Icon"));
const Menu_1 = __importDefault(require("../Menu"));
const Chip_1 = __importDefault(require("../Chip"));
const Chips_1 = __importDefault(require("../Chips"));
const TextField_1 = __importDefault(require("../TextField"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Line_1 = __importDefault(require("../Line"));
const utils_2 = require("../utils");
const IconMaterialArrowDropDownRounded = react_1.default.forwardRef((props, ref) => {
    return ((0, jsx_runtime_1.jsx)(Icon_1.default, Object.assign({ ref: ref, name: 'ArrowDropDownRounded', short_name: 'ArrowDropDown' }, props, { children: (0, jsx_runtime_1.jsx)("path", { d: "M11.3 14.3 8.7 11.7Q8.225 11.225 8.488 10.613Q8.75 10 9.425 10H14.575Q15.25 10 15.512 10.613Q15.775 11.225 15.3 11.7L12.7 14.3Q12.55 14.45 12.375 14.525Q12.2 14.6 12 14.6Q11.8 14.6 11.625 14.525Q11.45 14.45 11.3 14.3Z" }) })));
});
const useStyle = (0, style_react_1.style)(theme => {
    const overflow = {
        width: '100%',
        overflow: 'hidden',
        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis'
    };
    return {
        root: {
            flex: 'unset',
            minWidth: '140px',
            '& .amaui-TextField-input': {
                position: 'absolute',
                left: '0',
                bottom: '0',
                pointerEvents: 'none',
                opacity: '0'
            },
            '& .amaui-TextField-input-wrapper': {
                cursor: 'pointer'
            }
        },
        wrapper: {
            position: 'relative'
        },
        inputWrapper: {
            cursor: 'pointer',
            '&.amaui-TextField-input-wrapper': {
                cursor: 'pointer'
            }
        },
        inputWrapper_chip_size_small: {
            minHeight: '48px'
        },
        inputWrapper_chip_size_regular: {
            minHeight: '56px'
        },
        inputWrapper_chip_size_large: {
            minHeight: '64px'
        },
        input: Object.assign(Object.assign(Object.assign({ width: '100%', margin: '0', border: '0', color: theme.palette.text.default.primary, background: 'transparent', '-webkit-tap-highlight-color': 'transparent', textAlign: 'start', borderRadius: `${theme.shape.radius.unit / 2}px ${theme.shape.radius.unit / 2}px 0 0` }, theme.typography.values.b2), overflow), { cursor: 'pointer', pointerEvents: 'none' }),
        chip: {
            '&.amaui-TextField-input-wrapper': {
                height: 'unset'
            }
        },
        chipGroup: {
            pointerEvents: 'none'
        },
        chipGroup_padding: {
            paddingTop: theme.methods.space.value(0.5, 'px')
        },
        arrow: {
            transition: theme.methods.transitions.make('transform')
        },
        arrow_open: {
            transform: 'rotate(-180deg)'
        },
        menu_autoWidth: {
            width: '100%'
        },
        open: {
            '&.amaui-TextField-root': {
                cursor: 'default'
            }
        },
        fullWidth: {
            width: '100%'
        },
        readOnly: {
            '&.amaui-TextField-root': {
                cursor: 'default'
            }
        },
        disabled: {
            '&.amaui-TextField-root': {
                cursor: 'default'
            }
        }
    };
}, { name: 'amaui-Select' });
const Select = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiSelect) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Menu = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Menu) || Menu_1.default; }, [theme]);
    const Chip = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Chip) || Chip_1.default; }, [theme]);
    const ChipGroup = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.ChipGroup) || Chips_1.default; }, [theme]);
    const TextField = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.TextField) || TextField_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const { tonal = true, color = 'primary', size = 'regular', version = 'filled', value: value_, valueDefault, onChange, label, multiple, prefix, sufix, start, end, autoWidth = true, getLabel, fullWidth, chip, readOnly, disabled, renderValues: renderValues_, WrapperProps, ChipGroupProps, ListProps, MenuProps, className, style, children: children_ } = props, other = __rest(props, ["tonal", "color", "size", "version", "value", "valueDefault", "onChange", "label", "multiple", "prefix", "sufix", "start", "end", "autoWidth", "getLabel", "fullWidth", "chip", "readOnly", "disabled", "renderValues", "WrapperProps", "ChipGroupProps", "ListProps", "MenuProps", "className", "style", "children"]);
    const children = react_1.default.Children.toArray(children_);
    const [value, setValue] = react_1.default.useState(() => {
        const values = valueDefault !== undefined ? valueDefault : value_;
        return multiple ? ((0, utils_1.is)('array', values) ? values : [values]).filter(Boolean) : values;
    });
    const [open, setOpen] = react_1.default.useState(false);
    const [mouseDown, setMouseDown] = react_1.default.useState(false);
    const [focus, setFocus] = react_1.default.useState(false);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef(),
        wrapper: react_1.default.useRef(),
        menu: react_1.default.useRef(),
        input: react_1.default.useRef(),
        ids: {
            list: react_1.default.useId()
        }
    };
    const styles = {
        root: {}
    };
    react_1.default.useEffect(() => {
        var _a;
        const method = (event) => {
            if (event.key === 'Escape')
                onClose();
        };
        const rootDocument = (0, utils_1.isEnvironment)('browser') ? (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        rootDocument.addEventListener('keydown', method);
        return () => {
            // Clean up
            rootDocument.removeEventListener('keydown', method);
        };
    }, []);
    react_1.default.useEffect(() => {
        if (value_ !== undefined && value_ !== value)
            setValue(value_);
    }, [value_]);
    const onMouseDown = react_1.default.useCallback((event) => {
        if (!disabled && !readOnly)
            setMouseDown(true);
    }, []);
    const onMouseUp = react_1.default.useCallback((event) => {
        if (!disabled && !readOnly)
            setMouseDown(false);
    }, []);
    const onFocus = react_1.default.useCallback((event) => {
        if (!disabled && !readOnly)
            setFocus(true);
    }, []);
    const onBlur = react_1.default.useCallback((event) => {
        if (!disabled && !readOnly)
            setFocus(false);
    }, []);
    const onClick = react_1.default.useCallback((event) => {
        if (!disabled && !readOnly)
            setOpen(open_ => {
                if (open_)
                    setFocus(false);
                return !open_;
            });
    }, []);
    const onClickArrowDown = react_1.default.useCallback((event) => {
        if (!disabled && !readOnly)
            setOpen(open_ => !open_);
    }, []);
    const onEnterKeyDown = react_1.default.useCallback((event) => {
        if (event.key === 'Enter' && !disabled && !readOnly)
            setOpen(open_ => {
                if (open_)
                    refs.input.current.focus();
                return !open_;
            });
    }, []);
    const onClose = react_1.default.useCallback((refocus = true) => {
        if (!disabled && !readOnly) {
            setOpen(open_ => {
                if (open_ && refocus)
                    refs.input.current.focus();
                return false;
            });
        }
    }, []);
    const onSelect = (newValue) => {
        let values = multiple ? (0, utils_1.is)('array', value) ? value : [value] : value;
        values = multiple ? (0, utils_1.unique)([...values, newValue]) : newValue;
        // Inner controlled value
        if (!props.hasOwnProperty('value'))
            setValue(values);
        if ((0, utils_1.is)('function', onChange))
            onChange(values);
    };
    const onUnselect = (itemValue) => {
        if (multiple) {
            let values = (0, utils_1.is)('array', value) ? value : [value];
            values = values.filter(item => item !== itemValue);
            // Inner controlled value
            if (!props.hasOwnProperty('value'))
                setValue(values);
            if ((0, utils_1.is)('function', onChange))
                onChange(values);
        }
    };
    const renderValue = (values = value) => {
        const item = children.find((item_) => { var _a; return ((_a = item_.props) === null || _a === void 0 ? void 0 : _a.value) === values; });
        const getItemLabel = getLabel || (() => {
            var _a, _b, _c, _d, _e, _f, _g, _h;
            return (((_a = item.props) === null || _a === void 0 ? void 0 : _a.name) || ((_b = item.props) === null || _b === void 0 ? void 0 : _b.label) || ((_c = item.props) === null || _c === void 0 ? void 0 : _c.primary) || ((_d = item.props) === null || _d === void 0 ? void 0 : _d.secondary) || ((_e = item.props) === null || _e === void 0 ? void 0 : _e.tertiary) || (((_f = item.props) === null || _f === void 0 ? void 0 : _f.value) !== undefined ? (_g = item.props) === null || _g === void 0 ? void 0 : _g.value : (_h = item.props) === null || _h === void 0 ? void 0 : _h.children));
        });
        return item ? getItemLabel(item, props) : value;
    };
    const renderValues = renderValues_ || ((value__ = value) => {
        if (multiple) {
            if (chip) {
                return ((0, jsx_runtime_1.jsx)(ChipGroup, Object.assign({ wrap: 'wrap', size: size, className: (0, style_react_1.classNames)([
                        classes.chipGroup,
                        version !== 'outlined' && classes.chipGroup_padding
                    ]) }, ChipGroupProps, { children: value__.map(item => ((0, jsx_runtime_1.jsx)(Chip, Object.assign({ focus: false }, { children: renderValue(item) }), item))) })));
            }
            return value.flatMap((item, index) => [renderValue(item), ...(index < value.length - 1 ? [', '] : [])]);
        }
        return renderValue(value);
    });
    const endIcons = [
        end,
        ...(!readOnly ? [
            (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ size: 'small', fontSize: 24, onClick: onClickArrowDown, "aria-expanded": open, "aria-controls": refs.ids.list }, { children: (0, jsx_runtime_1.jsx)(IconMaterialArrowDropDownRounded, { className: (0, style_react_1.classNames)([
                        classes.arrow,
                        open && classes.arrow_open
                    ]) }) }), 1)
        ] : [])
    ];
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 0, direction: 'column', fullWidth: fullWidth }, WrapperProps, { ref: item => {
            if (WrapperProps === null || WrapperProps === void 0 ? void 0 : WrapperProps.ref) {
                if ((0, utils_1.is)('function', WrapperProps.ref))
                    WrapperProps.ref(item);
                else
                    WrapperProps.ref.current = item;
            }
            refs.wrapper.current = item;
        }, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Select', theme) && [
                'amaui-Select-wrapper',
                WrapperProps === null || WrapperProps === void 0 ? void 0 : WrapperProps.className,
                classes.wrapper
            ]
        ]) }, { children: [(0, jsx_runtime_1.jsx)(TextField, Object.assign({ ref: refs.input, rootRef: (item => {
                    if (ref) {
                        if ((0, utils_1.is)('function', ref))
                            ref(item);
                        else
                            ref.current = item;
                    }
                    refs.root.current = item;
                }), onBlur: onBlur, onFocus: onFocus, enabled: open || focus || mouseDown || !!((0, utils_1.is)('array', value) ? value.length : value !== undefined), focus: open || focus || mouseDown, className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('Select', theme) && [
                        'amaui-Select-root',
                        open && `amaui-Select-open`,
                        mouseDown && `amaui-Select-mouse-down`,
                        focus && `amaui-Select-focus`
                    ],
                    className,
                    classes.root,
                    open && classes.open,
                    fullWidth && classes.fullWidth,
                    disabled && classes.disabled
                ]), tonal: tonal, color: color, size: size, version: version, label: label, prefix: prefix, sufix: sufix, start: start, end: endIcons, readOnly: readOnly, endVerticalAlign: 'center', role: 'combobox', "aria-multiselectable": multiple, "aria-controls": refs.ids.list, "aria-expanded": open, "aria-haspopup": 'listbox', "aria-labelledby": label, "aria-disabled": disabled, disabled: disabled, InputWrapperProps: {
                    className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('Select', theme) && [
                            'amaui-Select-input-wrapper'
                        ],
                        classes.inputWrapper,
                        chip && [
                            classes.chip,
                            classes[`inputWrapper_chip_size_${size}`]
                        ],
                        open && classes.open,
                        readOnly && classes.readOnly
                    ]),
                    onMouseDown,
                    onMouseUp,
                    onClick,
                    onKeyDown: onEnterKeyDown
                }, inputProps: {
                    disabled: true,
                    readOnly: true
                }, style: Object.assign(Object.assign({}, style), styles.root) }, other, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, style_react_1.classNames)([
                        (0, utils_2.staticClassName)('Select', theme) && [
                            'amaui-Select-input'
                        ],
                        classes.input,
                        chip && classes.chip,
                        open && classes.open,
                        readOnly && classes.readOnly
                    ]) }, { children: renderValues(value) })) })), children && ((0, jsx_runtime_1.jsx)(Menu, Object.assign({ ref: refs.menu, open: open, portal: false, onClose: () => onClose(false), anchorElement: refs.root.current, transformOrigin: 'center top', transformOriginSwitch: 'center bottom', maxWidth: 'unset', menuItems: children.map((item, index) => {
                    var _a, _b, _c, _d;
                    return (react_1.default.cloneElement(item, {
                        key: index,
                        role: 'option',
                        selected: multiple ? value.includes((_a = item.props) === null || _a === void 0 ? void 0 : _a.value) : value === ((_b = item.props) === null || _b === void 0 ? void 0 : _b.value),
                        preselected: !(multiple ? value.includes((_c = item.props) === null || _c === void 0 ? void 0 : _c.value) : value === ((_d = item.props) === null || _d === void 0 ? void 0 : _d.value)),
                        onMouseUp,
                        onMouseDown,
                        onClick: (event) => {
                            var _a, _b, _c, _d, _e;
                            if (multiple && value.includes((_a = item.props) === null || _a === void 0 ? void 0 : _a.value))
                                onUnselect((_b = item.props) === null || _b === void 0 ? void 0 : _b.value);
                            else
                                onSelect((_c = item.props) === null || _c === void 0 ? void 0 : _c.value);
                            if ((0, utils_1.is)('function', (_d = item.props) === null || _d === void 0 ? void 0 : _d.onClick))
                                (_e = item.props) === null || _e === void 0 ? void 0 : _e.onClick(event);
                            if (!multiple)
                                setOpen(false);
                        }
                    }));
                }), AppendProps: Object.assign({}, (!autoWidth && {
                    alignment: 'start'
                })), ModalProps: {
                // focus: !MenuProps.portal
                }, style: styles.menu, ListProps: Object.assign({ menu: true, size, role: 'listbox', id: refs.ids.list, 'aria-label': label }, ListProps) }, MenuProps, { className: (0, style_react_1.classNames)([
                    MenuProps === null || MenuProps === void 0 ? void 0 : MenuProps.className,
                    autoWidth && classes.menu_autoWidth
                ]) })))] })));
});
Select.displayName = 'amaui-Select';
exports.default = Select;
