import React from 'react';
import { IBaseElement, ITonal, IColor, ISize, IElement, IPropsAny } from '../types';
export declare type TSliderValue = number | Array<number>;
export interface ISlider extends IBaseElement {
    tonal?: ITonal;
    color?: IColor;
    size?: ISize;
    value?: TSliderValue;
    valueDefault?: TSliderValue;
    onChange?: (value: TSliderValue) => any;
    orientation?: 'vertical' | 'horizontal';
    marks?: Array<{
        value?: number;
        label?: IElement;
    }>;
    precision?: number;
    min?: number;
    max?: number;
    tooltip?: 'always' | boolean;
    labels?: boolean;
    onlyMarks?: boolean;
    labelTooltipResolve?: (value: number) => IElement;
    iconButtonPositionResolve?: (value: number, normalized: number, size: ISize) => string;
    noTrack?: boolean;
    noButtons?: boolean;
    square?: boolean;
    inverted?: boolean;
    readOnly?: boolean;
    disabled?: boolean;
    icon?: any;
    IconButtonProps?: IPropsAny;
    LabelProps?: IPropsAny;
    TooltipProps?: IPropsAny;
}
declare const Slider: React.FC<ISlider>;
export default Slider;
