import React from 'react';
import { ISurface } from '../Surface/Surface';
import { ISize, IElement, IElementReference, IPropsAny } from '../types';
export interface ISnackbar extends ISurface {
    size?: ISize;
    open?: boolean;
    primary?: IElement;
    end?: IElement;
    position?: 'top' | 'bottom';
    alignment?: 'start' | 'left' | 'center' | 'right' | 'end';
    autoHide?: boolean;
    autoHideDuration?: number;
    resumeFromStart?: boolean;
    fixed?: boolean;
    closeButton?: boolean;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    onClose?: () => any;
    TransitionComponent?: IElementReference;
    TransitionComponentProps?: IPropsAny;
}
declare const Snackbar: React.FC<ISnackbar>;
export default Snackbar;
