import React from 'react';
import { ILine } from '../Line/Line';
import { ITonal, IColor, IVersion, IElement, IElementReference, IPropsAny } from '../types';
export interface ISpeedDial extends Omit<ILine, 'direction'> {
    tonal?: ITonal;
    color?: IColor;
    version?: IVersion;
    open?: boolean;
    openDefault?: boolean;
    onOpen?: () => any;
    onClose?: () => any;
    in?: boolean;
    position?: 'top' | 'bottom';
    alignment?: 'start' | 'left' | 'center' | 'right' | 'end';
    direction?: 'top' | 'left' | 'right' | 'bottom';
    closeOnClick?: boolean;
    tooltipOpen?: boolean;
    start?: any;
    end?: any;
    noRotate?: boolean;
    tooltipLabel?: IElement;
    onKeyDown?: (event: React.KeyboardEvent<any>) => any;
    disabled?: boolean;
    IconOpen?: IElementReference;
    Icon?: IElementReference;
    FabTransitionComponent?: IElementReference;
    SpeeDialItemTransitionComponent?: IElementReference;
    TooltipProps?: IPropsAny;
    FabProps?: IPropsAny;
    FabWrapperProps?: IPropsAny;
    FabTransitionComponentProps?: IPropsAny;
    SpeeDialItemTransitionComponentProps?: IPropsAny;
}
declare const SpeedDial: React.FC<ISpeedDial>;
export default SpeedDial;
