"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Tooltip_1 = __importDefault(require("../Tooltip"));
const IconButton_1 = __importDefault(require("../IconButton"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        position: 'relative',
        lineHeight: '0'
    },
    no_render: {
        '& .amaui-Button-root': {
            boxShadow: theme.shadows.values.default[6],
            '&:hover': {
                boxShadow: theme.shadows.values.default[8]
            },
            '&.amaui-Button-focus': {
                boxShadow: theme.shadows.values.default[8]
            }
        }
    }
}), { name: 'amaui-SpeedDialItem' });
const SpeedDialItem = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiSpeedDialItem) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Tooltip = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Tooltip) || Tooltip_1.default; }, [theme]);
    const IconButton = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.IconButton) || IconButton_1.default; }, [theme]);
    const { open, name, label: label_, tooltipOpen, closeOnClick, render, onBlur, onFocus, Icon, TooltipProps = {
        alignment: 'center',
        interactive: false
    }, Component = 'div', className, children } = props, other = __rest(props, ["open", "name", "label", "tooltipOpen", "closeOnClick", "render", "onBlur", "onFocus", "Icon", "TooltipProps", "Component", "className", "children"]);
    const { classes } = useStyle();
    delete TooltipProps.open;
    if (tooltipOpen)
        TooltipProps.open = true;
    const label = name !== undefined ? name : label_;
    return ((0, jsx_runtime_1.jsx)(Component, Object.assign({ ref: ref, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('SpeedDialItem', theme) && [
                `amaui-SpeedDialItem-root`
            ],
            className,
            classes.root,
            !(0, utils_1.is)('function', render) && classes.no_render
        ]) }, { children: (0, utils_1.is)('function', render) ?
            render(Object.assign({ onBlur,
                onFocus,
                TooltipProps }, other)) :
            (0, jsx_runtime_1.jsx)(Tooltip, Object.assign({ label: label, portal: false, nowrap: true }, TooltipProps, { children: (0, jsx_runtime_1.jsx)(IconButton, Object.assign({ onBlur: onBlur, onFocus: onFocus }, other, { children: (0, jsx_runtime_1.jsx)(Icon, {}) })) })) })));
});
SpeedDialItem.displayName = 'amaui-SpeedDialItem';
exports.default = SpeedDialItem;
