"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
}), { name: 'amaui-SpyScroll' });
const SpyScroll = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiSpyScroll) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const { ids, offset, offsetStart, addClassName, addStyle, onActive, parent, className, style, children } = props, other = __rest(props, ["ids", "offset", "offsetStart", "addClassName", "addStyle", "onActive", "parent", "className", "style", "children"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef(),
        active: react_1.default.useRef([]),
        parent: react_1.default.useRef(parent),
        props: react_1.default.useRef(),
        onActive: react_1.default.useRef(onActive)
    };
    refs.props.current = props;
    refs.parent.current = parent;
    refs.onActive.current = onActive;
    react_1.default.useEffect(() => {
        var _a;
        // Listen to window scroll value
        const methodElement = (element) => {
            if (element) {
                if (refs.parent.current) {
                    const rect = element.getBoundingClientRect();
                    const parentScrollTop = refs.parent.current.scrollTop;
                    const parentScrollLeft = refs.parent.current.scrollLeft;
                    const offsetTop = element.offsetTop;
                    const offsetLeft = element.offsetLeft;
                    if (
                    // vertically
                    ((refs.parent.current.scrollHeight > refs.parent.current.clientHeight) &&
                        (offsetTop <= parentScrollTop &&
                            parentScrollTop < offsetTop + rect.height)) ||
                        // horizontally
                        ((refs.parent.current.scrollWidth > refs.parent.current.clientWidth) &&
                            (offsetLeft <= parentScrollLeft &&
                                parentScrollLeft < offsetLeft + rect.width)))
                        return true;
                }
                else {
                    const rect = element.getBoundingClientRect();
                    // SpyScroll
                    const offset_ = refs.props.current.offsetStart !== undefined ? refs.props.current.offsetStart : refs.props.current.offset !== undefined ? refs.props.current.offset : 0;
                    const height = refs.parent.current ? refs.parent.current.clientHeight : window.innerHeight;
                    const width = refs.parent.current ? refs.parent.current.clientWidth : window.innerWidth;
                    if (
                    // Top
                    (
                    // Top
                    (rect.top - offset_ < height && rect.top - offset_ > 0) &&
                        (
                        // Left
                        (rect.left - offset_ < width && rect.left - offset_ > 0) ||
                            // Right
                            (rect.left - offset_ < width && rect.right + offset_ > 0))) ||
                        // Left
                        (
                        // Left
                        (rect.left - offset_ < width && rect.left - offset_ > 0) &&
                            (
                            // Top
                            (rect.top - offset_ < height && rect.top - offset_ > 0) ||
                                // Bottom
                                (rect.top - offset_ < height && rect.bottom + offset_ > 0))) ||
                        // Right
                        (
                        // Right
                        (rect.left - offset_ < width && rect.right + offset_ > 0) &&
                            (
                            // Top
                            (rect.top - offset_ < height && rect.top - offset_ > 0) ||
                                // Bottom
                                (rect.top - offset_ < height && rect.bottom + offset_ > 0))) ||
                        // Bottom
                        (
                        // Bottom
                        (rect.top - offset_ < height && rect.bottom + offset_ > 0) &&
                            (
                            // Left
                            (rect.left - offset_ < width && rect.left - offset_ > 0) ||
                                // Right
                                (rect.left - offset_ < width && rect.right + offset_ > 0))))
                        return true;
                }
            }
        };
        const method = () => {
            var _a;
            // Find first active id
            let id;
            const rootElement_ = (0, utils_1.isEnvironment)('browser') ? refs.parent.current || (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
            (0, utils_1.Try)(() => id = refs.props.current.ids.find((item) => methodElement(rootElement_.querySelector(`#${item}`.replace('##', '#')))));
            if (id && refs.root.current) {
                // Update all elements in root
                // Remove active className and style from
                // all previous active elements
                for (const element of refs.active.current) {
                    // addClassName
                    element.classList.remove(refs.props.current.addClassName);
                    // addStyle
                    if (refs.props.current.addStyle) {
                        Object.keys(refs.props.current.addStyle).forEach(item => {
                            element.style.removeProperty(item);
                        });
                    }
                }
                // And add to all elements with href containing #id with addClassName and style
                refs.active.current = (0, utils_1.unique)([
                    // a elemnts with id
                    ...Array.from(refs.root.current.querySelectorAll(`[href$='#${id}']`)),
                    // elements active for multiple ids
                    ...Array.from(refs.root.current.querySelectorAll(`[data-amaui-spy-scroll~=${id}]`))
                ]).filter(Boolean);
                for (const element of refs.active.current) {
                    // addClassName
                    if (!element.classList.contains(refs.props.current.addClassName))
                        element.classList.add(refs.props.current.addClassName);
                    // addStyle
                    if (refs.props.current.addStyle) {
                        Object.keys(refs.props.current.addStyle).forEach(item => {
                            element.style[item] = refs.props.current.addStyle[item];
                        });
                    }
                }
                // onActive
                if ((0, utils_1.is)('function', refs.onActive.current))
                    refs.onActive.current(id);
            }
            else {
                // Remove active className and style from
                // all previous active elements
                for (const element of refs.active.current) {
                    // addClassName
                    element.classList.remove(refs.props.current.addClassName);
                    // addStyle
                    if (refs.props.current.addStyle) {
                        Object.keys(refs.props.current.addStyle).forEach(item => {
                            element.style.removeProperty(item);
                        });
                    }
                }
            }
        };
        // Initial
        method();
        const rootElement = (0, utils_1.isEnvironment)('browser') ? refs.parent.current || (((_a = refs.root.current) === null || _a === void 0 ? void 0 : _a.ownerDocument) || window.document) : undefined;
        if (refs.root.current) {
            rootElement.addEventListener('scroll', method);
        }
        return () => {
            if (refs.root.current) {
                rootElement.removeEventListener('scroll', method);
            }
        };
    }, [parent]);
    return ((0, jsx_runtime_1.jsx)(react_1.default.Fragment, { children: react_1.default.cloneElement(children, Object.assign({ ref: (item) => {
                if (ref) {
                    if ((0, utils_1.is)('function', ref))
                        ref(item);
                    else
                        ref.current = item;
                }
                refs.root.current = item;
            }, className: (0, style_react_1.classNames)([
                (0, utils_2.staticClassName)('SpyScroll', theme) && [
                    'amaui-SpyScroll-root'
                ],
                children.props.className,
                className,
                classes.root
            ]) }, other)) }));
});
SpyScroll.displayName = 'amaui-SpyScroll';
exports.default = SpyScroll;
