import React from 'react';
import { ILine } from '../Line/Line';
import { ITonal, IColor, IVersion, IElement, IPropsAny } from '../types';
export interface IStep extends ILine {
    tonal?: ITonal;
    color?: IColor;
    version?: IVersion;
    iconColor?: IColor;
    iconColorActive?: IColor;
    dividerColor?: IColor;
    dividerColorActive?: IColor;
    step?: number;
    activeStep?: number;
    active?: boolean;
    completed?: boolean;
    primary?: IElement;
    secondary?: IElement;
    stepDirection?: 'row' | 'column';
    orientation?: 'vertical' | 'horizontal';
    button?: boolean;
    divider?: boolean;
    renderIcon?: (step: number, active: boolean, completed: boolean, activeStep: number) => IElement;
    ListItemProps?: IPropsAny;
    DividerProps?: IPropsAny;
}
declare const Step: React.FC<IStep>;
export default Step;
