"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Interaction_1 = __importDefault(require("../Interaction"));
const PaginationItem_1 = __importDefault(require("../PaginationItem"));
const Divider_1 = __importDefault(require("../Divider"));
const Surface_1 = __importDefault(require("../Surface"));
const ListItem_1 = __importDefault(require("../ListItem"));
const Line_1 = __importDefault(require("../Line"));
const Buttons_1 = require("../Buttons/Buttons");
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        position: 'relative',
        transition: theme.methods.transitions.make('opacity')
    },
    icon: {
        pointerEvents: 'none'
    },
    inactive: {
        userSelect: 'none',
        opacity: theme.palette.visual_contrast.default.opacity.disabled
    },
    direction_row: {},
    direction_column: {
        flex: '1 1 auto',
        '& .amaui-ListItem-text': {
            textAlign: 'center'
        }
    },
    button: {
        userSelect: 'none',
        cursor: 'pointer'
    },
    divider: {
        position: 'absolute',
        '&.amaui-Divider-root': {
            margin: '0',
            transition: theme.methods.transitions.make(['background', 'height'])
        }
    },
    divider_orientation_horizontal: {
        top: '20px',
        right: '0',
        transform: 'translate(calc(-50% - 70px), -50%)',
        '&.amaui-Divider-root': {
            width: 'calc(100% - 62px)'
        }
    },
    divider_orientation_vertical: {
        left: '50%',
        top: '0',
        transform: 'translate(-50%, calc(-50% - 16px))',
        '&.amaui-Divider-root': {
            height: '50%'
        }
    },
    divider_active_orientation_horizontal: {
        '&.amaui-Divider-root': {
            height: '4px'
        }
    },
    divider_active_orientation_vertical: {
        '&.amaui-Divider-root': {
            width: '4px'
        }
    }
}), { name: 'amaui-Step' });
const Step = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiStep) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Interaction = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Interaction) || Interaction_1.default; }, [theme]);
    const PaginationItem = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.PaginationItem) || PaginationItem_1.default; }, [theme]);
    const Divider = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Divider) || Divider_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const ListItem = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.ListItem) || ListItem_1.default; }, [theme]);
    const { tonal = true, color = 'default', version = 'text', iconColor = 'inverted', iconColorActive = 'primary', dividerColor = 'inverted', dividerColorActive = 'primary', step = 0, activeStep, active, completed, primary, secondary, stepDirection = 'row', orientation = 'horizontal', button, divider, renderIcon: renderIcon_, ListItemProps, DividerProps, Component = Surface, className, children } = props, other = __rest(props, ["tonal", "color", "version", "iconColor", "iconColorActive", "dividerColor", "dividerColorActive", "step", "activeStep", "active", "completed", "primary", "secondary", "stepDirection", "orientation", "button", "divider", "renderIcon", "ListItemProps", "DividerProps", "Component", "className", "children"]);
    const { classes } = useStyle();
    const activeDivider = activeStep >= step - 1;
    const renderIcon = (0, utils_1.is)('function', renderIcon_) ? renderIcon_ : (() => {
        return ((0, jsx_runtime_1.jsx)(PaginationItem, Object.assign({ tonal: tonal, color: !(active || completed) ? iconColor : iconColorActive, version: 'filled', className: (0, style_react_1.classNames)([
                (0, utils_2.staticClassName)('Step', theme) && [
                    'amaui-Step-icon'
                ],
                classes.icon
            ]) }, { children: !completed ? step : (0, jsx_runtime_1.jsx)(Buttons_1.IconDoneAnimated, { in: true, add: true }) })));
    });
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ ref: ref, version: version, tonal: tonal, color: color, gap: 0, direction: stepDirection, align: 'center', justify: 'center', Component: Component, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Step', theme) && [
                'amaui-Step-root',
                active && `amaui-Step-active`,
                completed && `amaui-Step-completed`,
                (!active && !completed) && `amaui-Step-inactive`
            ],
            className,
            classes.root,
            classes[`direction_${stepDirection}`],
            (!active && !completed) && classes.inactive,
            button && classes.button
        ]) }, other, { children: [button && ((0, jsx_runtime_1.jsx)(Interaction, { border: false })), renderIcon(step, active, completed, activeStep), (0, jsx_runtime_1.jsx)(ListItem, Object.assign({ Component: 'div', version: version, tonal: tonal, color: color, primary: primary, secondary: secondary }, ListItemProps)), step > 1 && divider && ((0, jsx_runtime_1.jsx)(Divider, Object.assign({ orientation: orientation, color: activeDivider ? dividerColorActive : dividerColor, flex: true }, DividerProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('Step', theme) && [
                        'amaui-Step-divider',
                        activeDivider && `amaui-Step-divider-active`
                    ],
                    DividerProps === null || DividerProps === void 0 ? void 0 : DividerProps.className,
                    classes.divider,
                    classes[`divider_orientation_${orientation}`],
                    activeDivider && classes[`divider_active_orientation_${orientation}`]
                ]) })))] })));
});
Step.displayName = 'amaui-Step';
exports.default = Step;
