import React from 'react';
import { ISurface } from '../Surface/Surface';
import { IElement, IPropsAny } from '../types';
export interface ITab extends Omit<ISurface, 'version'> {
    version?: 'primary' | 'secondary';
    size?: 'small' | 'regular' | 'large';
    value?: number;
    onChange?: (value: number, index: number) => any;
    active?: boolean;
    index?: number;
    name?: IElement;
    label?: IElement;
    icon?: IElement;
    iconPosition?: 'start' | 'top' | 'bottom' | 'end';
    activateOnFocus?: boolean;
    disabled?: boolean;
    onBlur?: (event: React.FocusEvent<any>) => any;
    onFocus?: (event: React.FocusEvent<any>) => any;
    LineProps?: IPropsAny;
}
declare const Tab: React.FC<ITab>;
export default Tab;
