"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Type_1 = __importDefault(require("../Type"));
const Surface_1 = __importDefault(require("../Surface"));
const Line_1 = __importDefault(require("../Line"));
const Interaction_1 = __importDefault(require("../Interaction"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        // Reset
        fontFamily: 'inherit',
        '-webkit-appearance': 'none',
        appearance: 'none',
        background: 'transparent',
        border: 'none',
        fontSize: '100%',
        lineHeight: '1.15',
        margin: '0',
        overflow: 'visible',
        textTransform: 'none',
        position: 'relative',
        flex: '0 0 auto',
        alignSelf: 'stretch',
        userSelect: 'none',
        cursor: 'pointer',
        opacity: theme.palette.visual_contrast.default.opacity.secondary,
        transition: theme.methods.transitions.make('opacity')
    },
    size_small: {
        padding: `${theme.methods.space.value(1.5, 'px')} ${theme.methods.space.value(3, 'px')}`,
        minWidth: '40px',
        maxWidth: '200px'
    },
    size_regular: {
        padding: `${theme.methods.space.value(2, 'px')} ${theme.methods.space.value(4, 'px')}`,
        minWidth: '70px',
        maxWidth: '240px'
    },
    size_large: {
        padding: `${theme.methods.space.value(2.5, 'px')} ${theme.methods.space.value(5, 'px')}`,
        minWidth: '100px',
        maxWidth: '280px'
    },
    type_small: {
        maxHeight: '2rem'
    },
    type_regular: {
        maxHeight: '2.15rem'
    },
    type_large: {
        maxHeight: '2.6rem'
    },
    line: {
        overflow: 'hidden'
    },
    active: {
        opacity: '1'
    },
    disabled: {
        pointerEvents: 'none',
        opacity: theme.palette.visual_contrast.default.opacity.disabled,
        cursor: 'default'
    }
}), { name: 'amaui-Tab' });
const Tab = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiTab) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const Interaction = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Interaction) || Interaction_1.default; }, [theme]);
    const { tonal = true, color = 'primary', version = 'primary', size = 'regular', value, onChange, active, index, name, label: label_, icon, iconPosition = 'start', activateOnFocus, disabled, onBlur: onBlur_, onFocus: onFocus_, LineProps = {}, Component = 'button', className, children } = props, other = __rest(props, ["tonal", "color", "version", "size", "value", "onChange", "active", "index", "name", "label", "icon", "iconPosition", "activateOnFocus", "disabled", "onBlur", "onFocus", "LineProps", "Component", "className", "children"]);
    const { classes } = useStyle();
    const [focus, setFocus] = react_1.default.useState(false);
    const label = name !== undefined ? name : label_;
    const onBlur = react_1.default.useCallback((event) => {
        if (!disabled)
            setFocus(false);
        if ((0, utils_1.is)('function', onBlur_))
            onBlur_(event);
    }, [disabled, onBlur_]);
    const onFocus = react_1.default.useCallback((event) => {
        if (!disabled) {
            setFocus(true);
            if (activateOnFocus)
                onChange(value, index);
        }
        if ((0, utils_1.is)('function', onFocus_))
            onFocus_(event);
    }, [activateOnFocus, value, disabled, onFocus_]);
    if (icon !== undefined) {
        LineProps.direction = iconPosition === 'start' ? 'row' : iconPosition === 'top' ? 'column' : iconPosition === 'end' ? 'row-reverse' : 'column-reverse';
    }
    let typeVersion = 'l2';
    if (size === 'large')
        typeVersion = 'l1';
    else if (size === 'small')
        typeVersion = 'l3';
    return ((0, jsx_runtime_1.jsxs)(Surface, Object.assign({ ref: ref, tabIndex: !disabled ? 0 : -1, tonal: tonal, color: color, onBlur: onBlur, onFocus: onFocus, role: 'tab', "aria-selected": active, "data-amaui-tab-value": value, Component: Component, className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Tab', theme) && [
                'amaui-Tab-root',
                active && `amaui-Tab-active`,
                disabled && `amaui-Tab-disabled`
            ],
            className,
            classes.root,
            classes[`size_${size}`],
            active && classes.active,
            disabled && classes.disabled
        ]) }, other, { children: [(0, jsx_runtime_1.jsx)(Interaction, { pulse: focus }), (0, jsx_runtime_1.jsxs)(Line, Object.assign({ gap: 1, direction: 'row', align: 'center', justify: 'center' }, LineProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('Tab', theme) && [
                        'amaui-Tab-line'
                    ],
                    LineProps === null || LineProps === void 0 ? void 0 : LineProps.className,
                    classes.line
                ]) }, { children: [icon, label !== undefined && ((0, utils_1.is)('simple', label) ? ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: typeVersion, className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('Tab', theme) && [
                                'amaui-Tab-type'
                            ],
                            classes[`type_${size}`]
                        ]) }, { children: label }))) : label), children !== undefined && ((0, utils_1.is)('simple', children) ? ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: typeVersion, className: (0, style_react_1.classNames)([
                            (0, utils_2.staticClassName)('Tab', theme) && [
                                'amaui-Tab-type'
                            ],
                            classes[`type_${size}`]
                        ]) }, { children: children }))) : children)] }))] })));
});
Tab.displayName = 'amaui-Tab';
exports.default = Tab;
