"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const style_react_1 = require("@amaui/style-react");
const Surface_1 = __importDefault(require("../Surface"));
const Line_1 = __importDefault(require("../Line"));
const utils_1 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: Object.assign({ borderRadius: `${theme.shape.radius.unit * 2}px`, overflow: 'hidden' }, theme.typography.values.b2),
    table: {
        display: 'table',
        width: '100%',
        borderCollapse: 'collapse',
        borderSpacing: '0px',
        background: 'inherit'
    },
    wrapper: {
        overflowX: 'auto',
        background: 'inherit'
    }
}), { name: 'amaui-Table' });
const Table = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiTable) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const { tonal = true, color = 'themed', size = 'regular', elevation = 1, header, footer, WrapperComponentProps, TableComponent = 'table', WrapperComponent = 'div', Component = 'div', className, children } = props, other = __rest(props, ["tonal", "color", "size", "elevation", "header", "footer", "WrapperComponentProps", "TableComponent", "WrapperComponent", "Component", "className", "children"]);
    const { classes } = useStyle();
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ ref: ref, gap: 0, direction: 'column', align: 'unset', justify: 'unset', fullWidth: true, tonal: tonal, color: color, elevation: elevation, Component: Surface, AdditionalProps: {
            Component
        }, className: (0, style_react_1.classNames)([
            (0, utils_1.staticClassName)('Table', theme) && [
                `amaui-Table-root`
            ],
            className,
            classes.root
        ]) }, other, { children: [header && react_1.default.cloneElement(header, {
                tonal: header.props.tonal !== undefined ? header.props.tonal : tonal,
                color: header.props.color !== undefined ? header.props.color : color,
                size: header.props.size !== undefined ? header.props.size : size
            }), (0, jsx_runtime_1.jsx)(WrapperComponent, Object.assign({}, WrapperComponentProps, { className: (0, style_react_1.classNames)([
                    (0, utils_1.staticClassName)('Table', theme) && [
                        `amaui-Table-wrapper`
                    ],
                    WrapperComponentProps === null || WrapperComponentProps === void 0 ? void 0 : WrapperComponentProps.className,
                    classes.wrapper
                ]) }, { children: (0, jsx_runtime_1.jsx)(TableComponent, Object.assign({ className: (0, style_react_1.classNames)([
                        (0, utils_1.staticClassName)('Table', theme) && [
                            `amaui-Table-table`,
                            header && `amaui-Table-header`,
                            footer && `amaui-Table-footer`
                        ],
                        classes.table
                    ]) }, { children: react_1.default.Children.toArray(children).map((item) => (react_1.default.cloneElement(item, {
                        tonal: item.props.tonal !== undefined ? item.props.tonal : tonal,
                        color: item.props.color !== undefined ? item.props.color : color,
                        size: item.props.size !== undefined ? item.props.size : size
                    }))) })) })), footer && react_1.default.cloneElement(footer, {
                tonal: footer.props.tonal !== undefined ? footer.props.tonal : tonal,
                color: footer.props.color !== undefined ? footer.props.color : color,
                size: footer.props.size !== undefined ? footer.props.size : size
            })] })));
});
Table.displayName = 'amaui-Table';
exports.default = Table;
