"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const style_react_1 = require("@amaui/style-react");
const Surface_1 = __importDefault(require("../Surface"));
const utils_1 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {
        display: 'table-row',
        position: 'relative'
    },
    hover: {
        '&:hover': {
            '& .amaui-TableCell-root::before': {
                opacity: theme.palette.visual_contrast.default.opacity.hover
            }
        }
    },
    selected: {
        '& .amaui-TableCell-root::before': {
            opacity: [theme.palette.visual_contrast.default.opacity.selected, '!important']
        }
    }
}), { name: 'amaui-TableRow' });
const TableRow = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiTableRow) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Surface = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Surface) || Surface_1.default; }, [theme]);
    const { tonal = true, color = 'themed', size = 'regular', hover = true, selected, position = 'body', Component = 'tr', className, children } = props, other = __rest(props, ["tonal", "color", "size", "hover", "selected", "position", "Component", "className", "children"]);
    const { classes } = useStyle();
    return ((0, jsx_runtime_1.jsx)(Surface, Object.assign({ ref: ref, tonal: tonal, color: color, role: 'row', Component: Component, className: (0, style_react_1.classNames)([
            (0, utils_1.staticClassName)('TableRow', theme) && [
                `amaui-TableRow-root`,
                (hover && position === 'body') && `amaui-TableRow-hover`,
                selected && `amaui-TableRow-selected`
            ],
            className,
            classes.root,
            (hover && position === 'body') && classes.hover,
            selected && classes.selected
        ]) }, other, { children: react_1.default.Children.toArray(children).map((item, index) => (react_1.default.cloneElement(item, {
            tonal: item.props.tonal !== undefined ? item.props.tonal : tonal,
            color: item.props.color !== undefined ? item.props.color : color,
            size: item.props.size !== undefined ? item.props.size : size,
            justify: item.props.justify !== undefined ? item.props.justify : index === 0 ? 'flex-start' : 'flex-end',
            position: props.position !== undefined ? props.position : (index === 0 && position === 'body') ? 'head' : position,
            noWeight: (index === 0 && position === 'body')
        }))) })));
});
TableRow.displayName = 'amaui-TableRow';
exports.default = TableRow;
