import React from 'react';
import { ISurface } from '../Surface/Surface';
import { TLineAlign, TLineJustify } from '../Line/Line';
import { IElementReference, IPropsAny } from '../types';
export interface ITabs extends Omit<ISurface, 'version'> {
    version?: 'primary' | 'secondary';
    value?: any;
    valueDefault?: any;
    onChange?: (value: any) => any;
    isActive?: (value: any, tabValue: any) => boolean;
    activateOnFocus?: boolean;
    align?: TLineAlign;
    justify?: TLineJustify;
    orientation?: 'vertical' | 'horizontal';
    size?: 'small' | 'regular' | 'large';
    initialLineUpdateTimeout?: number;
    arrows?: boolean;
    arrowsMobile?: boolean;
    fixed?: boolean;
    noDivider?: boolean;
    IconStart?: IElementReference;
    IconEnd?: IElementReference;
    IconTop?: IElementReference;
    IconBottom?: IElementReference;
    SurfaceProps?: IPropsAny;
}
declare const Tabs: React.FC<ITabs>;
export default Tabs;
