"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_react_1 = require("@amaui/style-react");
const Type_1 = __importDefault(require("../Type"));
const Line_1 = __importDefault(require("../Line"));
const useMediaQuery_1 = __importDefault(require("../useMediaQuery"));
const utils_2 = require("../utils");
const useStyle = (0, style_react_1.style)(theme => ({
    root: {},
    type: {
        columnGap: '40px'
    },
    divider: {
        columnRule: `1px solid ${theme.palette.text.divider}`
    },
    column_1: {
        columnCount: '1'
    },
    column_2: {
        columnCount: '2'
    },
    column_3: {
        columnCount: '3'
    },
    column_4: {
        columnCount: '4'
    }
}), { name: 'amaui-Text' });
const Text = react_1.default.forwardRef((props_, ref) => {
    const theme = (0, style_react_1.useAmauiTheme)();
    const props = react_1.default.useMemo(() => { var _a, _b, _c, _d, _e, _f, _g, _h; return (Object.assign(Object.assign(Object.assign({}, (_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b.all) === null || _c === void 0 ? void 0 : _c.props) === null || _d === void 0 ? void 0 : _d.default), (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f.amauiText) === null || _g === void 0 ? void 0 : _g.props) === null || _h === void 0 ? void 0 : _h.default), props_)); }, [props_]);
    const Line = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Line) || Line_1.default; }, [theme]);
    const Type = react_1.default.useMemo(() => { var _a; return ((_a = theme === null || theme === void 0 ? void 0 : theme.elements) === null || _a === void 0 ? void 0 : _a.Type) || Type_1.default; }, [theme]);
    const { value: value_, columns: columns_, responsive = true, divider, top, bottom, start, end, TypeProps, HorizontalProps, className, children } = props, other = __rest(props, ["value", "columns", "responsive", "divider", "top", "bottom", "start", "end", "TypeProps", "HorizontalProps", "className", "children"]);
    const { classes } = useStyle();
    const refs = {
        root: react_1.default.useRef()
    };
    const breakpoints = {};
    theme.breakpoints.keys.forEach(key => {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        if (theme.breakpoints.media[key])
            breakpoints[key] = (0, useMediaQuery_1.default)(theme.breakpoints.media[key], { element: refs.root.current });
    });
    let columns = (0, utils_2.valueBreakpoints)(columns_, 1, breakpoints, theme);
    if (responsive) {
        // 0 - 479px
        if (breakpoints.min || breakpoints.xxs || breakpoints.xs)
            columns = Math.min(columns, 1);
        // 480px - 1023px
        if (breakpoints.sm || breakpoints.md)
            columns = Math.min(columns, 2);
        // 1024px - 1439px
        if (breakpoints.lg)
            columns = Math.min(columns, 3);
    }
    let value = value_ !== undefined ? value_ : children;
    value = (0, utils_1.is)('string', value) ? (0, utils_1.textToInnerHTML)(value) : '';
    const main = ((0, jsx_runtime_1.jsx)(Type, Object.assign({ version: 'b2' }, TypeProps, { className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Text', theme) && [
                'amaui-Text-type'
            ],
            TypeProps === null || TypeProps === void 0 ? void 0 : TypeProps.className,
            classes.type,
            divider && classes.divider,
            classes[`column_${columns}`]
        ]), dangerouslySetInnerHTML: {
            __html: value
        } })));
    return ((0, jsx_runtime_1.jsxs)(Line, Object.assign({ ref: (item) => {
            if (ref) {
                if ((0, utils_1.is)('function', ref))
                    ref(item);
                else
                    ref.current = item;
            }
            refs.root.current = item;
        }, direction: 'column', justify: 'unset', align: 'unset', className: (0, style_react_1.classNames)([
            (0, utils_2.staticClassName)('Text', theme) && [
                'amaui-Text-root'
            ],
            className,
            classes.root
        ]), fullWidth: true }, other, { children: [top, (0, jsx_runtime_1.jsx)(Line, Object.assign({ direction: 'row', fullWidth: true }, HorizontalProps, { className: (0, style_react_1.classNames)([
                    (0, utils_2.staticClassName)('Text', theme) && [
                        'amaui-Text-main'
                    ],
                    HorizontalProps === null || HorizontalProps === void 0 ? void 0 : HorizontalProps.className,
                    classes.main
                ]) }, { children: main })), bottom] })));
});
Text.displayName = 'amaui-Text';
exports.default = Text;
