import React from 'react';
import AmauiSubscription from '@amaui/subscription';
import { IBaseElement, ITonal, IColor, IVersion, ISize, IRef, IElement, IValueBreakpoints, IPropsAny, IElementReference } from '../types';
export interface ITextField extends IBaseElement {
    tonal?: ITonal;
    color?: IColor;
    version?: IVersion;
    size?: ISize;
    rootRef?: IRef;
    valueDefault?: string | number;
    value?: string | number;
    onChange?: (value: any, event?: React.ChangeEvent<HTMLInputElement>) => any;
    name?: any;
    label?: any;
    align?: 'start' | 'end';
    start?: IElement;
    startVerticalAlign?: 'start' | 'center' | 'end';
    end?: IElement;
    endVerticalAlign?: 'start' | 'center' | 'end';
    placeholder?: string;
    fullWidth?: boolean | Partial<Record<IValueBreakpoints, boolean>>;
    helperText?: string;
    counter?: number;
    prefix?: string;
    sufix?: string;
    noPrefixMargin?: boolean;
    noSufixMargin?: boolean;
    enabled?: boolean;
    autoFocus?: boolean;
    autoComplete?: boolean;
    type?: React.HTMLInputTypeAttribute;
    required?: boolean;
    optional?: boolean;
    optionalText?: string;
    error?: boolean;
    multiline?: boolean;
    clear?: boolean;
    rows?: number;
    minRows?: number;
    maxRows?: number;
    focus?: boolean;
    footer?: IElement;
    controlled?: boolean;
    restoreSelection?: boolean;
    readOnly?: boolean;
    disabled?: boolean;
    subscription?: AmauiSubscription;
    onInput?: (event: InputEvent) => any;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    inputProps?: IPropsAny;
    InputWrapperProps?: IPropsAny;
    HelperTextProps?: IPropsAny;
    IconClear?: IElementReference;
    InputComponent?: IElementReference;
    WrapperComponent?: IElementReference;
}
declare const TextField: React.FC<ITextField>;
export default TextField;
