import React from 'react';
import { IModal } from '../Modal/Modal';
import { IColor, IElement, IElementReference, IHTMLElement, IMethodTransition, IPropsAny, ITonal } from '../types';
export interface ITooltip extends Omit<IModal, 'maxWidth'> {
    tonal?: ITonal;
    color?: IColor;
    open?: boolean;
    openDefault?: boolean;
    name?: IElement;
    label?: IElement;
    parent?: IHTMLElement;
    position?: 'top' | 'left' | 'bottom' | 'right';
    switch?: boolean;
    alignment?: 'start' | 'center' | 'end';
    portal?: boolean;
    fullWidth?: boolean;
    maxWidth?: 'xxs' | 'xs' | 'sm' | 'rg' | 'lg' | 'xl' | 'xxl' | 'unset';
    arrow?: boolean;
    anchor?: DOMRect;
    anchorElement?: IHTMLElement;
    noMargin?: boolean;
    classNameSwitch?: string;
    transformOrigin?: string;
    transformOriginSwitch?: string;
    transformOriginRtl?: string;
    transformOriginRtlSwitch?: string;
    click?: boolean;
    touch?: boolean;
    longPress?: boolean;
    hover?: boolean;
    focus?: boolean;
    inset?: boolean;
    nowrap?: boolean;
    follow?: boolean;
    interactive?: boolean;
    onOpen?: () => any;
    onClose?: () => any;
    onExited?: IMethodTransition;
    TransitionComponent?: IElementReference;
    TransitionComponentProps?: IPropsAny;
    AppendProps?: IPropsAny;
    ModalProps?: IPropsAny;
    LabelProps?: IPropsAny;
}
declare const Tooltip: React.FC<ITooltip>;
export default Tooltip;
