import React from 'react';
import { IBaseElement, IElement, IPropsAny, IElementReference } from '../types';
export interface ITree extends Omit<IBaseElement, 'children'> {
    open?: boolean;
    openDefault?: boolean;
    onChange?: (value: boolean) => any;
    selected?: boolean;
    line?: boolean;
    indicator?: boolean;
    arrow?: boolean;
    checkbox?: boolean;
    indicatorPosition?: 'start' | 'end';
    level?: number;
    icon?: IElement;
    iconOpen?: IElement;
    start?: IElement;
    middle?: IElement;
    end?: IElement;
    button?: boolean;
    noTransition?: boolean;
    noExpand?: boolean;
    noPadding?: boolean;
    parent?: HTMLElement;
    parentDisabled?: boolean;
    disabled?: boolean;
    ExpandProps?: IPropsAny;
    MainProps?: IPropsAny;
    StartProps?: IPropsAny;
    MiddleProps?: IPropsAny;
    EndProps?: IPropsAny;
    IndicatorProps?: IPropsAny;
    TransitionComponentProps?: IPropsAny;
    IconArrow?: IElementReference;
    TransitionComponent?: IElementReference;
    children?: any;
}
declare const Tree: React.FC<ITree>;
export default Tree;
