import React from 'react';
import { AmauiDate } from '@amaui/date';
import { ISurface } from '../Surface/Surface';
import { ISize, IElement, IPropsAny } from '../types';
export interface IWatch extends Omit<ISurface, 'version'> {
    version?: 'regular' | 'analog' | 'modern' | 'minimal';
    size?: ISize;
    start?: boolean;
    timeVisible?: boolean;
    timeOfDayVisible?: boolean;
    dateVisible?: boolean;
    timeFormatString?: string;
    dateFormatString?: string;
    renderTime?: (value: AmauiDate) => IElement;
    renderDate?: (value: AmauiDate) => IElement;
    shadow?: boolean;
    AnalogProps?: IPropsAny;
    RegularProps?: IPropsAny;
    MinimalProps?: IPropsAny;
    ModernProps?: IPropsAny;
}
declare const Watch: React.FC<IWatch>;
export default Watch;
