import React from 'react';
import { IBaseElement, IElement, IPropsAny, IElementReference } from '../types';
export interface IWidgetsValue {
    open: (value?: string) => void;
    openAll: () => void;
    close: (value?: string) => void;
    closeAll: () => void;
}
export interface IWidgets extends IBaseElement {
    widgets?: IElement;
    position?: 'top' | 'bottom';
    move?: boolean;
    fixed?: boolean;
    onOpen?: (value: string) => any;
    onOpenAll?: () => any;
    onClose?: (value: string) => any;
    onCloseAll?: () => any;
    SpeedDialProps?: IPropsAny;
    MoveProps?: IPropsAny;
    Icon?: IElementReference;
    IconCloseItem?: IElementReference;
}
declare const Widgets: React.FC<IWidgets>;
export default Widgets;
