import React from 'react';
import { ILine } from '../Line/Line';
import { ITonal, IColor, IElement, IPropsAny } from '../types';
export interface IWindowSplit extends ILine {
    tonal?: ITonal;
    color?: IColor;
    valueDefault?: number;
    value?: number;
    onChange?: (value: number) => any;
    padding?: number;
    paddingStart?: number;
    paddingEnd?: number;
    iconButton?: IElement;
    orientation?: 'vertical' | 'horizontal';
    noKeyboard?: boolean;
    noDivider?: boolean;
    focus?: boolean;
    onFocus?: (event: React.FocusEvent<any>) => any;
    onBlur?: (event: React.FocusEvent<any>) => any;
    onMouseEnter?: (event: React.MouseEvent<any>) => any;
    onMouseLeave?: (event: React.MouseEvent<any>) => any;
    iconButtonComponent?: IElement;
    iconOrientationHorizontal?: IElement;
    iconOrientationVertical?: IElement;
    IconButtonProps?: IPropsAny;
    DividerProps?: IPropsAny;
}
declare const WindowSplit: React.FC<IWindowSplit>;
export default WindowSplit;
