import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["className"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import NavigationDrawerElement from '../NavigationDrawer';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    '&.amaui-Modal-root .amaui-Modal-surface': {
      paddingTop: theme.methods.space.value(6.25, 'px'),
      maxWidth: '640px',
      '&:before': {
        content: "''",
        position: 'absolute',
        background: 'currentColor',
        height: '4px',
        width: '32px',
        top: '23px',
        left: '50%',
        transform: 'translateX(-50%)',
        borderRadius: theme.methods.shape.radius.value(0.5, 'px'),
        opacity: '0.4'
      }
    },
    '@media only screen and (min-width: 640px)': {
      '&.amaui-Modal-root .amaui-Modal-surface': {
        marginTop: '72px',
        marginInline: '56px'
      }
    }
  }
}), {
  name: 'amaui-BottomSheet'
});
const BottomSheet = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiBottomSheet?.props?.default), props_), [props_]);
  const NavigationDrawer = React.useMemo(() => theme?.elements?.NavigationDrawer || NavigationDrawerElement, [theme]);
  const {
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(NavigationDrawer, _extends({
    ref: ref,
    direction: "bottom",
    className: classNames([staticClassName('BottomSheet', theme) && ['amaui-BottomSheet-root'], className, classes.root])
  }, other));
});
BottomSheet.displayName = 'amaui-BottomSheet';
export default BottomSheet;