import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["valueDefault", "value", "onChange", "className"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import TextFieldElement from '../TextField';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    margin: '0',
    padding: '0',
    border: '0',
    outline: 'none',
    fontSize: '100%',
    background: 'transparent',
    boxSizing: 'border-box',
    touchAction: 'manipulation'
  },
  inputColor: {
    // Reset
    margin: '0',
    padding: '0',
    border: '0',
    fontFamily: 'inherit',
    fontSize: '100%',
    lineHeight: '1.15',
    borderRadius: theme.methods.shape.radius.value(40, 'px'),
    overflow: 'hidden',
    width: '17px',
    height: '17px',
    cursor: 'pointer',
    boxShadow: theme.methods.shadow(theme.palette.text.default.primary, theme.palette.light ? [7, 4, 11] : [27, 24, 31])[1],
    '&::-webkit-color-swatch-wrapper': {
      padding: '0'
    },
    '&::-webkit-color-swatch': {
      border: 'none'
    }
  }
}), {
  name: 'amaui-ColorTextField'
});
const ColorTextField = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiColorTextField?.props?.default), props_), [props_]);
  const TextField = React.useMemo(() => theme?.elements?.TextField || TextFieldElement, [theme]);
  const {
      valueDefault,
      value: value_,
      onChange: onChange_,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [init, setInit] = React.useState(false);
  const [value, setValue] = React.useState((valueDefault !== undefined ? valueDefault : value_) || '');
  const refs = {
    value: React.useRef()
  };
  refs.value.current = value;
  React.useEffect(() => {
    setInit(true);
  }, []);
  React.useEffect(() => {
    if (init) if (value_ !== refs.value.current) setValue(value_);
  }, [value_]);
  const onChange = valueNew => {
    // Update inner or controlled
    if (!props.hasOwnProperty('value')) setValue(valueNew);
    if (is('function', onChange_)) onChange_(valueNew);
  };
  return /*#__PURE__*/React.createElement(TextField, _extends({
    value: value,
    onChange: onChange,
    endVerticalAlign: "center",
    end: /*#__PURE__*/React.createElement("input", {
      type: "color",
      value: value,
      onChange: event => onChange(event.target.value),
      className: classNames([staticClassName('ColorTextField', theme) && ['amaui-ColorTextField-input-color'], classes.inputColor])
    }),
    className: classNames([staticClassName('ColorTextField', theme) && ['amaui-ColorTextField-root'], classes.root])
  }, other));
});
ColorTextField.displayName = 'amaui-ColorTextField';
export default ColorTextField;