import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["name", "description", "start", "end", "row", "footer", "Component", "HeaderProps", "MainProps", "TextProps", "AsideProps", "StartProps", "EndProps", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is } from '@amaui/utils';
import { style as styleMethod, classNames, useAmauiTheme } from '@amaui/style-react';
import LineElement from '../Line';
import TypeElement from '../Type';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {},
  aside: {
    flex: '0 0 auto'
  },
  row: {
    '& > *': {
      flex: '1 1 auto'
    },
    '& .amaui-TextField-root, & .amaui-TextField-wrapper': {
      width: '100%'
    }
  },
  footer: {
    marginTop: '8px'
  }
}), {
  name: 'amaui-FormRow'
});
const FormRow = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiFormRow?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      name,
      description,
      start,
      end,
      row,
      footer,
      Component = Line,
      HeaderProps,
      MainProps,
      TextProps,
      AsideProps,
      StartProps,
      EndProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const text = name || description;
  const actions = start || end;
  const header = text || actions;
  let justify = 'unset';
  if (start && end && !text) justify = 'space-between';
  if (!start && !text && end) justify = 'flex-end';
  return /*#__PURE__*/React.createElement(Component, _extends({
    ref: ref,
    gap: 1,
    direction: "column",
    justify: "unset",
    align: "unset",
    fullWidth: true,
    className: classNames([staticClassName('FormRow', theme) && ['amaui-FormRow-root'], className, classes.root])
  }, other), header && /*#__PURE__*/React.createElement(Line, _extends({
    direction: "row",
    align: "center",
    justify: justify,
    fullWidth: true
  }, HeaderProps), start && /*#__PURE__*/React.createElement(Line, _extends({}, AsideProps, StartProps, {
    className: classNames([AsideProps?.className, StartProps?.className, classes.aside])
  }), start), text && /*#__PURE__*/React.createElement(Line, _extends({
    gap: 0.5,
    direction: "column",
    flex: true
  }, TextProps), name && (is('string', name) ? /*#__PURE__*/React.createElement(Type, {
    version: "l2"
  }, name) : name), description && (is('string', description) ? /*#__PURE__*/React.createElement(Type, {
    version: "b3"
  }, description) : description)), end && /*#__PURE__*/React.createElement(Line, _extends({
    gap: 0,
    direction: "row",
    align: "center"
  }, AsideProps, EndProps, {
    className: classNames([AsideProps?.className, EndProps?.className, classes.aside])
  }), end)), /*#__PURE__*/React.createElement(Line, _extends({
    gap: 2,
    direction: row ? 'row' : 'column',
    fullWidth: true,
    className: classNames([staticClassName('FormRow', theme) && ['amaui-FormRow-main'], MainProps?.className, row && classes.row])
  }, MainProps), children), footer && /*#__PURE__*/React.createElement(Line, {
    direction: "row",
    justify: "flex-end",
    fullWidth: true,
    className: classes.footer
  }, footer));
});
FormRow.displayName = 'amaui-FormRow';
export default FormRow;