import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["id", "WrapperProps", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import ReactDOM from 'react-dom';
import { is, isEnvironment } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import LineElement from '../Line';
import { importIframeStyles, staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    width: '100%',
    height: '100%'
  },
  hidden: {
    height: 0,
    width: 0,
    opacity: 0,
    visibility: 'hidden'
  }
}), {
  name: 'amaui-IFrame'
});
const IFrame = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiIFrame?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const {
      id,
      WrapperProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [init, setInit] = React.useState(false);
  const [show, setShow] = React.useState(false);
  const refs = {
    root: React.useRef()
  };
  const iframeDocument = refs.root.current?.contentWindow?.document;
  const iframeBody = refs.root.current?.contentWindow?.document.body;
  const refresh = React.useCallback(() => {
    if (iframeDocument) {
      const rootDocument = isEnvironment('browser') ? refs.root.current?.ownerDocument || window.document : undefined;

      // Add iframe ref to iframe document
      iframeDocument.iframe = refs.root.current;
      iframeDocument.iframeWindow = refs.root.current?.contentWindow;

      // Head
      iframeDocument.head?.replaceWith(rootDocument.createElement('head'));
      importIframeStyles(iframeDocument);

      // Default
      const styleDefault = rootDocument.createElement('style');
      styleDefault.innerHTML = `
        body {
          background-color: transparent;
          padding: 0px;
        }

        body::-webkit-scrollbar {
          height: 0px;
          width: 0px;
        }
      `;
      iframeDocument.head?.append(styleDefault);

      // Body
      if (iframeBody) iframeBody.dir = rootDocument.body.dir;
    }
  }, [iframeDocument]);
  React.useEffect(() => {
    if (init && !show) setTimeout(() => {
      refresh();
      setShow(true);
    }, 740);
  }, [init]);
  React.useEffect(() => {
    refresh();
    if (!init) setInit(true);
  }, [id, refs.root.current, children, theme]);
  return /*#__PURE__*/React.createElement(Line, _extends({
    gap: 0,
    flex: true,
    fullWidth: true
  }, WrapperProps), /*#__PURE__*/React.createElement(Line, {
    className: classes.hidden
  }, children), /*#__PURE__*/React.createElement("iframe", _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    title: id,
    className: classNames([staticClassName('IFrame', theme) && ['amaui-IFrame-root'], className, classes.root])
  }, other), init && iframeBody && /*#__PURE__*/ReactDOM.createPortal( /*#__PURE__*/React.cloneElement(children, {
    iframeRef: refs.root.current,
    style: _objectSpread(_objectSpread({}, children?.props.style), {}, {
      transition: theme.methods.transitions.make('opacity')
    }, show ? {
      opacity: 1
    } : {
      opacity: 0
    })
  }), iframeBody)));
});
IFrame.displayName = 'amaui-IFrame';
export default IFrame;