import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["rows", "columns", "version", "Component", "className", "style", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import LineElement from '../Line';
import useMediaQuery from '../useMediaQuery';
import { valueBreakpoints, staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    position: 'relative',
    '& img': {
      display: 'block',
      width: '100%',
      height: 'auto',
      objectFit: 'cover',
      flex: '1 1 auto'
    }
  },
  version_masonry: {
    display: 'block',
    height: 'auto'
  }
}), {
  name: 'amaui-ImageListItem'
});
const ImageListItem = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiImageListItem?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const {
      rows: rows_,
      columns: columns_,
      version = 'standard',
      Component = 'li',
      className,
      style,
      children: children_
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const refs = {
    root: React.useRef()
  };
  const breakpoints = {};
  theme.breakpoints.keys.forEach(key => {
    if (theme.breakpoints.media[key]) breakpoints[key] = useMediaQuery(theme.breakpoints.media[key], {
      element: refs.root.current
    });
  });
  const rows = valueBreakpoints(rows_, 1, breakpoints, theme);
  const columns = valueBreakpoints(columns_, 1, breakpoints, theme);
  const styles = {
    root: {}
  };
  if (version !== 'masonry') {
    styles.root.gridRowEnd = `span ${rows}`;
    styles.root.gridColumnEnd = `span ${columns}`;
  }
  const children = React.Children.toArray(children_);
  if (children.length > 1) other.justify = 'flex-end';
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    gap: 0,
    direction: "column",
    align: "center",
    justify: "center",
    Component: Component,
    className: classNames([staticClassName('ImageListItem', theme) && ['amaui-ImageListItem-root'], className, classes.root, classes[`version_${version}`]]),
    style: _objectSpread(_objectSpread({}, styles.root), style)
  }, other), children);
});
ImageListItem.displayName = 'amaui-ImageListItem';
export default ImageListItem;