import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["position", "backgroundOpacity", "Component", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import ListItemElement from '../ListItem';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {},
  position_top: {
    position: 'absolute',
    top: '0',
    insetInline: '0',
    borderRadius: `0 0 ${theme.shape.radius.unit * 3}px ${theme.shape.radius.unit * 3}px`
  },
  position_bottom: {
    position: 'absolute',
    bottom: '0',
    insetInline: '0',
    borderRadius: `${theme.shape.radius.unit * 3}px ${theme.shape.radius.unit * 3}px 0 0`
  }
}), {
  name: 'amaui-ImageListItemBox'
});
const ImageListItemBox = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiImageListItemBox?.props?.default), props_), [props_]);
  const ListItem = React.useMemo(() => theme?.elements?.ListItem || ListItemElement, [theme]);
  const {
      position,
      backgroundOpacity = 0.74,
      Component = 'div',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(ListItem, _extends({
    ref: ref,
    backgroundOpacity: backgroundOpacity,
    Component: Component,
    className: classNames([staticClassName('ImageListItemBox', theme) && ['amaui-ImageListItemBox-root'], className, classes.root, position && classes[`position_${position}`]])
  }, other), children);
});
ImageListItemBox.displayName = 'amaui-ImageListItemBox';
export default ImageListItemBox;