import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["values", "separator", "ItemProps", "SeparatorProps", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import TypeElement from '../Type';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    overflow: 'auto hidden',
    '& > *': {
      flex: '0 0 auto'
    }
  }
}), {
  name: 'amaui-Meta'
});
const Meta = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiMeta?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      values: values_ = [],
      separator: separator_ = '•',
      ItemProps,
      SeparatorProps,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const separator = is('string', separator_) ? /*#__PURE__*/React.createElement(Type, _extends({
    version: "b3",
    priority: "secondary"
  }, SeparatorProps), separator_) : separator_;
  const getItem = (item, index) => {
    if (is('simple', item)) return /*#__PURE__*/React.createElement(Type, {
      key: index,
      version: "b3",
      priority: "secondary"
    }, item);
    return /*#__PURE__*/React.cloneElement(item, {
      key: index
    });
  };
  const values = values_?.filter(Boolean)?.flatMap((item, index) => !index ? getItem(item, index) : [separator, getItem(item, index)]);
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: 1,
    direction: "row",
    align: "center",
    justify: "flex-start",
    className: classNames([staticClassName('Meta', theme) && ['amaui-Meta-root'], className, classes.root])
  }, other), values);
});
Meta.displayName = 'amaui-Meta';
export default Meta;