import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
const _excluded = ["menuItems", "Icon", "IconButtonProps", "className"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import IconElement from '../Icon';
import IconButtonElement from '../IconButton';
import MenuElement from '../Menu/Menu';
import { staticClassName } from '../utils';
const IconMaterialMoreVert = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "MoreVert",
    short_name: "MoreVert",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M12 20q-.825 0-1.412-.587Q10 18.825 10 18q0-.825.588-1.413Q11.175 16 12 16t1.413.587Q14 17.175 14 18q0 .825-.587 1.413Q12.825 20 12 20Zm0-6q-.825 0-1.412-.588Q10 12.825 10 12t.588-1.413Q11.175 10 12 10t1.413.587Q14 11.175 14 12q0 .825-.587 1.412Q12.825 14 12 14Zm0-6q-.825 0-1.412-.588Q10 6.825 10 6t.588-1.412Q11.175 4 12 4t1.413.588Q14 5.175 14 6t-.587 1.412Q12.825 8 12 8Z"
  }));
});
const useStyle = styleMethod(theme => ({
  root: {},
  iconButton: {
    flex: '0 0 auto'
  }
}), {
  name: 'amaui-MoreOptions'
});
const MoreOptions = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiMoreOptions?.props?.default), props_), [props_]);
  const Menu = React.useMemo(() => theme?.elements?.Menu || MenuElement, [theme]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const {
      menuItems,
      Icon: Icon_ = IconMaterialMoreVert,
      IconButtonProps,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const onClick = React.useCallback(event => {
    //  event.stopPropagation();
  }, []);
  return /*#__PURE__*/React.createElement(Menu, _extends({
    alignment: "center",
    onClick: onClick,
    menuItems: menuItems
  }, other, {
    ListProps: _objectSpread({
      color: 'themed',
      size: 'small'
    }, other?.ListProps),
    className: classNames([staticClassName('MoreOptions', theme) && ['amaui-MoreOptions-root'], className, classes.root])
  }), /*#__PURE__*/React.createElement(IconButton, _extends({
    color: "inherit",
    size: "small",
    disabled: !menuItems?.length,
    onClick: onClick
  }, IconButtonProps, {
    className: classNames([staticClassName('MoreOptions', theme) && ['amaui-MoreOptions-icon-button'], IconButtonProps?.className, classes.iconButton])
  }), /*#__PURE__*/React.createElement(Icon_, null)));
});
MoreOptions.displayName = 'amaui-MoreOptions';
export default MoreOptions;