import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
const _excluded = ["back", "forward", "noHeader", "name", "IconBack", "IconForward", "Component", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { useNavigate } from 'react-router-dom';
import { is, isEnvironment } from '@amaui/utils';
import { style as styleMethod, classNames, useAmauiTheme } from '@amaui/style-react';
import IconElement from '../Icon';
import IconButtonElement from '../IconButton';
import LineElement from '../Line';
import TooltipElement from '../Tooltip';
import TypeElement from '../Type';
import { staticClassName } from '../utils';
const IconMaterialArrowBackRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "ArrowBackRounded",
    short_name: "ArrowBack"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M10.875 19.3 4.275 12.7Q4.125 12.55 4.062 12.375Q4 12.2 4 12Q4 11.8 4.062 11.625Q4.125 11.45 4.275 11.3L10.875 4.7Q11.15 4.425 11.562 4.412Q11.975 4.4 12.275 4.7Q12.575 4.975 12.588 5.387Q12.6 5.8 12.3 6.1L7.4 11H18.575Q19 11 19.288 11.287Q19.575 11.575 19.575 12Q19.575 12.425 19.288 12.712Q19 13 18.575 13H7.4L12.3 17.9Q12.575 18.175 12.588 18.6Q12.6 19.025 12.3 19.3Q12.025 19.6 11.6 19.6Q11.175 19.6 10.875 19.3Z"
  }));
});
const IconMaterialArrowForwardRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "ArrowForwardRounded",
    short_name: "ArrowForward"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M11.3 19.3Q11.025 19.025 11.012 18.6Q11 18.175 11.275 17.9L16.175 13H5Q4.575 13 4.287 12.712Q4 12.425 4 12Q4 11.575 4.287 11.287Q4.575 11 5 11H16.175L11.275 6.1Q11 5.825 11.012 5.4Q11.025 4.975 11.3 4.7Q11.575 4.425 12 4.425Q12.425 4.425 12.7 4.7L19.3 11.3Q19.45 11.425 19.513 11.612Q19.575 11.8 19.575 12Q19.575 12.2 19.513 12.375Q19.45 12.55 19.3 12.7L12.7 19.3Q12.425 19.575 12 19.575Q11.575 19.575 11.3 19.3Z"
  }));
});
const useStyle = styleMethod(theme => ({
  root: {
    position: 'relative',
    height: '100%',
    maxWidth: '1024px',
    padding: theme.methods.space.value(3, 'px'),
    '& .amaui-overflow-y': {
      height: '0px',
      flex: '1 1 auto',
      overflowX: 'hidden',
      overflowY: 'auto'
    }
  },
  name: {
    maxWidth: '440px'
  }
}), {
  name: 'amaui-Page'
});
const Page = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiPage?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const Tooltip = React.useMemo(() => theme?.elements?.Tooltip || TooltipElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      back,
      forward,
      noHeader,
      name,
      IconBack = IconMaterialArrowBackRounded,
      IconForward = IconMaterialArrowForwardRounded,
      Component = Line,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const navigate = isEnvironment('browser') && useNavigate();
  const IconButtonProps = {
    color: 'inherit'
  };
  const navigation = (back || forward) && /*#__PURE__*/React.createElement(Line, {
    direction: "row",
    align: "center",
    justify: "space-between",
    fullWidth: true
  }, back ? /*#__PURE__*/React.createElement(Tooltip, {
    name: (back?.name !== undefined ? back.name : back?.label) || 'Back'
  }, /*#__PURE__*/React.createElement(IconButton, _extends({
    onClick: () => navigate(back?.to)
  }, IconButtonProps), /*#__PURE__*/React.createElement(IconBack, null))) : /*#__PURE__*/React.createElement("span", null), forward ? /*#__PURE__*/React.createElement(Tooltip, {
    name: (forward?.name !== undefined ? forward.name : forward?.label) || 'Forward'
  }, /*#__PURE__*/React.createElement(IconButton, _extends({
    onClick: () => navigate(forward?.to)
  }, IconButtonProps), /*#__PURE__*/React.createElement(IconForward, null))) : /*#__PURE__*/React.createElement("span", null));
  const header = !noHeader && (navigation || name) && /*#__PURE__*/React.createElement(Line, {
    gap: 2,
    direction: "column",
    fullWidth: true
  }, navigation, /*#__PURE__*/React.createElement(Line, {
    gap: 0,
    direction: "row",
    align: "center",
    justify: "center",
    fullWidth: true
  }, is('string', name) ? /*#__PURE__*/React.createElement(Type, {
    version: "t1",
    color: "inherit",
    align: "center",
    className: classes.name
  }, name) : name));
  return /*#__PURE__*/React.createElement(Component, _extends({
    ref: ref,
    gap: 4,
    direction: "column",
    justify: "unset",
    align: "unset",
    fullWidth: true,
    flex: true,
    className: classNames([staticClassName('Page', theme) && ['amaui-Page-root'], className, classes.root])
  }, other), header, /*#__PURE__*/React.createElement(Line, {
    gap: 0,
    direction: "column",
    justify: "unset",
    align: "unset",
    fullWidth: true,
    flex: true
  }, children));
});
Page.displayName = 'amaui-Page';
export default Page;