import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["color", "version", "width", "height", "animation", "text", "Component", "className", "style", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import SurfaceElement from '../Surface';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  '@keyframes move': {
    '100%': {
      transform: 'translateX(100%)'
    }
  },
  '@keyframes pulse': {
    '0%': {
      opacity: '1'
    },
    '50%': {
      opacity: '0.4'
    },
    '100%': {
      opacity: '1'
    }
  },
  '@keyframes pulseDark': {
    '0%': {
      opacity: '1'
    },
    '50%': {
      opacity: '0.7'
    },
    '100%': {
      opacity: '1'
    }
  },
  root: {
    position: 'relative',
    userSelect: 'none',
    overflow: 'hidden'
  },
  wrapper: {
    opacity: theme.palette.light ? '0.07' : '0.14',
    background: 'currentColor',
    width: '100%',
    height: '100%'
  },
  animation_wave: {
    '&::before': {
      content: "''",
      position: 'absolute',
      inset: '0',
      background: `linear-gradient(90deg, transparent, ${theme.methods.palette.color.colorToRgb(theme.palette.text.default.primary, 4)}, transparent)`,
      transform: 'translateX(-100%)',
      animation: '$move 2.4s infinite'
    }
  },
  animation_pulse: {
    animation: `$pulse${theme.palette.light ? '' : 'Dark'} 2.4s 0.4s infinite`
  },
  version_circle: {
    borderRadius: theme.methods.shape.radius.value(40, 'px')
  },
  version_rounded: {
    borderRadius: theme.methods.shape.radius.value(1, 'px')
  },
  version_rectangle: {
    borderRadius: '0px'
  },
  text: {
    height: '1em'
  },
  children: {
    visibility: 'hidden'
  }
}), {
  name: 'amaui-Placeholder'
});
const Placeholder = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiPlaceholder?.props?.default), props_), [props_]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const {
      color = 'default',
      version = 'rounded',
      width,
      height,
      animation = 'pulse',
      text,
      Component = 'div',
      className,
      style,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const styles = {
    root: {}
  };
  if (width !== undefined) styles.root.width = width;
  if (height !== undefined) styles.root.height = height;
  return /*#__PURE__*/React.createElement(Component, _extends({
    ref: ref,
    className: classNames([staticClassName('Placeholder', theme) && [`amaui-Placeholder-root`], className, classes.root, classes[`version_${version}`], animation && animation && classes[`animation_${animation}`], text && classes.text]),
    style: _objectSpread(_objectSpread({}, style), styles.root)
  }, other), /*#__PURE__*/React.createElement(Surface, {
    version: "text",
    tonal: false,
    color: color,
    className: classNames([staticClassName('Placeholder', theme) && [`amaui-Placeholder-wrapper`], classes.wrapper])
  }, children && /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('Placeholder', theme) && [`amaui-Placeholder-children`], classes.children])
  }, children)));
});
Placeholder.displayName = 'amaui-Placeholder';
export default Placeholder;