import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["inDefault", "offset", "offsetReveal", "offsetUnreveal", "unreveal", "inClassName", "onChange", "noTransition", "Component", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is, isEnvironment } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import FadeElement from '../Fade';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {}
}), {
  name: 'amaui-Reveal'
});
const Reveal = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiReveal?.props?.default), props_), [props_]);
  const Fade = React.useMemo(() => theme?.elements?.Fade || FadeElement, [theme]);
  const {
      inDefault,
      offset,
      offsetReveal,
      offsetUnreveal,
      unreveal,
      inClassName,
      onChange,
      noTransition,
      Component: Component_ = Fade,
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [inProp, setInProp] = React.useState(inDefault !== undefined ? inDefault : false);
  const refs = {
    root: React.useRef(),
    props: React.useRef(),
    in: React.useRef()
  };
  refs.props.current = props;
  refs.in.current = inProp;
  const updateIn = React.useCallback(value => {
    setInProp(value);
    if (is('function', onChange)) onChange(value);
  }, [onChange]);
  React.useEffect(() => {
    // Listen to window scroll value
    const method = () => {
      if (refs.root.current) {
        const rect = refs.root.current.getBoundingClientRect();
        const rootWindow = isEnvironment('browser') ? refs.root.current?.ownerDocument?.defaultView || window : undefined;

        // Reveal
        if (!refs.in.current) {
          const offset_ = refs.props.current.offsetReveal !== undefined ? refs.props.current.offsetReveal : refs.props.current.offset !== undefined ? refs.props.current.offset : 0;
          if (
          // Top
          // Top
          rect.top - offset_ < rootWindow.innerHeight && rect.top - offset_ > 0 && (
          // Left
          rect.left - offset_ < rootWindow.innerWidth && rect.left - offset_ > 0 ||
          // Right
          rect.left - offset_ < rootWindow.innerWidth && rect.right + offset_ > 0) ||
          // Left

          // Left
          rect.left - offset_ < rootWindow.innerWidth && rect.left - offset_ > 0 && (
          // Top
          rect.top - offset_ < rootWindow.innerHeight && rect.top - offset_ > 0 ||
          // Bottom
          rect.top - offset_ < rootWindow.innerHeight && rect.bottom + offset_ > 0) ||
          // Right

          // Right
          rect.left - offset_ < rootWindow.innerWidth && rect.right + offset_ > 0 && (
          // Top
          rect.top - offset_ < rootWindow.innerHeight && rect.top - offset_ > 0 ||
          // Bottom
          rect.top - offset_ < rootWindow.innerHeight && rect.bottom + offset_ > 0) ||
          // Bottom

          // Bottom
          rect.top - offset_ < rootWindow.innerHeight && rect.bottom + offset_ > 0 && (
          // Left
          rect.left - offset_ < rootWindow.innerWidth && rect.left - offset_ > 0 ||
          // Right
          rect.left - offset_ < rootWindow.innerWidth && rect.right + offset_ > 0)) updateIn(true);
        } else if (refs.props.current.unreveal) {
          const offset_ = refs.props.current.offsetUnreveal !== undefined ? refs.props.current.offsetUnreveal : refs.props.current.offset !== undefined ? refs.props.current.offset : 0;
          if (
          // Top
          rect.bottom + offset_ < 0 ||
          // Left
          rect.right + offset_ < 0 ||
          // Right
          rect.left - offset_ > rootWindow.innerWidth ||
          // Bottom
          rect.top - offset_ > rootWindow.innerHeight) updateIn(false);
        }
      }
    };

    // Initial
    setTimeout(() => {
      method();
    }, 14);
    const rootDocument = isEnvironment('browser') ? refs.root.current?.ownerDocument || window.document : undefined;
    if (refs.root.current) {
      rootDocument.addEventListener('scroll', method);
    }
    return () => {
      if (refs.root.current) {
        rootDocument.removeEventListener('scroll', method);
      }
    };
  }, []);
  const Component = !noTransition ? Component_ : React.Fragment;
  if (!noTransition) other.in = inProp;
  const ComponentProps = !noTransition && _objectSpread({}, other);
  return /*#__PURE__*/React.createElement(Component, ComponentProps, /*#__PURE__*/React.cloneElement(children, {
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    className: classNames([staticClassName('Reveal', theme) && ['amaui-Reveal-root', unreveal && `amaui-Reveal-unreveal`, inProp ? `amaui-Reveal-revealed` : `amaui-Reveal-unrevealed`], className, children.props.className, classes.root, inProp && inClassName])
  }));
});
Reveal.displayName = 'amaui-Reveal';
export default Reveal;