import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
const _excluded = ["value", "size", "name", "IconDocument", "MediaProps", "ImageProps", "AudioProps", "VideoProps", "OtherProps", "className"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { cleanValue, is } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import AudioPlayerElement from '../AudioPlayer';
import IconElement from '../Icon';
import ImageElement from '../Image';
import InteractionElement from '../Interaction';
import LineElement from '../Line';
import SectionElement from '../Section/Section';
import TypeElement from '../Type';
import VideoPlayerElement from '../VideoPlayer';
import { staticClassName } from '../utils';
const IconMaterialDraft = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "Draft",
    short_name: "Draft",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M6 22q-.825 0-1.412-.587Q4 20.825 4 20V4q0-.825.588-1.413Q5.175 2 6 2h7.175q.4 0 .763.15.362.15.637.425l4.85 4.85q.275.275.425.637.15.363.15.763V20q0 .825-.587 1.413Q18.825 22 18 22Zm7-14V4H6v16h12V9h-4q-.425 0-.712-.288Q13 8.425 13 8ZM6 4v5-5 16V4Z"
  }));
});
const useStyle = styleMethod(theme => ({
  root: {},
  name: {
    wordBreak: 'break-word'
  },
  other: {
    position: 'relative',
    aspectRatio: '3 / 4',
    cursor: 'pointer',
    userSelect: 'none',
    background: theme.palette.background.secondary.tertiary,
    boxShadow: theme.shadows.values.default[1]
  },
  otherWrapper_size_small: {
    maxWidth: '74px',
    width: '90vw'
  },
  otherWrapper_size_regular: {
    maxWidth: '94px',
    width: '90vw'
  },
  otherWrapper_size_large: {
    maxWidth: '114px',
    width: '90vw'
  },
  other_size_small: {
    borderRadius: theme.methods.shape.radius.value(1)
  },
  other_size_regular: {
    borderRadius: theme.methods.shape.radius.value(2)
  },
  other_size_large: {
    borderRadius: theme.methods.shape.radius.value(3)
  }
}), {
  name: 'amaui-SectionMedia'
});
const Element = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiSectionMedia?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Section = React.useMemo(() => theme?.elements?.Section || SectionElement, [theme]);
  const Image = React.useMemo(() => theme?.elements?.Image || ImageElement, [theme]);
  const AudioPlayer = React.useMemo(() => theme?.elements?.AudioPlayer || AudioPlayerElement, [theme]);
  const VideoPlayer = React.useMemo(() => theme?.elements?.VideoPlayer || VideoPlayerElement, [theme]);
  const Interaction = React.useMemo(() => theme?.elements?.Interaction || InteractionElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const {
      value,
      size = 'regular',
      name,
      IconDocument = IconMaterialDraft,
      MediaProps,
      ImageProps,
      AudioProps,
      VideoProps,
      OtherProps,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const refs = {
    root: React.useRef()
  };
  const onOpenMedia = React.useCallback(media => {
    window.open(media.url || media.src || media.urlSmall || media.srcSmall, 'blank_');
  }, []);
  let element;
  if (value) {
    const mime = value.mime;
    if (mime?.includes('image')) element = /*#__PURE__*/React.createElement(Image, _extends({
      src: value?.url || value?.src || value?.urlSmall || value?.srcSmall || (is('string', value) ? value : ''),
      maxWidth: "rg",
      fullWidth: true
    }, MediaProps, ImageProps, {
      className: classNames([staticClassName('SectionMedia', theme) && ['amaui-SectionMedia-item', 'amaui-SectionMedia-item-image'], MediaProps?.className, ImageProps?.className])
    }));else if (mime?.includes('audio')) element = /*#__PURE__*/React.createElement(AudioPlayer, _extends({
      size: size
    }, value, MediaProps, AudioProps, {
      className: classNames([staticClassName('SectionMedia', theme) && ['amaui-SectionMedia-item', 'amaui-SectionMedia-item-audio'], MediaProps?.className, AudioProps?.className])
    }));else if (mime?.includes('video')) element = /*#__PURE__*/React.createElement(VideoPlayer, _extends({
      size: size
    }, value, MediaProps, VideoProps, {
      className: classNames([staticClassName('SectionMedia', theme) && ['amaui-SectionMedia-item', 'amaui-SectionMedia-item-video'], MediaProps?.className, VideoProps?.className])
    }));else element = /*#__PURE__*/React.createElement(Line, {
      gap: 1,
      className: classNames([staticClassName('SectionMedia', theme) && ['amaui-SectionMedia-wrapper', 'amaui-SectionMedia-wrapper-other'], classes.wrapper, classes[`otherWrapper_size_${size}`]])
    }, /*#__PURE__*/React.createElement(Line, _extends({
      align: "center",
      justify: "center",
      onClick: () => onOpenMedia(value),
      fullWidth: true
    }, MediaProps, OtherProps, {
      className: classNames([staticClassName('SectionMedia', theme) && ['amaui-SectionMedia-item', 'amaui-SectionMedia-item-other'], MediaProps?.className, OtherProps?.className, classes.other, classes[`other_size_${size}`]])
    }), /*#__PURE__*/React.createElement(Interaction, null), /*#__PURE__*/React.createElement(IconDocument, {
      size: size === 'large' ? 44 : size === 'regular' ? 34 : 24
    })));
  }
  return /*#__PURE__*/React.createElement(Section, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    padding: "small",
    align: "center",
    className: classNames([staticClassName('SectionMedia', theme) && ['amaui-SectionMedia-root'], className, classes.root])
  }, other), /*#__PURE__*/React.createElement(Line, {
    align: "center",
    fullWidth: true
  }, element, name && /*#__PURE__*/React.createElement(Type, {
    version: size === 'large' ? 't1' : size === 'regular' ? 't2' : 't3',
    align: "center",
    fullWidth: true,
    className: classNames([staticClassName('SectionMedia', theme) && ['amaui-SectionMedia-name'], classes.name])
  }, cleanValue(value?.name || 'No name', {
    capitalize: true
  }))));
});
Element.displayName = 'amaui-SectionMedia';
export default Element;