import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
const _excluded = ["version", "valueDefault", "value", "inputProps", "onChange", "error", "placeholder", "edit", "mention", "multiline", "onChangeMention", "optionsMention", "mentionLabel", "onKeyDown", "readOnly", "additional", "className"],
  _excluded2 = ["label", "labelButton", "value", "onChange", "onClick", "InputComponent", "InputProps"],
  _excluded3 = ["open", "element", "anchorElement", "onClose", "children"],
  _excluded4 = ["open", "label", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { innerHTMLToText, is, isEnvironment, parse, stringToColor, textToInnerHTML } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import TextFieldElement from '../TextField/TextField';
import IconElement from '../Icon';
import LineElement from '../Line';
import ListElement from '../List';
import ListItemElement from '../ListItem';
import AvatarElement from '../Avatar';
import TypeElement from '../Type';
import SurfaceElement from '../Surface';
import ButtonElement from '../Button';
import AppendElement from '../Append';
import FadeElement from '../Fade';
import TooltipElement from '../Tooltip';
import ToggleButtonElement from '../ToggleButton';
import ClickListenerElement from '../ClickListener';
import ToggleButtonsElement from '../ToggleButtons';
import MenuElement from '../Menu';
import { sanitize, caret, keyboardStyleCommands, staticClassName } from '../utils';
const IconMaterialFormatItalicRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "FormatItalic",
    short_name: "FormatItalic",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M6.5 20q-.625 0-1.062-.438Q5 19.125 5 18.5t.438-1.062Q5.875 17 6.5 17h1.875l4-10H10.5q-.625 0-1.062-.438Q9 6.125 9 5.5t.438-1.062Q9.875 4 10.5 4h7q.625 0 1.062.438Q19 4.875 19 5.5t-.438 1.062Q18.125 7 17.5 7h-1.875l-4 10H13.5q.625 0 1.062.438.438.437.438 1.062t-.438 1.062Q14.125 20 13.5 20Z"
  }));
});
const IconMaterialFormatUnderlinedRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "FormatUnderlined",
    short_name: "FormatUnderlined",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M6 21q-.425 0-.713-.288Q5 20.425 5 20t.287-.712Q5.575 19 6 19h12q.425 0 .712.288.288.287.288.712t-.288.712Q18.425 21 18 21Zm6-4q-2.525 0-4.263-1.738Q6 13.525 6 11V4.25q0-.525.363-.888Q6.725 3 7.25 3t.887.362q.363.363.363.888V11q0 1.475 1.012 2.488Q10.525 14.5 12 14.5t2.488-1.012Q15.5 12.475 15.5 11V4.25q0-.525.363-.888Q16.225 3 16.75 3t.888.362q.362.363.362.888V11q0 2.525-1.738 4.262Q14.525 17 12 17Z"
  }));
});
const IconMaterialStrikethroughSRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "StrikethroughS",
    short_name: "StrikethroughS",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M12.15 20q-1.625 0-2.925-.812-1.3-.813-2.1-2.288-.225-.425-.05-.9.175-.475.675-.675.425-.2.863-.025.437.175.712.625.45.75 1.187 1.213.738.462 1.688.462 1.05 0 1.9-.5.85-.5.85-1.6 0-.45-.175-.825Q14.6 14.3 14.3 14h2.8q.125.35.188.712.062.363.062.788 0 2.15-1.538 3.325Q14.275 20 12.15 20ZM3 12q-.425 0-.712-.288Q2 11.425 2 11t.288-.713Q2.575 10 3 10h18q.425 0 .712.287.288.288.288.713t-.288.712Q21.425 12 21 12Zm4.25-4q.05-1.725 1.363-2.938Q9.925 3.85 12.05 3.85q1.35 0 2.425.537 1.075.538 1.8 1.663.275.425.1.9-.175.475-.675.7-.375.175-.812.038-.438-.138-.788-.563-.325-.375-.825-.625-.5-.25-1.175-.25-1.025 0-1.7.463-.675.462-.75 1.287Z"
  }));
});
const IconMaterialFormatBoldRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "FormatBold",
    short_name: "FormatBold",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M9 18q-.825 0-1.412-.587Q7 16.825 7 16V6q0-.825.588-1.412Q8.175 4 9 4h3.5q1.7 0 2.975.975 1.275.975 1.275 2.675 0 1.2-.55 1.912-.55.713-1.3 1.088v.2q1.1.375 1.725 1.175t.625 2.075q0 1.875-1.363 2.888Q14.525 18 12.65 18Zm.65-8.3h2.65q.825 0 1.363-.475.537-.475.537-1.2t-.537-1.2q-.538-.475-1.363-.475H9.65Zm0 5.9h2.85q.975 0 1.538-.5.562-.5.562-1.325t-.562-1.325q-.563-.5-1.538-.5H9.65Z"
  }));
});
const IconMaterialAddLinkRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "AddLink",
    short_name: "AddLink",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M7 17q-2.075 0-3.537-1.463Q2 14.075 2 12t1.463-3.538Q4.925 7 7 7h3q.425 0 .713.287Q11 7.575 11 8t-.287.712Q10.425 9 10 9H7q-1.25 0-2.125.875T4 12q0 1.25.875 2.125T7 15h3q.425 0 .713.287.287.288.287.713t-.287.712Q10.425 17 10 17Zm2-4q-.425 0-.712-.288Q8 12.425 8 12t.288-.713Q8.575 11 9 11h6q.425 0 .713.287.287.288.287.713t-.287.712Q15.425 13 15 13Zm13-1h-2q0-1.25-.875-2.125T17 9h-3q-.425 0-.712-.288Q13 8.425 13 8t.288-.713Q13.575 7 14 7h3q2.075 0 3.538 1.462Q22 9.925 22 12Zm-4 8q-.425 0-.712-.288Q17 19.425 17 19v-2h-2q-.425 0-.712-.288Q14 16.425 14 16t.288-.713Q14.575 15 15 15h2v-2q0-.425.288-.713Q17.575 12 18 12t.712.287Q19 12.575 19 13v2h2q.425 0 .712.287.288.288.288.713t-.288.712Q21.425 17 21 17h-2v2q0 .425-.288.712Q18.425 20 18 20Z"
  }));
});
const IconMaterialLinkOffRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "LinkOff",
    short_name: "LinkOff",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "m15.825 13-2-2h2q.425 0 .713.287.287.288.287.713t-.287.712q-.288.288-.713.288Zm3.425 3.45-1.5-1.55q.975-.275 1.613-1.063Q20 13.05 20 12q0-1.25-.875-2.125T17 9h-3q-.425 0-.712-.288Q13 8.425 13 8t.288-.713Q13.575 7 14 7h3q2.075 0 3.538 1.438Q22 9.875 22 12q0 1.425-.75 2.637-.75 1.213-2 1.813Zm-.15 5.45-17-17q-.275-.275-.275-.7 0-.425.275-.7.275-.275.7-.275.425 0 .7.275l17 17q.275.275.275.7 0 .425-.275.7-.275.275-.7.275-.425 0-.7-.275ZM10 17H7q-2.075 0-3.537-1.463Q2 14.075 2 12q0-1.75 1.062-3.088Q4.125 7.575 5.75 7.15L7.6 9H7q-1.25 0-2.125.875T4 12q0 1.25.875 2.125T7 15h3q.425 0 .713.287.287.288.287.713t-.287.712Q10.425 17 10 17Zm1.6-4H8.175q-.425 0-.712-.288-.288-.287-.288-.712t.288-.713Q7.75 11 8.175 11h1.45Z"
  }));
});
const IconMaterialFormatClearRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "FormatClear",
    short_name: "FormatClear",
    viewBox: "0 0 24 24"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "m13.2 10.35-2.325-2.325L7.85 5H18.5q.625 0 1.062.438Q20 5.875 20 6.5t-.438 1.062Q19.125 8 18.5 8h-4.3Zm5.9 11.55-7.6-7.6-1.6 3.775q-.175.425-.562.675Q8.95 19 8.5 19q-.8 0-1.25-.675-.45-.675-.125-1.425L9.2 12 2.1 4.9q-.275-.275-.275-.7 0-.425.275-.7.275-.275.7-.275.425 0 .7.275l17 17q.275.275.275.7 0 .425-.275.7-.275.275-.7.275-.425 0-.7-.275Z"
  }));
});
const useStyle = styleMethod(theme => ({
  root: {
    minHeight: '20px',
    width: '100%',
    '& .amaui-TextField-input': _objectSpread({
      wordBreak: 'break-word',
      color: theme.methods.palette.color.value('primary', 10)
    }, theme.typography.values.b2)
  },
  root_type: {
    minHeight: '20px',
    width: '100%',
    cursor: 'text',
    '& .amaui-TextField-input': _objectSpread({
      wordBreak: 'break-word',
      color: theme.methods.palette.color.value('primary', 10)
    }, theme.typography.values.b2)
  },
  menu: {
    width: '100vw',
    maxWidth: '240px',
    borderRadius: theme.methods.shape.radius.value(2.5),
    boxShadow: '0px 4px 32px 0px rgba(0, 0, 0, 0.04)',
    background: theme.palette.light ? theme.palette.color.neutral[99] : theme.palette.color.neutral[20]
  },
  list: {
    maxHeight: '240px',
    overflow: 'hidden auto'
  },
  textMiniMenuWrapper: {
    paddingBlock: theme.methods.space.value(1, 'px')
  },
  textMiniMenu: {
    padding: theme.methods.space.value(1.5, 'px'),
    borderRadius: theme.methods.shape.radius.value(140, 'px'),
    boxShadow: theme.shadows.values.default[2]
  },
  textMiniMenuAdditionaMenu: {
    zIndex: '1514'
  },
  inputWrapper: {
    padding: theme.methods.space.value(1, 'px'),
    borderRadius: theme.methods.shape.radius.value(1, 'px'),
    boxShadow: theme.shadows.values.default[2]
  },
  singleLine: {
    whiteSpace: 'nowrap',
    overflow: 'hidden'
  }
}), {
  name: 'amaui-SmartTextField'
});
const SmartTextField = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiSmartTextField?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const TextField = React.useMemo(() => theme?.elements?.TextField || TextFieldElement, [theme]);
  const List = React.useMemo(() => theme?.elements?.List || ListElement, [theme]);
  const ListItem = React.useMemo(() => theme?.elements?.ListItem || ListItemElement, [theme]);
  const Avatar = React.useMemo(() => theme?.elements?.Avatar || AvatarElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const Button = React.useMemo(() => theme?.elements?.Button || ButtonElement, [theme]);
  const Append = React.useMemo(() => theme?.elements?.Append || AppendElement, [theme]);
  const Fade = React.useMemo(() => theme?.elements?.Fade || FadeElement, [theme]);
  const Tooltip = React.useMemo(() => theme?.elements?.Tooltip || TooltipElement, [theme]);
  const ToggleButton = React.useMemo(() => theme?.elements?.ToggleButton || ToggleButtonElement, [theme]);
  const ClickListener = React.useMemo(() => theme?.elements?.ClickListener || ClickListenerElement, [theme]);
  const ToggleButtons = React.useMemo(() => theme?.elements?.ToggleButtons || ToggleButtonsElement, [theme]);
  const Menu = React.useMemo(() => theme?.elements?.Menu || MenuElement, [theme]);
  const {
      version = 'type',
      valueDefault,
      value: value_,
      inputProps,
      onChange,
      error: error_,
      placeholder,
      edit,
      mention,
      multiline,
      onChangeMention,
      optionsMention: optionsMention_,
      mentionLabel,
      onKeyDown: onKeyDown_,
      readOnly,
      additional,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [value, setValue] = React.useState(valueDefault || '');
  const [openMenu, setOpenMenu] = React.useState(false);
  const [offset, setOffset] = React.useState([0, 8]);
  const [selectionMenu, setSelectionMenu] = React.useState();
  const [optionsMention, setOptionsMention] = React.useState([]);
  const [textSelection, setTextSelection] = React.useState();
  const [textSelected, setTextSelected] = React.useState([]);
  const [open, setOpen] = React.useState({});
  const [inputValues, setInputValues] = React.useState({});
  const refs = {
    root: React.useRef(),
    input: React.useRef(),
    searchElement: React.useRef(),
    error: React.useRef(),
    search: React.useRef(),
    open: React.useRef(),
    openMenu: React.useRef(),
    selectionMenu: React.useRef(),
    caret: React.useRef(),
    value: React.useRef(),
    version: React.useRef(version),
    optionsMention: React.useRef(optionsMention),
    validateMeta: React.useRef({}),
    range: React.useRef(),
    inputValues: React.useRef(),
    miniMenu: React.useRef(),
    miniMenuElements: {
      color: React.useRef(),
      colorPalette: React.useRef(),
      background: React.useRef(),
      backgroundPalette: React.useRef(),
      linkAdd: React.useRef(),
      linkAddInput: React.useRef(),
      linkRemove: React.useRef()
    },
    textSelected: React.useRef(),
    textSelection: React.useRef(),
    rootDocument: React.useRef(),
    rootWindow: React.useRef(),
    edit: React.useRef(edit),
    multiline: React.useRef(multiline),
    readOnly: React.useRef(readOnly),
    onChange: React.useRef(onChange)
  };
  refs.value.current = value;
  refs.version.current = version;
  refs.open.current = open;
  refs.openMenu.current = openMenu;
  refs.selectionMenu.current = selectionMenu;
  refs.optionsMention.current = optionsMention;
  refs.inputValues.current = inputValues;
  refs.textSelected.current = textSelected;
  refs.textSelection.current = textSelection;
  refs.edit.current = edit;
  refs.multiline.current = multiline;
  refs.readOnly.current = readOnly;
  refs.onChange.current = onChange;
  const rootDocument = isEnvironment('browser') && (refs.root.current?.ownerDocument || window.document);
  const rootWindow = rootDocument && (rootDocument.defaultView || window);
  refs.rootDocument.current = rootDocument;
  refs.rootWindow.current = rootWindow;
  const init = React.useCallback(() => {
    if (version === 'type') {
      const valueNew = valueDefault || value || '';
      if (refs.root.current) {
        refs.root.current.innerHTML = valueNew;
      }
    }
  }, [version, value, valueDefault]);
  React.useEffect(() => {
    // init
    init();
  }, []);
  React.useEffect(() => {
    if (optionsMention !== optionsMention_) setOptionsMention(optionsMention_);
  }, [optionsMention_]);
  React.useEffect(() => {
    const valuePrevious = (refs.root.current.innerHTML || '').replaceAll('&nbsp;', ' ');
    const valueNew = textToInnerHTML(value_);
    if (value_ !== undefined && valuePrevious !== valueNew) validate(!value_ ? '' : sanitize(value_));
  }, [value_]);

  // Save selection to revive, use it on execComand
  React.useEffect(() => {
    const selection_ = refs.rootWindow.current.getSelection();
    if (selection_ && selection_.anchorNode && !selection_.anchorNode?.className?.includes('TextField')) refs.range.current = selection_.getRangeAt(0);
  }, [open]);
  const updateInputValues = (property, itemValue) => {
    setInputValues(values => _objectSpread(_objectSpread({}, values), {}, {
      [property]: itemValue
    }));
  };
  const updateOpen = (property, itemValue) => {
    setOpen(values => _objectSpread(_objectSpread({}, values), {}, {
      [property]: itemValue
    }));
  };
  const validateElement = React.useCallback(element => {
    if (element?.children) {
      Array.from(element?.children).forEach(child => {
        // Any tag
        if (child.dataset.amauiVersion === 'mention-user') {
          // Replace the child if label & textContent don't match
          if (child.dataset.amauiLabel !== child.innerHTML) {
            element.replaceChild(window.document.createTextNode(child.textContent), child);
            refs.validateMeta.current.restore = true;
          }
        }
        if (child?.children) validateElement(child);
      });
    }
  }, []);
  const validate = React.useCallback(function () {
    let valueNew = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
    // Save caret position
    refs.caret.current = caret.save(refs.root.current);

    // Update the root innerHTML
    if (valueNew !== undefined) refs.root.current.innerHTML = valueNew;
    refs.validateMeta.current.restore = false;

    // Find all span amaui-mention children
    // if they aren't valid, replace them with text node of their textContent
    validateElement(refs.root.current);
    if (refs.validateMeta.current.restore) caret.restore(refs.root.current, refs.caret.current);
    return refs.root.current.innerHTML;
  }, []);
  const getAtSearchData = React.useCallback(() => {
    if (refs.root.current) {
      const windowSelection = window.document.getSelection();
      if (!(windowSelection && windowSelection.rangeCount > 0)) return;
      const range = windowSelection?.getRangeAt(0);
      if (!range) return;

      // Only allow for text not in span user mention element
      if (windowSelection.anchorNode?.parentElement?.dataset?.amauiVersion === 'mention-user') return '';

      // Text
      if (!['text', '#text'].includes(range?.commonAncestorContainer?.nodeName)) return '';
      const text = windowSelection.anchorNode?.textContent || '';
      const start = text.slice(0, range.endOffset).split('').reverse().join('');
      let result = [];
      for (const valueText of start) {
        // All characters other than space, numbers
        if (!!valueText.match(/[^<>\\/\n\r\t]/)) result.unshift(valueText);else break;
        if (['@'].includes(valueText)) break;
      }
      result = result.includes('@') ? result.join('') : '';

      // Allow 1 space only
      if (result && result.match(/\s{2}/g)) return '';
      return result;
    }
  }, []);
  refs.search.current = getAtSearchData();
  const onInput = React.useCallback(event => {
    if (refs.root.current) {
      let valueInput = refs.root.current.innerHTML || '';
      if (refs.root.current.textContent === '') {
        valueInput = '';
        refs.root.current.innerHTML = '';
      }
      if (!refs.multiline.current) {
        const previous = valueInput;
        valueInput = valueInput.replace(/\r?\n|\r/gm, '');
        if (previous !== valueInput) refs.root.current.innerHTML = valueInput;
      }
      valueInput = innerHTMLToText(valueInput);
      setValue(valueInput);
      if (is('function', refs.onChange.current)) refs.onChange.current(valueInput, event);
    }
  }, []);
  React.useEffect(() => {
    if (mention && refs.search.current !== undefined) onChangeMention?.(refs.search.current, '@');
  }, [mention, refs.search.current]);
  React.useEffect(() => {
    const method = () => {
      if (window.document.activeElement === refs.input.current) onInput();
    };
    window.document.addEventListener('selectionchange', method);
    onChangeMention?.(refs.search.current, '@');
    return () => {
      window.document.removeEventListener('selectionchange', method);
    };
  }, []);
  const updateSelection = React.useCallback(() => {
    const windowSelection = window.document.getSelection();
    if (!(windowSelection && windowSelection.rangeCount > 0)) return;
    const range = windowSelection?.getRangeAt(0);
    if (range) setSelectionMenu(range?.getBoundingClientRect());
  }, []);
  const onOpenSearch = React.useCallback(async () => {
    if (!refs.openMenu.current && !!refs.optionsMention.current.length) {
      // open
      setOpenMenu(true);

      // selection
      updateSelection();
    }
  }, []);
  const onCloseSearch = React.useCallback(() => {
    if (refs.openMenu.current) {
      setOpenMenu(false);
      setSelectionMenu(null);
    }
  }, []);
  const updateOffset = React.useCallback(() => {
    setOffset([-(refs.searchElement.current?.clientWidth || 0), 8]);
  }, []);
  const onFocus = React.useCallback(() => {
    // setFocus(true);
  }, []);
  const onBlur = React.useCallback(() => {
    // setFocus(false);
  }, []);
  const onKeyDown = React.useCallback(event => {
    const windowSelection = window.getSelection();
    if (windowSelection) {
      // if (event.key === 'Enter') {
      //   event.preventDefault();

      //   const anchor = windowSelection.anchorNode as HTMLElement;
      //   const element = anchor.parentElement;

      //   const multiple = anchor.tagName === 'P' && anchor.children.length === 1 && anchor.children[0].tagName === 'BR';

      //   window.document.execCommand('insertHTML', false, `<p><br /></p>`.repeat(multiple ? 2 : 1));

      //   const range = new Range();

      //   const rangeStartElement = ((multiple ? anchor : element) as any)?.nextElementSibling;

      //   if (rangeStartElement) range.setStart(rangeStartElement, 0);

      //   windowSelection.removeAllRanges();
      //   windowSelection.addRange(range);
      // }

      if (event.key === 'ArrowRight') {
        // If in user mention span
        // move out of it with adding new empty space root node after the user mention span
        // only if caret is at the end of the span, & span is last child of it's parent
        if (!(windowSelection && windowSelection.rangeCount > 0)) return;
        const range = windowSelection.getRangeAt(0);
        const caretElement = windowSelection.anchorNode.parentElement;
        const caretElementParent = caretElement.parentElement;
        const caretElementParentChildNodes = Array.from(caretElementParent.childNodes);
        if (caretElement?.dataset?.amauiVersion === 'mention-user' && range.endOffset === windowSelection.anchorNode.textContent.length && caretElementParentChildNodes[caretElementParentChildNodes.length - 1] === caretElement) {
          caretElementParent.insertBefore(window.document.createTextNode('\u00A0'), caretElement.nextElementSibling);
        }
      }
    }
    if (!refs.multiline.current) {
      if (event.key === 'Enter') {
        event.preventDefault();
      }
    }
    if (!refs.edit.current && (event.metaKey && keyboardStyleCommands.includes(event.key) || event.ctrlKey && keyboardStyleCommands.includes(event.key))) {
      event.preventDefault();
    }
    if (is('function', onKeyDown_)) onKeyDown_(event);
  }, [onKeyDown_]);
  const onPaste = React.useCallback(event => {
    event.preventDefault();
    const text = event.clipboardData?.getData('text/plain');
    window.document.execCommand('insertText', false, text);
  }, []);
  const onDrop = React.useCallback(event => {
    event.preventDefault();
  }, []);
  const addTag = React.useCallback(function (item) {
    let versionMention = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'user';
    // Save caret position
    refs.caret.current = caret.save(refs.root.current);
    const name = item.name;
    const classesElement = ['amaui-mention'];

    // Query text node that equals selection anchorNode
    // and replace its textContent's search value with new span
    const windowSelection = window.document.getSelection();
    if (!(windowSelection && windowSelection.rangeCount > 0)) return;
    const range = windowSelection?.getRangeAt(0);
    if (!range) return;
    const textNode = windowSelection.anchorNode;
    const textContent = textNode.textContent;

    // Bug fix
    // only be able to insert data within the input
    // if by accident selection went outside the input
    // basically do nothing with it
    if (refs.root.current.contains(textNode.parentElement)) {
      const end = range.endOffset;
      const start = end - refs.search.current.length;
      const pre = textContent.slice(0, start);
      const post = textContent.slice(end);

      // Insert before anchorNode pre, item mention, and post
      if (pre) textNode.parentElement.insertBefore(window.document.createTextNode(pre), windowSelection.anchorNode);
      const span = window.document.createElement('span');
      span.className = classesElement.join(' ');
      span.dataset.amauiLabel = `@${name}`;
      span.dataset.amauiVersion = `mention-${versionMention}`;
      span.dataset.amauiObject = `${versionMention}`;
      span.dataset.amauiId = item.id;
      span.innerHTML = `@${name}`;
      textNode.parentElement.insertBefore(span, windowSelection.anchorNode);

      // 1 space only following the item mention
      textNode.parentElement.insertBefore(window.document.createTextNode('\u00A0'), windowSelection.anchorNode);
      if (post) textNode.parentElement.insertBefore(window.document.createTextNode(post), windowSelection.anchorNode);

      // Remove the text node
      textNode.remove();

      // Invoke onChange method with new value
      const valueInput = innerHTMLToText(refs.root.current.innerHTML);
      if (is('function', refs.onChange.current)) refs.onChange.current(valueInput, {
        target: refs.root.current
      });

      // Update the caret position to be outside the span mention
      // for amount of added characters + 1 space
      const added = `@${name}`.length - refs.search.current.length + 1;
      refs.caret.current.start = refs.caret.current.end += added;
      caret.restore(refs.root.current, refs.caret.current);
    }

    // Close the search
    onCloseSearch();
  }, [onChange]);

  // If users response & not open, open
  // else if no users response & opened, close the search
  React.useEffect(() => {
    if (mention) {
      if (refs.openMenu.current && !optionsMention.length) onCloseSearch();else if (!refs.openMenu.current && refs.search.current && !!optionsMention.length) onOpenSearch();
    }
  }, [mention, optionsMention]);
  React.useEffect(() => {
    if (mention) {
      // Validate
      validate();

      // Update
      // open, selection & offset
      setTimeout(() => {
        refs.search.current ? onOpenSearch() : onCloseSearch();
        if (refs.openMenu.current) updateSelection();
        updateOffset();
      });
    }
  }, [mention, value]);
  React.useEffect(() => {
    // setError(error_);
  }, [error_]);
  const label = React.useCallback(() => is('function', mentionLabel) ? mentionLabel(refs.optionsMention.current, {
    addTag
  }) : /*#__PURE__*/React.createElement(Line, {
    className: classes.menu
  }, /*#__PURE__*/React.createElement(List, {
    size: "small",
    className: classes.list
  }, refs.optionsMention.current?.map((item, index) => /*#__PURE__*/React.createElement(ListItem, {
    key: index,
    start: /*#__PURE__*/React.createElement(Avatar, {
      color: stringToColor(item.name),
      size: "small"
    }, item.name?.slice(0, 1)),
    primary: /*#__PURE__*/React.createElement(Type, {
      version: "l3"
    }, item.name),
    onClick: () => addTag(item),
    button: true
  })))), []);
  const paste = async () => {
    const valueClipboard = await navigator.clipboard.read();
    if (valueClipboard) {
      let values = '';
      for (const item of Array.from(valueClipboard)) {
        const valueItem = await item.getType('text/html');
        values += await valueItem.text();
      }
      rootDocument.execCommand('insertHTML', undefined, values);
    }
  };
  const query = command => {
    return parse(refs.rootDocument.current.queryCommandValue(command));
  };
  const textQueryUpdate = () => {
    const selected = [];
    const updateOptionValues = [{
      name: 'italic',
      command: 'italic'
    }, {
      name: 'underline',
      command: 'underline'
    }, {
      name: 'bold',
      command: 'bold'
    }, {
      name: 'strike-line',
      command: 'strikeThrough'
    }];
    updateOptionValues.forEach(item => {
      if (query(item.command)) selected.push(item.name);
    });
    setTextSelected(selected);
  };
  const onMouseUp = React.useCallback(() => {
    if (!refs.edit.current) return;
    const selection_ = refs.rootWindow.current.getSelection();
    if (!selection_) return;
    if (!selection_.anchorNode || !refs.root.current.contains(selection_.anchorNode)) return setTextSelection(null);
    setTimeout(() => {
      const rect = selection_.getRangeAt(0).getBoundingClientRect();
      setTextSelection(Math.round(rect.width) ? {
        selection: rect,
        element: selection_.anchorNode?.parentElement
      } : null);
      textQueryUpdate();
    }, 140);
  }, []);
  const onMouseDown = React.useCallback(() => {
    if (!refs.edit.current) return;
    textQueryUpdate();
  }, []);
  const textMethod = React.useCallback(command => argument => {
    switch (command) {
      // updates
      case 'italic':
        refs.rootDocument.current.execCommand('italic');
        if (query('italic')) setTextSelected(values => [...values, 'italic']);else setTextSelected(values => values.filter(item => item !== 'italic'));
        break;
      case 'underline':
        refs.rootDocument.current.execCommand('underline');
        if (query('underline')) setTextSelected(values => [...values, 'underline']);else setTextSelected(values => values.filter(item => item !== 'underline'));
        break;
      case 'bold':
        refs.rootDocument.current.execCommand('bold');
        if (query('bold')) setTextSelected(values => [...values, 'bold']);else setTextSelected(values => values.filter(item => item !== 'bold'));
        break;
      case 'strike-line':
        refs.rootDocument.current.execCommand('strikeThrough');
        if (query('strikeThrough')) setTextSelected(values => [...values, 'strike-line']);else setTextSelected(values => values.filter(item => item !== 'strike-line'));
        break;
      case 'link-add':
        refs.rootDocument.current.execCommand('createLink', undefined, argument);
        break;
      case 'link-remove':
        refs.rootDocument.current.execCommand('unlink');
        break;

      // actions
      case 'copy':
        refs.rootDocument.current.execCommand('copy');
        break;
      case 'cut':
        refs.rootDocument.current.execCommand('cut');
        break;
      case 'paste':
        if (refs.rootDocument.current.queryCommandSupported('paste')) refs.rootDocument.current.execCommand('paste');else paste();
        break;
      case 'delete':
        refs.rootDocument.current.execCommand('delete');
        break;
      case 'clear':
        refs.rootDocument.current.execCommand('removeFormat');
        break;
      case 'select-all':
        refs.rootDocument.current.execCommand('selectAll');
        break;
      case 'undo':
        refs.rootDocument.current.execCommand('undo');
        break;
      case 'redo':
        refs.rootDocument.current.execCommand('redo');
        break;
      default:
        break;
    }
    const element = refs.textSelection.current?.element;
    if (element) {
      let valueElement = element.innerHTML || '';
      if (element.textContent === '') {
        valueElement = '';
        element.innerHTML = '';
      }
      if (valueElement) valueElement = innerHTMLToText(valueElement);
    }
  }, []);
  const AppendProps = {
    padding: [14, 14]
  };
  const IconProps = {
    size: 'small'
  };
  const TooltipProps = {
    position: 'bottom',
    interactive: false
  };
  const ToggleButtonsProps = {
    tonal: false,
    color: 'default',
    version: 'text',
    border: false
  };
  const ToggleButtonProps = {
    size: 'small'
  };
  const MiniMenuProps = {
    tonal: false,
    color: 'default'
  };
  const Input = React.useCallback( /*#__PURE__*/React.forwardRef((propsInput, ref_) => {
    const {
        label: labelInput,
        labelButton,
        value: value__,
        onChange: onChange__,
        onClick,
        InputComponent = TextField,
        InputProps
      } = propsInput,
      other_ = _objectWithoutProperties(propsInput, _excluded2);
    return /*#__PURE__*/React.createElement(Line, _extends({
      ref: ref_,
      gap: 1,
      direction: "column",
      Component: Surface
    }, other_, {
      className: classNames([other_?.className, classes.inputWrapper])
    }), /*#__PURE__*/React.createElement(Line, {
      gap: 0.5,
      direction: "row",
      align: "center",
      style: {
        width: '100%'
      }
    }, /*#__PURE__*/React.createElement(InputComponent, _extends({
      label: labelInput,
      version: "outlined",
      size: "small",
      valueDefault: value__,
      onChange: onChange__,
      className: classNames([classes.textFieldColor])
    }, InputProps)), /*#__PURE__*/React.createElement(Button, {
      color: "inherit",
      version: "text",
      size: "small",
      onClick: onClick
    }, labelButton)));
  }), []);
  const WrapperAppend = React.useCallback(propsWrapper => {
    const {
        open: open_,
        element,
        anchorElement,
        onClose,
        children: childrenWrapperAppend
      } = propsWrapper,
      other_ = _objectWithoutProperties(propsWrapper, _excluded3);
    return /*#__PURE__*/React.createElement(Append, _extends({
      open: open_,
      element: /*#__PURE__*/React.createElement("div", {
        className: classes.textMiniMenuAdditionaMenu
      }, /*#__PURE__*/React.createElement(Fade, {
        in: open_,
        add: true
      }, /*#__PURE__*/React.cloneElement(element))),
      anchorElement: anchorElement,
      portal: true,
      alignment: "center",
      position: "bottom"
    }, AppendProps), /*#__PURE__*/React.cloneElement(childrenWrapperAppend, _objectSpread(_objectSpread({}, other_), childrenWrapperAppend.props)));
  }, []);
  const WrapperToggleButton = React.useCallback( /*#__PURE__*/React.forwardRef((propsWrapperToggleButton, ref_) => {
    const {
        open: open_,
        label: labelWrapperToogleButton,
        children: childrenWrapperToggleButton
      } = propsWrapperToggleButton,
      other_ = _objectWithoutProperties(propsWrapperToggleButton, _excluded4);
    return /*#__PURE__*/React.createElement(Tooltip, _extends({
      open: open_ !== undefined ? open_ : undefined,
      label: labelWrapperToogleButton
    }, TooltipProps), /*#__PURE__*/React.cloneElement(childrenWrapperToggleButton, _objectSpread(_objectSpread({}, other_), childrenWrapperToggleButton.props)));
  }), []);
  const updateElements = {
    'italic': /*#__PURE__*/React.createElement(WrapperToggleButton, {
      label: "Italic"
    }, /*#__PURE__*/React.createElement(ToggleButton, _extends({}, ToggleButtonProps, {
      selected: refs.textSelected.current.includes('italic'),
      onClick: textMethod('italic')
    }), /*#__PURE__*/React.createElement(IconMaterialFormatItalicRounded, IconProps))),
    'underline': /*#__PURE__*/React.createElement(WrapperToggleButton, {
      label: "Underline"
    }, /*#__PURE__*/React.createElement(ToggleButton, _extends({}, ToggleButtonProps, {
      selected: refs.textSelected.current.includes('underline'),
      onClick: textMethod('underline')
    }), /*#__PURE__*/React.createElement(IconMaterialFormatUnderlinedRounded, IconProps))),
    'bold': /*#__PURE__*/React.createElement(WrapperToggleButton, {
      label: "Bold",
      onClick: textMethod('bold')
    }, /*#__PURE__*/React.createElement(ToggleButton, _extends({}, ToggleButtonProps, {
      selected: refs.textSelected.current.includes('bold')
    }), /*#__PURE__*/React.createElement(IconMaterialFormatBoldRounded, IconProps))),
    'strike-line': /*#__PURE__*/React.createElement(WrapperToggleButton, {
      label: "Strike Line",
      onClick: textMethod('strike-line')
    }, /*#__PURE__*/React.createElement(ToggleButton, _extends({}, ToggleButtonProps, {
      selected: refs.textSelected.current.includes('strike-line')
    }), /*#__PURE__*/React.createElement(IconMaterialStrikethroughSRounded, IconProps))),
    'link-add': /*#__PURE__*/React.createElement(WrapperAppend, {
      open: refs.open.current.linkMiniMenu,
      anchorElement: refs.miniMenuElements.linkAdd,
      element: /*#__PURE__*/React.createElement(ClickListener, {
        onClickOutside: () => updateOpen('linkMiniMenu', false),
        include: [refs.miniMenuElements.linkAdd]
      }, /*#__PURE__*/React.createElement(Input, {
        ref: refs.miniMenuElements.linkAddInput,
        label: "Link",
        labelButton: "Add",
        value: refs.inputValues.current.link,
        onChange: valueNew => updateInputValues('link', valueNew),
        onClick: () => {
          if (refs.range.current) {
            const selection_ = refs.rootWindow.current.getSelection();
            if (!selection_) return;
            selection_.removeAllRanges();
            selection_.addRange(refs.range.current);
          }
          textMethod('link-add')(refs.inputValues.current.link);
          updateOpen('linkMiniMenu', false);
          updateInputValues('link', '');
        }
      }))
    }, /*#__PURE__*/React.createElement(WrapperToggleButton, {
      label: "Insert Link",
      open: refs.open.current.linkMiniMenu ? false : undefined
    }, /*#__PURE__*/React.createElement(ToggleButton, _extends({
      ref: refs.miniMenuElements.linkAdd
    }, ToggleButtonProps, {
      selected: refs.open.current.linkMiniMenu,
      onClick: () => updateOpen('linkMiniMenu', !refs.open.current.linkMiniMenu)
    }), /*#__PURE__*/React.createElement(IconMaterialAddLinkRounded, IconProps)))),
    'link-remove': /*#__PURE__*/React.createElement(WrapperToggleButton, {
      label: "Remove Link"
    }, /*#__PURE__*/React.createElement(ToggleButton, _extends({}, ToggleButtonProps, {
      onClick: textMethod('link-remove')
    }), /*#__PURE__*/React.createElement(IconMaterialLinkOffRounded, IconProps)))
  };
  const actionElements = {
    'clear': /*#__PURE__*/React.createElement(WrapperToggleButton, {
      label: "Clear"
    }, /*#__PURE__*/React.createElement(ToggleButton, _extends({}, ToggleButtonProps, {
      onClick: textMethod('clear')
    }), /*#__PURE__*/React.createElement(IconMaterialFormatClearRounded, IconProps)))
  };
  const miniMenu = React.useMemo(() => {
    return /*#__PURE__*/React.createElement(Append, _extends({
      open: !!textSelection,
      element: body => {
        const {
          ref: ref_,
          values,
          style: styleAppend
        } = body;
        return /*#__PURE__*/React.createElement("div", {
          ref: item => {
            if (ref_) {
              if (is('function', ref_)) ref_(item);else ref_.current = item;
              refs.miniMenu.current = item;
            }
          },
          style: _objectSpread(_objectSpread(_objectSpread({}, values?.x === 0 && values?.y === 0 ? {
            visibility: 'hidden'
          } : undefined), styleAppend), {}, {
            zIndex: 1500
          }),
          className: classes.textMiniMenuWrapper
        }, /*#__PURE__*/React.createElement(Fade, {
          in: !!textSelection,
          add: true
        }, /*#__PURE__*/React.createElement(ClickListener, {
          onClickOutside: () => {
            setTextSelection(null);
          },
          include: [refs.miniMenu, refs.miniMenu.current, refs.miniMenuElements.linkAddInput, refs.miniMenuElements.linkAddInput.current]
        }, /*#__PURE__*/React.createElement(Line, _extends({
          gap: 2,
          direction: "row",
          align: "center",
          justify: "flex-start",
          role: "toolbar",
          "aria-label": "Mini menu",
          Component: Surface
        }, MiniMenuProps, {
          className: classNames([classes.textMiniMenu])
        }), /*#__PURE__*/React.createElement(ToggleButtons, ToggleButtonsProps, updateElements['italic'], updateElements['underline'], updateElements['bold'], updateElements['strike-line']), /*#__PURE__*/React.createElement(ToggleButtons, ToggleButtonsProps, updateElements['link-add'], updateElements['link-remove']), /*#__PURE__*/React.createElement(ToggleButtons, ToggleButtonsProps, actionElements['clear'])))));
      },
      parent: refs.root.current,
      anchor: textSelection?.selection,
      portal: true,
      alignment: "center",
      position: "bottom",
      clearOnClose: true
    }, AppendProps));
  }, [open, textSelection, textSelected]);
  const menu = React.useMemo(() => {
    return /*#__PURE__*/React.createElement(Menu, {
      open: openMenu,
      position: "top",
      alignment: "start",
      offset: offset,
      anchor: selectionMenu,
      onClose: onCloseSearch,
      label: label(),
      interactive: true
    });
  }, [openMenu, selectionMenu, label]);
  let main = /*#__PURE__*/React.createElement(TextField, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      refs.root.current = item;
    },
    version: "text",
    minRows: 12,
    multiline: true,
    enabled: true,
    fullWidth: true,
    onInput: onInput,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    readOnly: readOnly,
    inputProps: _objectSpread(_objectSpread({
      version: 'b2',
      contentEditable: true,
      spellCheck: false,
      onPaste,
      onDrop,
      onMouseUp,
      onMouseDown,
      'data-placeholder': placeholder
    }, inputProps), {}, {
      ref: item => {
        refs.input.current = item;
        if (inputProps?.ref) {
          if (is('function', inputProps.ref)) inputProps.ref(item);else inputProps.ref.current = item;
        }
      }
    }),
    InputComponent: Type,
    className: classNames([staticClassName('SmartTextField', theme) && ['amaui-SmartTextField-root', `amaui-SmartTextField-version-${version}`], className, classes.root])
  }, additional, other));
  if (version === 'type') main = /*#__PURE__*/React.createElement(Type, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else ref.current = item;
      }
      if (inputProps?.ref) {
        if (is('function', inputProps.ref)) inputProps.ref(item);else inputProps.ref.current = item;
      }
      refs.root.current = item;
      refs.input.current = item;
    },
    onInput: onInput,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    onPaste: onPaste,
    onDrop: onDrop,
    onMouseUp: onMouseUp,
    onMouseDown: onMouseDown,
    spellCheck: false,
    "data-placeholder": placeholder
  }, inputProps, {
    contentEditable: !readOnly,
    className: classNames([staticClassName('SmartTextField', theme) && ['amaui-SmartTextField-root', `amaui-SmartTextField-version-${version}`], className, classes.root_type, !multiline && classes.singleLine])
  }, additional, other));
  return /*#__PURE__*/React.createElement(React.Fragment, null, main, miniMenu, menu);
});
SmartTextField.displayName = 'amaui-SmartTextField';
export default SmartTextField;