import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["open", "name", "label", "tooltipOpen", "closeOnClick", "render", "onBlur", "onFocus", "Icon", "TooltipProps", "Component", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is } from '@amaui/utils';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import TooltipElement from '../Tooltip';
import IconButtonElement from '../IconButton';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    position: 'relative',
    lineHeight: '0'
  },
  no_render: {
    '& .amaui-Button-root': {
      boxShadow: theme.shadows.values.default[6],
      '&:hover': {
        boxShadow: theme.shadows.values.default[8]
      },
      '&.amaui-Button-focus': {
        boxShadow: theme.shadows.values.default[8]
      }
    }
  }
}), {
  name: 'amaui-SpeedDialItem'
});
const SpeedDialItem = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiSpeedDialItem?.props?.default), props_), [props_]);
  const Tooltip = React.useMemo(() => theme?.elements?.Tooltip || TooltipElement, [theme]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const {
      open,
      name,
      label: label_,
      tooltipOpen,
      closeOnClick,
      render,
      onBlur,
      onFocus,
      Icon,
      TooltipProps = {
        alignment: 'center',
        interactive: false
      },
      Component = 'div',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  delete TooltipProps.open;
  if (tooltipOpen) TooltipProps.open = true;
  const label = name !== undefined ? name : label_;
  return /*#__PURE__*/React.createElement(Component, {
    ref: ref,
    className: classNames([staticClassName('SpeedDialItem', theme) && [`amaui-SpeedDialItem-root`], className, classes.root, !is('function', render) && classes.no_render])
  }, is('function', render) ? render(_objectSpread({
    onBlur,
    onFocus,
    TooltipProps
  }, other)) : /*#__PURE__*/React.createElement(Tooltip, _extends({
    label: label,
    portal: false,
    nowrap: true
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, _extends({
    onBlur: onBlur,
    onFocus: onFocus
  }, other), /*#__PURE__*/React.createElement(Icon, null))));
});
SpeedDialItem.displayName = 'amaui-SpeedDialItem';
export default SpeedDialItem;