import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["tonal", "color", "size", "elevation", "header", "footer", "WrapperComponentProps", "TableComponent", "WrapperComponent", "Component", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import SurfaceElement from '../Surface';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: _objectSpread({
    borderRadius: `${theme.shape.radius.unit * 2}px`,
    overflow: 'hidden'
  }, theme.typography.values.b2),
  table: {
    display: 'table',
    width: '100%',
    borderCollapse: 'collapse',
    borderSpacing: '0px',
    background: 'inherit'
  },
  wrapper: {
    overflowX: 'auto',
    background: 'inherit'
  }
}), {
  name: 'amaui-Table'
});
const Table = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiTable?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const {
      tonal = true,
      color = 'themed',
      size = 'regular',
      elevation = 1,
      header,
      footer,
      WrapperComponentProps,
      TableComponent = 'table',
      WrapperComponent = 'div',
      Component = 'div',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: 0,
    direction: "column",
    align: "unset",
    justify: "unset",
    fullWidth: true,
    tonal: tonal,
    color: color,
    elevation: elevation,
    Component: Surface,
    AdditionalProps: {
      Component
    },
    className: classNames([staticClassName('Table', theme) && [`amaui-Table-root`], className, classes.root])
  }, other), header && /*#__PURE__*/React.cloneElement(header, {
    tonal: header.props.tonal !== undefined ? header.props.tonal : tonal,
    color: header.props.color !== undefined ? header.props.color : color,
    size: header.props.size !== undefined ? header.props.size : size
  }), /*#__PURE__*/React.createElement(WrapperComponent, _extends({}, WrapperComponentProps, {
    className: classNames([staticClassName('Table', theme) && [`amaui-Table-wrapper`], WrapperComponentProps?.className, classes.wrapper])
  }), /*#__PURE__*/React.createElement(TableComponent, {
    className: classNames([staticClassName('Table', theme) && [`amaui-Table-table`, header && `amaui-Table-header`, footer && `amaui-Table-footer`], classes.table])
  }, React.Children.toArray(children).map(item => /*#__PURE__*/React.cloneElement(item, {
    tonal: item.props.tonal !== undefined ? item.props.tonal : tonal,
    color: item.props.color !== undefined ? item.props.color : color,
    size: item.props.size !== undefined ? item.props.size : size
  })))), footer && /*#__PURE__*/React.cloneElement(footer, {
    tonal: footer.props.tonal !== undefined ? footer.props.tonal : tonal,
    color: footer.props.color !== undefined ? footer.props.color : color,
    size: footer.props.size !== undefined ? footer.props.size : size
  }));
});
Table.displayName = 'amaui-Table';
export default Table;