import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["orientation", "start", "end", "DividerProps", "IconProps", "Icon", "Divider", "Component", "className", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import SurfaceElement from '../Surface';
import DividerElement from '../Divider';
import LineElement from '../Line';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    '&:last-of-type': {
      '& $divider': {
        display: 'none'
      }
    }
  },
  orientation_vertical: {
    minHeight: '77px'
  },
  orientation_horizontal: {
    minWidth: '114px'
  },
  icon: {
    display: 'inline-block',
    width: '12px',
    height: '12px',
    borderRadius: theme.methods.shape.radius.value(40, 'px')
  },
  aside_orientation_vertical: {
    padding: `${theme.methods.space.value(0.5, 'px')} ${theme.methods.space.value(3, 'px')}`
  },
  aside_orientation_horizontal: {
    padding: `${theme.methods.space.value(3, 'px')} ${theme.methods.space.value(0.5, 'px')}`
  },
  iconWrapper: {
    lineHeight: '0'
  },
  iconWrapper_orientation_vertical: {
    marginBlock: '8px'
  },
  iconWrapper_orientation_horizontal: {
    marginInline: '8px'
  },
  divider: {
    '&.amaui-Divider-root': {
      margin: '0px'
    }
  },
  divider_orientation_vertical: {
    '&.amaui-Divider-root': {
      width: '2px'
    }
  },
  divider_orientation_horizontal: {
    '&.amaui-Divider-root': {
      height: '2px'
    }
  }
}), {
  name: 'amaui-TimelineItem'
});
const TimelineItem = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiTimelineItem?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const Divider = React.useMemo(() => theme?.elements?.Divider || DividerElement, [theme]);
  const {
      orientation = 'vertical',
      start,
      end,
      DividerProps: DividerProps_ = !props.Divider ? {
        tonal: 'secondary',
        color: 'neutral'
      } : undefined,
      IconProps = !props.Icon ? {
        tonal: 'secondary',
        color: 'neutral',
        version: 'filled'
      } : undefined,
      Icon,
      Divider: Divider_,
      Component = 'li',
      className,
      children
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const direction = orientation === 'vertical' ? 'row' : 'column';
  const lineDirection = orientation === 'vertical' ? 'column' : 'row';
  const DividerProps = _objectSpread({}, DividerProps_);
  if (!Divider_) {
    DividerProps.orientation = orientation;
  }
  return /*#__PURE__*/React.createElement(Line, _extends({
    ref: ref,
    gap: 0,
    align: "unset",
    justify: "unset",
    direction: direction,
    Component: Component,
    className: classNames([staticClassName('TimelineItem', theme) && ['amaui-TimelineItem-root'], className, classes.root, classes[`orientation_${orientation}`]])
  }, other), start && /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('TimelineItem', theme) && ['amaui-TimelineItem-aside', 'amaui-TimelineItem-item', 'amaui-TimelineItem-start'], classes.aside, classes.item, classes.start, classes[`aside_orientation_${orientation}`]])
  }, start), /*#__PURE__*/React.createElement(Line, {
    gap: 0,
    direction: lineDirection,
    align: "center",
    justify: "flex-start",
    className: classNames([staticClassName('TimelineItem', theme) && ['amaui-TimelineItem-item', 'amaui-TimelineItem-middle'], classes.item, classes.middle])
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('TimelineItem', theme) && ['amaui-TimelineItem-icon-wrapper'], classes.iconWrapper, classes[`iconWrapper_orientation_${orientation}`]])
  }, Icon ? Icon : /*#__PURE__*/React.createElement(Surface, _extends({}, IconProps, {
    className: classNames([staticClassName('TimelineItem', theme) && ['amaui-TimelineItem-icon'], IconProps?.className, classes.icon])
  }))), Divider_ ? Divider_ : /*#__PURE__*/React.createElement(Divider, _extends({}, DividerProps, {
    className: classNames([staticClassName('TimelineItem', theme) && ['amaui-TimelineItem-divider'], DividerProps?.className, classes.divider, classes[`divider_orientation_${orientation}`]]),
    flex: true
  }))), (end || children) && /*#__PURE__*/React.createElement("div", {
    className: classNames([staticClassName('TimelineItem', theme) && ['amaui-TimelineItem-aside', 'amaui-TimelineItem-item', 'amaui-TimelineItem-end'], classes.aside, classes.item, classes.end, classes[`aside_orientation_${orientation}`]])
  }, end || children));
});
TimelineItem.displayName = 'amaui-TimelineItem';
export default TimelineItem;