import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
const _excluded = ["tonal", "color", "renderValue", "icon", "onStart", "onFlag", "onPause", "onStop", "onResume", "Icon", "IconStart", "IconPause", "IconFlag", "IconStop", "TreeProps", "TooltipProps", "IconButtonProps", "IconProps", "Component", "className"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is, getLeadingZerosNumber } from '@amaui/utils';
import { AmauiDate, duration } from '@amaui/date';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import FadeElement from '../Fade';
import ExpandElement from '../Expand';
import TypeElement from '../Type';
import TooltipElement from '../Tooltip';
import TreeElement from '../Tree';
import SurfaceElement from '../Surface';
import LineElement from '../Line';
import IconButtonElement from '../IconButton';
import IconElement from '../Icon';
import { staticClassName } from '../utils';
const IconMaterialTimerRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "TimerRounded",
    short_name: "Timer"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M10 3Q9.575 3 9.288 2.712Q9 2.425 9 2Q9 1.575 9.288 1.287Q9.575 1 10 1H14Q14.425 1 14.713 1.287Q15 1.575 15 2Q15 2.425 14.713 2.712Q14.425 3 14 3ZM12 14Q12.425 14 12.713 13.712Q13 13.425 13 13V9Q13 8.575 12.713 8.287Q12.425 8 12 8Q11.575 8 11.288 8.287Q11 8.575 11 9V13Q11 13.425 11.288 13.712Q11.575 14 12 14ZM12 22Q10.15 22 8.512 21.288Q6.875 20.575 5.65 19.35Q4.425 18.125 3.712 16.488Q3 14.85 3 13Q3 11.15 3.712 9.512Q4.425 7.875 5.65 6.65Q6.875 5.425 8.512 4.713Q10.15 4 12 4Q13.55 4 14.975 4.5Q16.4 5 17.65 5.95L18.375 5.225Q18.65 4.95 19.05 4.95Q19.45 4.95 19.75 5.25Q20.025 5.525 20.025 5.95Q20.025 6.375 19.75 6.65L19.05 7.35Q20 8.6 20.5 10.025Q21 11.45 21 13Q21 14.85 20.288 16.488Q19.575 18.125 18.35 19.35Q17.125 20.575 15.488 21.288Q13.85 22 12 22ZM12 20Q14.9 20 16.95 17.95Q19 15.9 19 13Q19 10.1 16.95 8.05Q14.9 6 12 6Q9.1 6 7.05 8.05Q5 10.1 5 13Q5 15.9 7.05 17.95Q9.1 20 12 20ZM12 13Q12 13 12 13Q12 13 12 13Q12 13 12 13Q12 13 12 13Q12 13 12 13Q12 13 12 13Q12 13 12 13Q12 13 12 13Z"
  }));
});
const IconMaterialPlayArrowRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "PlayArrowRounded",
    short_name: "PlayArrow"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M9.525 18.025Q9.025 18.35 8.512 18.062Q8 17.775 8 17.175V6.825Q8 6.225 8.512 5.937Q9.025 5.65 9.525 5.975L17.675 11.15Q18.125 11.45 18.125 12Q18.125 12.55 17.675 12.85ZM10 12ZM10 15.35 15.25 12 10 8.65Z"
  }));
});
const IconMaterialPauseRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "PauseRounded",
    short_name: "Pause"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M15 19Q14.175 19 13.588 18.413Q13 17.825 13 17V7Q13 6.175 13.588 5.588Q14.175 5 15 5H17Q17.825 5 18.413 5.588Q19 6.175 19 7V17Q19 17.825 18.413 18.413Q17.825 19 17 19ZM7 19Q6.175 19 5.588 18.413Q5 17.825 5 17V7Q5 6.175 5.588 5.588Q6.175 5 7 5H9Q9.825 5 10.413 5.588Q11 6.175 11 7V17Q11 17.825 10.413 18.413Q9.825 19 9 19ZM15 17H17V7H15ZM7 17H9V7H7ZM7 7V17ZM15 7V17Z"
  }));
});
const IconMaterialStopRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "StopRounded",
    short_name: "Stop"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M8 8V16ZM8 18Q7.175 18 6.588 17.413Q6 16.825 6 16V8Q6 7.175 6.588 6.588Q7.175 6 8 6H16Q16.825 6 17.413 6.588Q18 7.175 18 8V16Q18 16.825 17.413 17.413Q16.825 18 16 18ZM8 16H16V8H8Z"
  }));
});
const IconMaterialFlagRounded = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconElement, _extends({
    ref: ref,
    name: "FlagRounded",
    short_name: "Flag"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M6 21Q5.575 21 5.287 20.712Q5 20.425 5 20V5Q5 4.575 5.287 4.287Q5.575 4 6 4H13.175Q13.525 4 13.8 4.225Q14.075 4.45 14.15 4.8L14.4 6H19Q19.425 6 19.712 6.287Q20 6.575 20 7V15Q20 15.425 19.712 15.712Q19.425 16 19 16H13.825Q13.475 16 13.2 15.775Q12.925 15.55 12.85 15.2L12.6 14H7V20Q7 20.425 6.713 20.712Q6.425 21 6 21ZM12.5 10ZM14.65 14H18V8H12.75L12.35 6H7V12H14.25Z"
  }));
});
const useStyle = styleMethod(theme => ({
  root: {
    minWidth: '300px',
    padding: `${theme.methods.space.value(3, 'px')} ${theme.methods.space.value(5, 'px')}`,
    borderRadius: theme.methods.shape.radius.value('rg', 'px')
  },
  value: {
    marginTop: '8px'
  },
  flags_wrapper: {
    width: '100%',
    paddingTop: theme.methods.space.value(1, 'px')
  },
  flags: {
    width: '100%',
    maxHeight: '170px',
    overflowY: 'auto'
  },
  flag: {
    width: '100%',
    paddingInlineStart: theme.methods.space.value(0.5, 'px')
  },
  actions: {
    marginTop: '8px'
  }
}), {
  name: 'amaui-Timer'
});
const Timer = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiTimer?.props?.default), props_), [props_]);
  const Line = React.useMemo(() => theme?.elements?.Line || LineElement, [theme]);
  const Fade = React.useMemo(() => theme?.elements?.Fade || FadeElement, [theme]);
  const Type = React.useMemo(() => theme?.elements?.Type || TypeElement, [theme]);
  const Expand = React.useMemo(() => theme?.elements?.Expand || ExpandElement, [theme]);
  const Tooltip = React.useMemo(() => theme?.elements?.Tooltip || TooltipElement, [theme]);
  const Tree = React.useMemo(() => theme?.elements?.Tree || TreeElement, [theme]);
  const Surface = React.useMemo(() => theme?.elements?.Surface || SurfaceElement, [theme]);
  const IconButton = React.useMemo(() => theme?.elements?.IconButton || IconButtonElement, [theme]);
  const {
      tonal = true,
      color = 'primary',
      renderValue,
      icon = true,
      onStart: onStart_,
      onFlag: onFlag_,
      onPause: onPause_,
      onStop: onStop_,
      onResume: onResume_,
      Icon: Icon_ = IconMaterialTimerRounded,
      IconStart = IconMaterialPlayArrowRounded,
      IconPause = IconMaterialPauseRounded,
      IconFlag = IconMaterialFlagRounded,
      IconStop = IconMaterialStopRounded,
      TreeProps: TreeProps_,
      TooltipProps: TooltipProps_,
      IconButtonProps: IconButtonProps_,
      IconProps: IconProps_,
      Component = 'div',
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  const [status, setStatus] = React.useState('initial');
  const [flags, setFlags] = React.useState([]);
  const [expand, setExpand] = React.useState();
  const [value, setValue] = React.useState(0);
  const refs = {
    root: React.useRef(),
    start: React.useRef(0),
    valuePaused: React.useRef(0),
    value: React.useRef(),
    animationFrame: React.useRef()
  };
  refs.value.current = value;
  const clear = () => {
    cancelAnimationFrame(refs.animationFrame.current);
  };
  React.useEffect(() => {
    return () => {
      // Clean up
      clear();
    };
  }, []);
  const update = () => {
    setValue(refs.valuePaused.current + (AmauiDate.milliseconds - refs.start.current));
    refs.animationFrame.current = requestAnimationFrame(update);
  };
  const onStart = React.useCallback(event => {
    refs.start.current = AmauiDate.milliseconds;

    // ~60+ fps
    refs.animationFrame.current = requestAnimationFrame(update);
    setStatus('running');
    if (is('function', onStart_)) onStart_(event);
  }, []);
  const onFlag = React.useCallback(event => {
    if (!expand) setExpand(true);
    setFlags(values => [...values, refs.value.current]);
    if (is('function', onFlag_)) onFlag_(event);
  }, [expand]);
  const onPause = React.useCallback(event => {
    clear();

    // Remember previous value
    refs.valuePaused.current = refs.value.current;
    setStatus('paused');
    if (is('function', onPause_)) onPause_(event);
  }, []);
  const onStop = React.useCallback(event => {
    clear();
    setStatus('initial');
    setExpand(false);
    setValue(0);
    refs.start.current = 0;
    refs.valuePaused.current = 0;
    refs.value.current = 0;
    if (is('function', onStop_)) onStop_(event);
  }, []);
  const onResume = React.useCallback(event => {
    // ~60+ fps
    refs.animationFrame.current = requestAnimationFrame(update);

    // Update start, valuePaused value
    refs.start.current = AmauiDate.milliseconds;
    setStatus('running');
    if (is('function', onResume_)) onResume_(event);
  }, []);
  const onExited = React.useCallback(() => {
    setFlags([]);
  }, []);
  const IconProps = _objectSpread({}, IconProps_);
  const TooltipProps = _objectSpread({
    portal: true,
    interactive: false
  }, TooltipProps_);
  const TreeProps = _objectSpread({
    tonal,
    color: 'inherit'
  }, TreeProps_);
  const IconButtonProps = _objectSpread({
    tonal,
    color: 'inherit',
    version: 'text'
  }, IconButtonProps_);
  const valueFormat = valueNew_ => {
    let valueNew = '';
    const valueDuration = duration(valueNew_, undefined, true, undefined, ['hour', 'minute', 'second', 'millisecond']);
    if (valueDuration.hour > 0) valueNew += `${getLeadingZerosNumber(valueDuration.hour)}:`;
    valueNew += `${getLeadingZerosNumber(valueDuration.minute || 0)}:`;
    valueNew += `${getLeadingZerosNumber(valueDuration.second || 0)}.`;
    valueNew += `${getLeadingZerosNumber(Math.floor((valueDuration.millisecond || 0) / 10))}`;
    return valueNew;
  };
  const value_ = status === 'initial' ? '00:00.00' : valueFormat(value);
  return /*#__PURE__*/React.createElement(Surface, _extends({
    ref: item => {
      if (ref) {
        if (is('function', ref)) ref(item);else if (ref?.current) ref.current = item;
      }
      refs.root.current = item;
    },
    tonal: tonal,
    color: color,
    gap: 0,
    direction: "column",
    align: "center",
    Component: Line,
    AdditionalProps: {
      Component
    },
    className: classNames([staticClassName('Timer', theme) && ['amaui-Timer-root'], className, classes.root])
  }, other), icon && /*#__PURE__*/React.createElement(Icon_, _extends({
    size: "medium"
  }, IconProps, {
    style: _objectSpread({
      marginBottom: 4
    }, IconProps?.style)
  })), is('function', renderValue) ? renderValue(value_) : /*#__PURE__*/React.createElement(Type, {
    version: "h1",
    className: classNames([staticClassName('Timer', theme) && ['amaui-Timer-value'], classes.value])
  }, value_), /*#__PURE__*/React.createElement(Expand, {
    in: expand,
    parent: refs.root.current,
    onExited: onExited,
    className: classNames([staticClassName('Timer', theme) && ['amaui-Timer-flags-wrapper'], classes.flags_wrapper])
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Surface, {
    tonal: tonal,
    color: color
  }, _ref => {
    let {
      palette
    } = _ref;
    return /*#__PURE__*/React.createElement(Tree, _extends({
      openDefault: true,
      middle: "Flags",
      indicator: true,
      indicatorPosition: "end",
      parent: refs.root.current,
      TreeProps: {
        className: classNames([staticClassName('Timer', theme) && ['amaui-Timer-flags'], classes.flags])
      }
    }, TreeProps), flags.map((item, index) => /*#__PURE__*/React.createElement(Tree, _extends({
      key: index,
      icon: /*#__PURE__*/React.createElement(IconFlag, {
        size: "small",
        color: palette[40]
      }),
      middle: /*#__PURE__*/React.createElement(Line, {
        direction: "row",
        align: "center",
        justify: "space-between",
        className: classNames([classes.flag])
      }, /*#__PURE__*/React.createElement(Type, {
        version: "b2"
      }, getLeadingZerosNumber(index + 1)), /*#__PURE__*/React.createElement(Type, {
        version: "b2",
        style: {
          opacity: '0.7'
        }
      }, "+", valueFormat(item - (flags[index - 1] || 0))), /*#__PURE__*/React.createElement(Type, {
        version: "b2"
      }, valueFormat(item))),
      noPadding: true,
      indicator: true,
      indicatorPosition: "end"
    }, TreeProps))));
  }))), /*#__PURE__*/React.createElement(Line, {
    gap: 1,
    direction: "row",
    align: "center",
    justify: "center",
    className: classNames([staticClassName('Timer', theme) && ['amaui-Timer-actions'], classes.actions])
  }, status === 'initial' && /*#__PURE__*/React.createElement(Fade, {
    in: true,
    add: true
  }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Tooltip, _extends({
    label: "Start"
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, _extends({
    onClick: onStart
  }, IconButtonProps), /*#__PURE__*/React.createElement(IconStart, null))))), status === 'running' && /*#__PURE__*/React.createElement(Fade, {
    in: true,
    add: true
  }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Tooltip, _extends({
    label: "Flag"
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, _extends({
    onClick: onFlag
  }, IconButtonProps), /*#__PURE__*/React.createElement(IconFlag, null))), /*#__PURE__*/React.createElement(Tooltip, _extends({
    label: "Pause"
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, _extends({
    onClick: onPause
  }, IconButtonProps), /*#__PURE__*/React.createElement(IconPause, null))))), status === 'paused' && /*#__PURE__*/React.createElement(Fade, {
    in: true,
    add: true
  }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Tooltip, _extends({
    label: "Stop"
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, _extends({
    onClick: onStop
  }, IconButtonProps), /*#__PURE__*/React.createElement(IconStop, null))), /*#__PURE__*/React.createElement(Tooltip, _extends({
    label: "Resume"
  }, TooltipProps), /*#__PURE__*/React.createElement(IconButton, _extends({
    onClick: onResume
  }, IconButtonProps), /*#__PURE__*/React.createElement(IconStart, null)))))));
});
Timer.displayName = 'amaui-Timer';
export default Timer;