import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
const _excluded = ["size", "icon", "className"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { classNames, style as styleMethod, useAmauiTheme } from '@amaui/style-react';
import ChipElement from '../Chip';
import { staticClassName } from '../utils';
const useStyle = styleMethod(theme => ({
  root: {
    '&.amaui-Chip-root': {
      width: 'unset'
    }
  },
  size_small: {
    '&.amaui-Button-root': {
      padding: `${theme.methods.space.value(0.5, 'px')} ${theme.methods.space.value(0.75, 'px')}`
    }
  },
  size_regular: {
    '&.amaui-Button-root': {
      padding: `${theme.methods.space.value(1, 'px')} ${theme.methods.space.value(1, 'px')}`
    }
  },
  size_large: {
    '&.amaui-Button-root': {
      padding: `${theme.methods.space.value(1.5, 'px')} ${theme.methods.space.value(1.25, 'px')}`
    }
  }
}), {
  name: 'amaui-ToggleButton'
});
const ToggleButton = /*#__PURE__*/React.forwardRef((props_, ref) => {
  const theme = useAmauiTheme();
  const props = React.useMemo(() => _objectSpread(_objectSpread(_objectSpread({}, theme?.ui?.elements?.all?.props?.default), theme?.ui?.elements?.amauiToggleButton?.props?.default), props_), [props_]);
  const Chip = React.useMemo(() => theme?.elements?.Chip || ChipElement, [theme]);
  const {
      size,
      icon = true,
      className
    } = props,
    other = _objectWithoutProperties(props, _excluded);
  const {
    classes
  } = useStyle();
  return /*#__PURE__*/React.createElement(Chip, _extends({
    ref: ref,
    size: size,
    icon: icon,
    noCheckIcon: true,
    className: classNames([staticClassName('ToggleButton', theme) && ['amaui-ToggleButton-root'], className, classes.root, classes[`size_${size}`]])
  }, other));
});
ToggleButton.displayName = 'amaui-ToggleButton';
export default ToggleButton;