import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { is } from '@amaui/utils';
const useSubscription = (amauiSubscription, method, value) => {
  // an array of the value
  // we are getting the same reference value
  // from some of the subscriptions
  // in order for rerender to be made
  const [response, setResponse] = React.useState([value !== undefined ? value : amauiSubscription?.value]);
  React.useEffect(() => {
    if (value !== undefined) {
      if (is('function', amauiSubscription.init)) amauiSubscription.init(_objectSpread(_objectSpread({}, value), {}, {
        loaded: true
      }));
    }
  }, []);
  React.useEffect(() => {
    const subscription = amauiSubscription?.subscribe(async valueItem => {
      if (is('function', method)) await method(valueItem, setResponse);else setResponse([valueItem]);
    });
    return () => {
      subscription.unsubscribe();
    };
  }, [amauiSubscription]);
  return response[0];
};
export default useSubscription;