"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.caret = exports.keyboardStyleCommands = exports.keyboardStandardCommands = exports.getOverflowParent = exports.importIframeStyles = exports.replace = exports.sanitize = exports.minMaxBetweenNumbers = exports.controlPoint = exports.line = exports.angleToCoordinates = exports.matches = exports.save = exports.print = exports.canvasOldPhoto = exports.canvasInvert = exports.canvasFade = exports.canvasSaturation = exports.canvasContrast = exports.canvasBrightness = exports.image = exports.valueBreakpoints = exports.iconSizeToFontSize = exports.staticClassName = exports.reflow = void 0;
const utils_1 = require("@amaui/utils");
function reflow(element) {
    element === null || element === void 0 ? void 0 : element.offsetHeight;
}
exports.reflow = reflow;
const staticClassName = (name, theme) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return ((_d = (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _a === void 0 ? void 0 : _a.elements) === null || _b === void 0 ? void 0 : _b[`amaui-${name}`]) === null || _c === void 0 ? void 0 : _c.className) === null || _d === void 0 ? void 0 : _d.static) !== undefined ? (_h = (_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _e === void 0 ? void 0 : _e.elements) === null || _f === void 0 ? void 0 : _f[`amaui-${name}`]) === null || _g === void 0 ? void 0 : _g.className) === null || _h === void 0 ? void 0 : _h.static : (_j = theme === null || theme === void 0 ? void 0 : theme.ui) === null || _j === void 0 ? void 0 : _j.className.static;
};
exports.staticClassName = staticClassName;
const iconSizeToFontSize = (value) => {
    let fontSize = '1.5rem';
    if (value === 'very small')
        fontSize = '0.75rem';
    else if (value === 'small')
        fontSize = '1.125rem';
    else if (value === 'regular')
        fontSize = '1.5rem';
    else if (value === 'medium')
        fontSize = '1.875rem';
    else if (value === 'large')
        fontSize = '2.25rem';
    else if (value === 'very large')
        fontSize = '2.625rem';
    else if (value !== undefined)
        fontSize = value;
    return fontSize;
};
exports.iconSizeToFontSize = iconSizeToFontSize;
// Media query value or value
const valueBreakpoints = (item, value, breakpoints, theme) => {
    // Simple
    if (!(0, utils_1.is)('object', item) && item !== undefined)
        return item;
    // No breakpoints object
    if ((0, utils_1.is)('object', item) && !Object.keys(item).every(prop => ['default', ...theme.breakpoints.keys].includes(prop)))
        return item;
    // Item
    if ((0, utils_1.is)('object', item)) {
        for (const breakpoint of theme.breakpoints.keys) {
            if (breakpoints[breakpoint] && (item === null || item === void 0 ? void 0 : item[breakpoint]) !== undefined)
                return item[breakpoint];
        }
        if ((item === null || item === void 0 ? void 0 : item.default) !== undefined)
            return item === null || item === void 0 ? void 0 : item.default;
    }
    // Value
    if ((0, utils_1.is)('object', value)) {
        for (const breakpoint of theme.breakpoints.keys) {
            if (breakpoints[breakpoint] && (value === null || value === void 0 ? void 0 : value[breakpoint]) !== undefined)
                return value[breakpoint];
        }
        if ((value === null || value === void 0 ? void 0 : value.default) !== undefined)
            return value === null || value === void 0 ? void 0 : value.default;
    }
    return value;
};
exports.valueBreakpoints = valueBreakpoints;
const image = (uri) => new Promise((resolve, reject) => {
    const img = document.createElement('img');
    const method = () => resolve(img);
    img.onload = method;
    img.onerror = () => resolve('');
    img.src = uri;
});
exports.image = image;
const canvasBrightness = (value, mainCanvas, valueCopy) => {
    const rootDocument = (mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.ownerDocument) || window.document;
    const canvas = rootDocument.createElement('canvas');
    canvas.width = valueCopy.width;
    canvas.height = valueCopy.height;
    const context = canvas.getContext('2d');
    context.drawImage(valueCopy, 0, 0);
    if (![0, undefined].includes(value))
        (0, utils_1.canvasFilterBrightness)(value, canvas);
    mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.getContext('2d').drawImage(canvas, 0, 0, canvas.width, canvas.height);
    return canvas;
};
exports.canvasBrightness = canvasBrightness;
const canvasContrast = (value, mainCanvas, valueCopy) => {
    const rootDocument = (mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.ownerDocument) || window.document;
    const canvas = rootDocument.createElement('canvas');
    canvas.width = valueCopy.width;
    canvas.height = valueCopy.height;
    const context = canvas.getContext('2d');
    context.drawImage(valueCopy, 0, 0);
    if (![0, undefined].includes(value))
        (0, utils_1.canvasFilterContrast)(value, canvas);
    mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.getContext('2d').drawImage(canvas, 0, 0, canvas.width, canvas.height);
    return canvas;
};
exports.canvasContrast = canvasContrast;
const canvasSaturation = (value, mainCanvas, valueCopy) => {
    const rootDocument = (mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.ownerDocument) || window.document;
    const canvas = rootDocument.createElement('canvas');
    canvas.width = valueCopy.width;
    canvas.height = valueCopy.height;
    const context = canvas.getContext('2d');
    context.drawImage(valueCopy, 0, 0);
    if (![0, undefined].includes(value))
        (0, utils_1.canvasFilterSaturation)(value, canvas);
    mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.getContext('2d').drawImage(canvas, 0, 0, canvas.width, canvas.height);
    return canvas;
};
exports.canvasSaturation = canvasSaturation;
const canvasFade = (value, mainCanvas, valueCopy) => {
    const rootDocument = (mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.ownerDocument) || window.document;
    const canvas = rootDocument.createElement('canvas');
    canvas.width = valueCopy.width;
    canvas.height = valueCopy.height;
    const context = canvas.getContext('2d');
    context.drawImage(valueCopy, 0, 0);
    if (![0, undefined].includes(value))
        (0, utils_1.canvasFilterFade)(value, canvas);
    mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.getContext('2d').drawImage(canvas, 0, 0, canvas.width, canvas.height);
    return canvas;
};
exports.canvasFade = canvasFade;
const canvasInvert = (value, mainCanvas, valueCopy) => {
    const rootDocument = (mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.ownerDocument) || window.document;
    const canvas = rootDocument.createElement('canvas');
    canvas.width = valueCopy.width;
    canvas.height = valueCopy.height;
    const context = canvas.getContext('2d');
    context.drawImage(valueCopy, 0, 0);
    if (![0, undefined].includes(value))
        (0, utils_1.canvasFilterInvert)(value, canvas);
    mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.getContext('2d').drawImage(canvas, 0, 0, canvas.width, canvas.height);
    return canvas;
};
exports.canvasInvert = canvasInvert;
const canvasOldPhoto = (value, mainCanvas, valueCopy) => {
    const rootDocument = (mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.ownerDocument) || window.document;
    const canvas = rootDocument.createElement('canvas');
    canvas.width = valueCopy.width;
    canvas.height = valueCopy.height;
    const context = canvas.getContext('2d');
    context.drawImage(valueCopy, 0, 0);
    if (![0, undefined].includes(value))
        (0, utils_1.canvasFilterOldPhoto)(value, canvas);
    mainCanvas === null || mainCanvas === void 0 ? void 0 : mainCanvas.getContext('2d').drawImage(canvas, 0, 0, canvas.width, canvas.height);
    return canvas;
};
exports.canvasOldPhoto = canvasOldPhoto;
const print = (element) => {
    const rootDocument = (element === null || element === void 0 ? void 0 : element.ownerDocument) || window.document;
    const clone = rootDocument.cloneNode(true);
    clone.body.innerHTML = '';
    const elementClone = element.cloneNode(true);
    clone.body.append(elementClone);
    const windowNew = window.open('', 'print');
    windowNew.document.head.innerHTML = clone.head.innerHTML;
    windowNew.document.body.innerHTML = clone.body.innerHTML;
    windowNew.document.close();
    windowNew.focus();
    windowNew.print();
    windowNew.close();
};
exports.print = print;
const save = (element) => {
    const rootDocument = (element === null || element === void 0 ? void 0 : element.ownerDocument) || window.document;
    const clone = rootDocument.cloneNode(true);
    clone.body.innerHTML = '';
    const elementClone = element.cloneNode(true);
    elementClone.contentEditable = 'false';
    clone.body.append(elementClone);
    (0, utils_1.download)(`${rootDocument.title}.html`, clone.documentElement.innerHTML, 'text/html');
};
exports.save = save;
const matches = (value) => {
    const method = (0, utils_1.is)('element', value) && (value.matches || value['webkitMatchesSelector'] || value['mozMatchesSelector'] || value['oMatchesSelector'] || value['msMatchesSelector']);
    if (!method)
        return () => false;
    return method.bind(value);
};
exports.matches = matches;
const angleToCoordinates = (degrees, centerX, centerY, radius) => {
    const radians = (degrees * Math.PI) / 180;
    return {
        x: centerX + (radius * Math.cos(radians)),
        y: centerY + (radius * Math.sin(radians))
    };
};
exports.angleToCoordinates = angleToCoordinates;
const line = (pointA, pointB) => {
    const lengthX = pointB[0] - pointA[0];
    const lengthY = pointB[1] - pointA[1];
    return {
        length: Math.sqrt(Math.pow(lengthX, 2) + Math.pow(lengthY, 2)),
        angle: Math.atan2(lengthY, lengthX)
    };
};
exports.line = line;
const controlPoint = (current, previous_, next_, reverse = false, smoothRatio = 0.14) => {
    const previous = previous_ || current;
    const next = next_ || current;
    const opposed = (0, exports.line)(previous, next);
    const angle = opposed.angle + (reverse ? Math.PI : 0);
    const length = opposed.length * smoothRatio;
    // Bug fix, prevent ties if x are the same
    // for previous, and current value
    const x = (0, utils_1.clamp)(current[0] + Math.cos(angle) * length, previous[0], next[0]);
    const y = current[1] + Math.sin(angle) * length;
    return [x, y];
};
exports.controlPoint = controlPoint;
const minMaxBetweenNumbers = (value = 10, min = 0, max = 100) => {
    const part = (max - min) / (value - 1);
    const values = [min];
    for (let i = 0; i < (value - 2); i++)
        values.push(values[values.length - 1] + part);
    values.push(max);
    return values;
};
exports.minMaxBetweenNumbers = minMaxBetweenNumbers;
const sanitize = (value) => {
    if (value) {
        const map = {
            '&': '&amp;',
            '<': '&lt;',
            '>': '&gt;',
            '"': '&quot;',
            "'": '&#x27;',
            "/": '&#x2F;',
            "\\": '&#x5c;',
            '*': '&#x2a',
        };
        const reg = /[&<>"'/\\*]/ig;
        return value.replace(reg, (match) => (map[match]));
    }
};
exports.sanitize = sanitize;
const replace = (value, split, join) => {
    return value.split(split).join(join);
};
exports.replace = replace;
const importIframeStyles = (iframeDocument) => {
    var _a;
    const styleSheets = window.document.styleSheets;
    for (const styleSheet of Array.from(styleSheets)) {
        if (!styleSheet.ownerNode.amaui) {
            iframeDocument.head.append((_a = styleSheet.ownerNode) === null || _a === void 0 ? void 0 : _a.cloneNode(true));
            continue;
        }
        let css = '';
        const rules = styleSheet === null || styleSheet === void 0 ? void 0 : styleSheet.cssRules;
        for (const rule of Array.from(rules))
            css += rule.cssText;
        const style = window.document.createElement('style');
        style.innerHTML = css;
        iframeDocument.head.append(style);
    }
};
exports.importIframeStyles = importIframeStyles;
const getOverflowParent = (element) => {
    if (!element)
        return;
    if (element.scrollHeight > element.clientHeight)
        return element;
    return (0, exports.getOverflowParent)(element.parentElement);
};
exports.getOverflowParent = getOverflowParent;
exports.keyboardStandardCommands = ['a', 'c', 'v', 'y', 'z'];
exports.keyboardStyleCommands = ['b', 'i', 'u'];
exports.caret = {};
if ((0, utils_1.isEnvironment)('browser')) {
    if (window.getSelection && document.createRange) {
        // Saves caret position(s)
        exports.caret.save = function (container) {
            var _a;
            const selection = window.getSelection();
            if (!(selection && selection.rangeCount > 0))
                return;
            const range = (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.getRangeAt(0);
            if (!range)
                return;
            const preSelectionRange = range.cloneRange();
            preSelectionRange.selectNodeContents(container);
            preSelectionRange.setEnd(range.startContainer, range.startOffset);
            const start = preSelectionRange.toString().length;
            return {
                start: start,
                end: start + range.toString().length
            };
        };
        // Restores caret position(s)
        exports.caret.restore = function (container, savedElement) {
            let charIndex = 0;
            const range = document.createRange();
            range.setStart(container, 0);
            range.collapse(true);
            const nodeStack = [container];
            let node;
            let foundStart = false;
            let stop = false;
            // tslint:disable-next-line
            while (!stop && (node = nodeStack.pop())) {
                if (node.nodeType === 3) {
                    const nextCharIndex = charIndex + node.length;
                    if (!foundStart && savedElement.start >= charIndex && savedElement.start <= nextCharIndex) {
                        range.setStart(node, savedElement.start - charIndex);
                        foundStart = true;
                    }
                    if (foundStart && savedElement.end >= charIndex && savedElement.end <= nextCharIndex) {
                        range.setEnd(node, savedElement.end - charIndex);
                        stop = true;
                    }
                    charIndex = nextCharIndex;
                }
                else {
                    let i = node.childNodes.length;
                    while (i--) {
                        nodeStack.push(node.childNodes[i]);
                    }
                }
            }
            const selection = window.getSelection();
            selection === null || selection === void 0 ? void 0 : selection.removeAllRanges();
            selection === null || selection === void 0 ? void 0 : selection.addRange(range);
        };
    }
    else if (process.window && window.document.selection && window.document.body.createTextRange) {
        // Saves caret position(s)
        exports.caret.save = function (container) {
            const selectedTextRange = window.document.selection.createRange();
            const preSelectionTextRange = window.document.body.createTextRange();
            preSelectionTextRange.moveToElementText(container);
            preSelectionTextRange.setEndPoint("EndToStart", selectedTextRange);
            const start = preSelectionTextRange.text.length;
            return {
                start: start,
                end: start + selectedTextRange.text.length
            };
        };
        // Restores caret position(s)
        exports.caret.restore = function (container, savedElement) {
            const textRange = window.document.body.createTextRange();
            textRange.moveToElementText(container);
            textRange.collapse(true);
            textRange.moveEnd("character", savedElement.end);
            textRange.moveStart("character", savedElement.start);
            textRange.select();
        };
    }
}
